module.exports = function () {
    var JobCentreServic = require('../../services/admin/JobCentreService')
    // require('../utils/error.js')()
    var JobCentreServiceObject = new JobCentreServic()

    const STRINGS = require('../../strings.json')


    this.addOneJobFairPostController = async (req, callback) => {
        var response = {}
        try {
            var addOneJobFairService = await JobCentreServiceObject.addOneJobFairService(req)
            if (addOneJobFairService.error) {
                response.error = true
                response.statusCode = addOneJobFairService.statusCode
                response.message = addOneJobFairService.message
            } else {
                response.error = addOneJobFairService.error
                response.statusCode = addOneJobFairService.statusCode
                response.message = addOneJobFairService.message
                response.data = addOneJobFairService.data
            }
            callback(response)
        } catch (e) {
            // console.log(e)
            response.error = true
            response.statusCode = STRINGS.errorStatusCode
            response.message = STRINGS.oopsErrorMessage
            callback(response)
        }
    }


    this.getJobFairListController = async (req, callback) => {
        var response = {}
        try {
            var getJobFairListService = await JobCentreServiceObject.getJobFairListService(req)
            if (getJobFairListService.error) {
                response.error = true
                response.statusCode = getJobFairListService.statusCode
                response.message = getJobFairListService.message
            } else {
                response.error = getJobFairListService.error
                response.statusCode = getJobFairListService.statusCode
                response.totalPages = getJobFairListService.totalPages
                response.message = getJobFairListService.message
                response.data = getJobFairListService.data
            }
            callback(response)
        } catch (e) {
            // console.log(e)
            response.error = true
            response.statusCode = STRINGS.errorStatusCode
            response.message = STRINGS.oopsErrorMessage
            callback(response)
        }
    }

    this.viewOneJobFairController = async (req, callback) => {
        var response = {}
        try {
            var viewOneJobFairService = await JobCentreServiceObject.viewOneJobFairService(req)
            if (viewOneJobFairService.error) {
                response.error = true
                response.statusCode = viewOneJobFairService.statusCode
                response.message = viewOneJobFairService.message
            } else {
                response.error = viewOneJobFairService.error
                response.statusCode = viewOneJobFairService.statusCode
                response.message = viewOneJobFairService.message
                response.data = viewOneJobFairService.data
            }
            callback(response)
        } catch (e) {
            // console.log(e)
            response.error = true
            response.statusCode = STRINGS.errorStatusCode
            response.message = STRINGS.oopsErrorMessage
            callback(response)
        }
    }



    this.editOneJobFairController = async (req, callback) => {
        var response = {}
        try {
            var editOneSurveyService = await JobCentreServiceObject.editOneSurveyService(req)
            if (editOneSurveyService.error) {
                response.error = true
                response.statusCode = editOneSurveyService.statusCode
                response.message = editOneSurveyService.message
            } else {
                response.error = editOneSurveyService.error
                response.statusCode = editOneSurveyService.statusCode
                response.message = editOneSurveyService.message
                response.data = editOneSurveyService.data
            }
            callback(response)
        } catch (e) {
            // console.log(e)
            response.error = true
            response.statusCode = STRINGS.errorStatusCode
            response.message = STRINGS.oopsErrorMessage
            callback(response)
        }
    }



    this.deleteOneJobFairController = async (req, callback) => {
        var response = {}
        try {
            var deleteOneJobFairService = await JobCentreServiceObject.deleteOneJobFairService(req)
            if (deleteOneJobFairService.error) {
                response.error = true
                response.statusCode = deleteOneJobFairService.statusCode
                response.message = deleteOneJobFairService.message
            } else {
                response.error = deleteOneJobFairService.error
                response.statusCode = deleteOneJobFairService.statusCode
                response.message = deleteOneJobFairService.message
                response.data = deleteOneJobFairService.data
            }
            callback(response)
        } catch (e) {
            // console.log(e)
            response.error = true
            response.statusCode = STRINGS.errorStatusCode
            response.message = STRINGS.oopsErrorMessage
            callback(response)
        }
    }



    this.getALLSubscriptionListController = async (req, callback) => {
        var response = {}
        try {
            var getALLSubscriptionListService = await JobCentreServiceObject.getALLSubscriptionListService(req)
            if (getALLSubscriptionListService.error) {
                response.error = true
                response.statusCode = getALLSubscriptionListService.statusCode
                response.message = getALLSubscriptionListService.message
            } else {
                response.error = getALLSubscriptionListService.error
                response.statusCode = getALLSubscriptionListService.statusCode
                response.message = getALLSubscriptionListService.message
                response.totalPages = getALLSubscriptionListService.totalPages
                response.data = getALLSubscriptionListService.data
            }
            callback(response)
        } catch (e) {
            // console.log(e)
            response.error = true
            response.statusCode = STRINGS.errorStatusCode
            response.message = STRINGS.oopsErrorMessage
            callback(response)
        }
    }

    this.getOneSubscriptionController = async (req, callback) => {
        var response = {}
        try {
            var getOneSubscriptionService = await JobCentreServiceObject.getOneSubscriptionService(req)
            if (getOneSubscriptionService.error) {
                response.error = true
                response.statusCode = getOneSubscriptionService.statusCode
                response.message = getOneSubscriptionService.message
            } else {
                response.error = getOneSubscriptionService.error
                response.statusCode = getOneSubscriptionService.statusCode
                response.message = getOneSubscriptionService.message
                response.data = getOneSubscriptionService.data
            }
            callback(response)
        } catch (e) {
            // console.log(e)
            response.error = true
            response.statusCode = STRINGS.errorStatusCode
            response.message = STRINGS.oopsErrorMessage
            callback(response)
        }
    }
}