module.exports = function () {
    var goodVibesService = require('../../services/admin/goodVibesService')
    // require('../utils/error.js')()
    var goodVibesServiceObject = new goodVibesService()

    const STRINGS = require('../../strings.json')


    this.addOneGoodVibeController = async (req, callback) => {
        var response = {}
        try {
            var addOneGoodVibeService = await goodVibesServiceObject.addOneGoodVibeService(req)
            if (addOneGoodVibeService.error) {
                response.error = true
                response.statusCode = addOneGoodVibeService.statusCode
                response.message = addOneGoodVibeService.message
            } else {
                response.error = addOneGoodVibeService.error
                response.statusCode = addOneGoodVibeService.statusCode
                response.message = addOneGoodVibeService.message
                response.data = addOneGoodVibeService.data
            }
            callback(response)
        } catch (e) {
            // console.log(e)
            response.error = true
            response.statusCode = STRINGS.errorStatusCode
            response.message = STRINGS.oopsErrorMessage
            callback(response)
        }
    }


    this.getGoodVibesListController = async (req, callback) => {
        var response = {}
        try {
            var getGoodVibesListService = await goodVibesServiceObject.getGoodVibesListService(req)
            if (getGoodVibesListService.error) {
                response.error = true
                response.statusCode = getGoodVibesListService.statusCode
                response.message = getGoodVibesListService.message
            } else {
                response.error = getGoodVibesListService.error
                response.statusCode = getGoodVibesListService.statusCode
                response.totalPages = getGoodVibesListService.totalPages
                response.message = getGoodVibesListService.message
                response.data = getGoodVibesListService.data
            }
            callback(response)
        } catch (e) {
            // console.log(e)
            response.error = true
            response.statusCode = STRINGS.errorStatusCode
            response.message = STRINGS.oopsErrorMessage
            callback(response)
        }
    }

    this.viewOneGoodVibePostController = async (req, callback) => {
        var response = {}
        try {
            var viewOneGoodVibePostService = await goodVibesServiceObject.viewOneGoodVibePostService(req)
            if (viewOneGoodVibePostService.error) {
                response.error = true
                response.statusCode = viewOneGoodVibePostService.statusCode
                response.message = viewOneGoodVibePostService.message
            } else {
                response.error = viewOneGoodVibePostService.error
                response.statusCode = viewOneGoodVibePostService.statusCode
                response.message = viewOneGoodVibePostService.message
                response.data = viewOneGoodVibePostService.data
            }
            callback(response)
        } catch (e) {
            // console.log(e)
            response.error = true
            response.statusCode = STRINGS.errorStatusCode
            response.message = STRINGS.oopsErrorMessage
            callback(response)
        }
    }



    this.editOneGoodVibePostController = async (req, callback) => {
        var response = {}
        try {
            var editOneGoodVibePostService = await goodVibesServiceObject.editOneGoodVibePostService(req)
            if (editOneGoodVibePostService.error) {
                response.error = true
                response.statusCode = editOneGoodVibePostService.statusCode
                response.message = editOneGoodVibePostService.message
            } else {
                response.error = editOneGoodVibePostService.error
                response.statusCode = editOneGoodVibePostService.statusCode
                response.message = editOneGoodVibePostService.message
                response.data = editOneGoodVibePostService.data
            }
            callback(response)
        } catch (e) {
            // console.log(e)
            response.error = true
            response.statusCode = STRINGS.errorStatusCode
            response.message = STRINGS.oopsErrorMessage
            callback(response)
        }
    }



    this.deleteOneGoodVibeController = async (req, callback) => {
        var response = {}
        try {
            var deleteOneGoodVibeService = await goodVibesServiceObject.deleteOneGoodVibeService(req)
            if (deleteOneGoodVibeService.error) {
                response.error = true
                response.statusCode = deleteOneGoodVibeService.statusCode
                response.message = deleteOneGoodVibeService.message
            } else {
                response.error = deleteOneGoodVibeService.error
                response.statusCode = deleteOneGoodVibeService.statusCode
                response.message = deleteOneGoodVibeService.message
                response.data = deleteOneGoodVibeService.data
            }
            callback(response)
        } catch (e) {
            // console.log(e)
            response.error = true
            response.statusCode = STRINGS.errorStatusCode
            response.message = STRINGS.oopsErrorMessage
            callback(response)
        }
    }


}