module.exports = function (app) {
    const myProfile = require('../../services/web/MyProfileService')
    const myProfileServiceObject = new myProfile()
    const STRINGS = require('../../strings.json')


    this.addMyProfileController = async (req, callBack) => {
        const response = {}
        const addMyProfileService = await myProfileServiceObject.addMyProfileService(req)
        if (addMyProfileService.error) {
            response.error = true
            response.statusCode = addMyProfileService.statusCode
            response.message = addMyProfileService.message
        } else {
            response.error = addMyProfileService.error
            response.statusCode = addMyProfileService.statusCode
            response.message = addMyProfileService.message
            response.data = addMyProfileService.data
        }
        callBack(response)
    }

    this.getOneProfileController = async (req, callBack) => {
        const response = {}
        const getOneProfileService = await myProfileServiceObject.getOneProfileService(req)
        if (getOneProfileService.error) {
            response.error = true
            response.statusCode = getOneProfileService.statusCode
            response.message = getOneProfileService.message
        } else {
            response.error = getOneProfileService.error
            response.statusCode = getOneProfileService.statusCode
            response.message = getOneProfileService.message
            response.data = getOneProfileService.data
        }
        callBack(response)
    }
    this.editMyProfileController = async (req, callback) => {
        var response = {}
        try {
            var editMyProfileService = await myProfileServiceObject.editMyprofileService(req)
            if (editMyProfileService.error) {
                response.error = true
                response.statusCode = editMyProfileService.statusCode
                response.message = editMyProfileService.message
            } else {
                response.error = editMyProfileService.error
                response.statusCode = editMyProfileService.statusCode
                response.message = editMyProfileService.message
                response.data = editMyProfileService.data
            }
            callback(response)
        } catch (e) {
            console.log(e)
            response.error = true
            response.statusCode = STRINGS.errorStatusCode
            response.message = STRINGS.oopsErrorMessage
            callback(response)
        }
    }
    this.userFoodTripListController = async (req, callback) => {
        var response = {}
        try {
            var userFoodTripListService = await myProfileServiceObject.userFoodTripListService(req)
            if (userFoodTripListService.error) {
                response.error = true
                response.statusCode = userFoodTripListService.statusCode
                response.message = userFoodTripListService.message
            } else {
                response.error = userFoodTripListService.error
                response.statusCode = userFoodTripListService.statusCode
                response.message = userFoodTripListService.message
                // response.totalArticlePages = userFoodTripListService.totalArticlePages
                response.data = userFoodTripListService.data
            }
            callback(response)
        } catch (e) {
            console.log(e)
            response.error = true
            response.statusCode = STRINGS.errorStatusCode
            response.message = STRINGS.oopsErrorMessage
            callback(response)
        }
    }



    this.getOnePostController = async (req, callback) => {
        var response = {}
        try {
            var getOnePostService = await myProfileServiceObject.getOnePostService(req)
            if (getOnePostService.error) {
                response.error = true
                response.statusCode = getOnePostService.statusCode
                response.message = getOnePostService.message
            } else {
                response.error = getOnePostService.error
                response.statusCode = getOnePostService.statusCode
                response.message = getOnePostService.message
                // response.totalArticlePages = userFoodTripListService.totalArticlePages
                response.data = getOnePostService.data
            }
            callback(response)
        } catch (e) {
            console.log(e)
            response.error = true
            response.statusCode = STRINGS.errorStatusCode
            response.message = STRINGS.oopsErrorMessage
            callback(response)
        }
    }

    this.editOnePostController = async (req, callback) => {
        var response = {}
        try {
            var editOnePostService = await myProfileServiceObject.editOnePostService(req)
            if (editOnePostService.error) {
                response.error = true
                response.statusCode = editOnePostService.statusCode
                response.message = editOnePostService.message
            } else {
                response.error = editOnePostService.error
                response.statusCode = editOnePostService.statusCode
                response.message = editOnePostService.message
                // response.totalArticlePages = userFoodTripListService.totalArticlePages
                response.data = editOnePostService.data
            }
            callback(response)
        } catch (e) {
            console.log(e)
            response.error = true
            response.statusCode = STRINGS.errorStatusCode
            response.message = STRINGS.oopsErrorMessage
            callback(response)
        }
    }

    this.deleteOnePostController = async (req, callback) => {
        var response = {}
        try {
            var deleteOnePostService = await myProfileServiceObject.deleteOnePostService(req)
            if (deleteOnePostService.error) {
                response.error = true
                response.statusCode = deleteOnePostService.statusCode
                response.message = deleteOnePostService.message
            } else {
                response.error = deleteOnePostService.error
                response.statusCode = deleteOnePostService.statusCode
                response.message = deleteOnePostService.message
                // response.totalArticlePages = userFoodTripListService.totalArticlePages
                response.data = deleteOnePostService.data
            }
            callback(response)
        } catch (e) {
            console.log(e)
            response.error = true
            response.statusCode = STRINGS.errorStatusCode
            response.message = STRINGS.oopsErrorMessage
            callback(response)
        }
    }

    this.userBazaarCityListController = async (req, callback) => {
        var response = {}
        try {
            var userBazaarCityListService = await myProfileServiceObject.userBazaarCityListService(req)
            if (userBazaarCityListService.error) {
                response.error = true
                response.statusCode = userBazaarCityListService.statusCode
                response.message = userBazaarCityListService.message
            } else {
                response.error = userBazaarCityListService.error
                response.statusCode = userBazaarCityListService.statusCode
                response.message = userBazaarCityListService.message
                response.data = userBazaarCityListService.data
            }
            callback(response)
        } catch (e) {
            console.log(e)
            response.error = true
            response.statusCode = STRINGS.errorStatusCode
            response.message = STRINGS.oopsErrorMessage
            callback(response)
        }
    }


    this.getOneBazaarCityPostController = async (req, callback) => {
        var response = {}
        try {
            var getOneBazaarCityPostService = await myProfileServiceObject.getOneBazaarCityPostService(req)
            if (getOneBazaarCityPostService.error) {
                response.error = true
                response.statusCode = getOneBazaarCityPostService.statusCode
                response.message = getOneBazaarCityPostService.message
            } else {
                response.error = getOneBazaarCityPostService.error
                response.statusCode = getOneBazaarCityPostService.statusCode
                response.message = getOneBazaarCityPostService.message
                response.data = getOneBazaarCityPostService.data
            }
            callback(response)
        } catch (e) {
            console.log(e)
            response.error = true
            response.statusCode = STRINGS.errorStatusCode
            response.message = STRINGS.oopsErrorMessage
            callback(response)
        }
    }

    this.deleteOneBazaarCityPostController = async (req, callback) => {
        var response = {}
        try {
            var deleteOneBazaarCityPostService = await myProfileServiceObject.deleteOneBazaarCityPostService(req)
            if (deleteOneBazaarCityPostService.error) {
                response.error = true
                response.statusCode = deleteOneBazaarCityPostService.statusCode
                response.message = deleteOneBazaarCityPostService.message
            } else {
                response.error = deleteOneBazaarCityPostService.error
                response.statusCode = deleteOneBazaarCityPostService.statusCode
                response.message = deleteOneBazaarCityPostService.message
                response.data = deleteOneBazaarCityPostService.data
            }
            callback(response)
        } catch (e) {
            console.log(e)
            response.error = true
            response.statusCode = STRINGS.errorStatusCode
            response.message = STRINGS.oopsErrorMessage
            callback(response)
        }
    }


    this.editOneBazaarCityPostController = async (req, callback) => {
        var response = {}
        try {
            var editOneBazaarCityPostService = await myProfileServiceObject.editOneBazaarCityPostService(req)
            if (editOneBazaarCityPostService.error) {
                response.error = true
                response.statusCode = editOneBazaarCityPostService.statusCode
                response.message = editOneBazaarCityPostService.message
            } else {
                response.error = editOneBazaarCityPostService.error
                response.statusCode = editOneBazaarCityPostService.statusCode
                response.message = editOneBazaarCityPostService.message
                response.data = editOneBazaarCityPostService.data
            }
            callback(response)
        } catch (e) {
            console.log(e)
            response.error = true
            response.statusCode = STRINGS.errorStatusCode
            response.message = STRINGS.oopsErrorMessage
            callback(response)
        }
    }

    this.userBuyBuyItemsListController = async (req, callback) => {
        var response = {}
        try {
            var userBuyBuyItemsListService = await myProfileServiceObject.userBuyBuyItemsListService(req)
            if (userBuyBuyItemsListService.error) {
                response.error = true
                response.statusCode = userBuyBuyItemsListService.statusCode
                response.message = userBuyBuyItemsListService.message
            } else {
                response.error = userBuyBuyItemsListService.error
                response.statusCode = userBuyBuyItemsListService.statusCode
                response.message = userBuyBuyItemsListService.message
                response.data = userBuyBuyItemsListService.data
            }
            callback(response)
        } catch (e) {
            console.log(e)
            response.error = true
            response.statusCode = STRINGS.errorStatusCode
            response.message = STRINGS.oopsErrorMessage
            callback(response)
        }
    }

    this.ListUserPostedBuyBuyItemController = async (req, callback) => {
        var response = {}
        try {
            var ListUserPostedBuyBuyItem = await myProfileServiceObject.ListUserPostedBuyBuyItemService(req)
            if (ListUserPostedBuyBuyItem.error) {
                response.error = true
                response.statusCode = ListUserPostedBuyBuyItem.statusCode
                response.message = ListUserPostedBuyBuyItem.message
            } else {
                response.error = ListUserPostedBuyBuyItem.error
                response.statusCode = ListUserPostedBuyBuyItem.statusCode
                response.message = ListUserPostedBuyBuyItem.message
                response.data = ListUserPostedBuyBuyItem.data
            }
            callback(response)
        } catch (e) {
            console.log(e)
            response.error = true
            response.statusCode = STRINGS.errorStatusCode
            response.message = STRINGS.oopsErrorMessage
            callback(response)
        }
    }

    this.viewUserBuyBuyItemController = async (req, callback) => {
        var response = {}
        try {
            var viewUserBuyBuyItemService = await myProfileServiceObject.ViewUserBuyBuyItemService(req)
            if (viewUserBuyBuyItemService.error) {
                response.error = true
                response.statusCode = viewUserBuyBuyItemService.statusCode
                response.message = viewUserBuyBuyItemService.message
            } else {
                response.error = viewUserBuyBuyItemService.error
                response.statusCode = viewUserBuyBuyItemService.statusCode
                response.message = viewUserBuyBuyItemService.message
                response.data = viewUserBuyBuyItemService.data
            }
            callback(response)
        } catch (e) {
            console.log(e)
            response.error = true
            response.statusCode = STRINGS.errorStatusCode
            response.message = STRINGS.oopsErrorMessage
            callback(response)
        }
    }

    this.EditUserBuyBuyItemController = async (req, callback) => {
        var response = {}
        try {
            var EditUserBuyBuyItemService = await myProfileServiceObject.EditUserBuyBuyItemService(req)
            if (EditUserBuyBuyItemService.error) {
                response.error = true
                response.statusCode = EditUserBuyBuyItemService.statusCode
                response.message = EditUserBuyBuyItemService.message
            } else {
                response.error = EditUserBuyBuyItemService.error
                response.statusCode = EditUserBuyBuyItemService.statusCode
                response.message = EditUserBuyBuyItemService.message
                response.data = EditUserBuyBuyItemService.data
            }
            callback(response)
        } catch (e) {
            console.log(e)
            response.error = true
            response.statusCode = STRINGS.errorStatusCode
            response.message = STRINGS.oopsErrorMessage
            callback(response)
        }
    }


    this.DeleteUserBuyBuyItemController = async (req, callback) => {
        var response = {}
        try {
            var DeleteUserBuyBuyItemService = await myProfileServiceObject.DeleteUserBuyBuyItemsService(req)
            if (DeleteUserBuyBuyItemService.error) {
                response.error = true
                response.statusCode = DeleteUserBuyBuyItemService.statusCode
                response.message = DeleteUserBuyBuyItemService.message
            } else {
                response.error = DeleteUserBuyBuyItemService.error
                response.statusCode = DeleteUserBuyBuyItemService.statusCode
                response.message = DeleteUserBuyBuyItemService.message
                response.data = DeleteUserBuyBuyItemService.data
            }
            callback(response)
        } catch (e) {
            console.log(e)
            response.error = true
            response.statusCode = STRINGS.errorStatusCode
            response.message = STRINGS.oopsErrorMessage
            callback(response)
        }
    }



    this.getUsersListController = async (req, callback) => {
        var response = {}
        try {
            var getUsersListService = await myProfileServiceObject.getUsersListService(req)
            if (getUsersListService.error) {
                response.error = true
                response.statusCode = getUsersListService.statusCode
                response.message = getUsersListService.message
            } else {
                response.error = getUsersListService.error
                response.statusCode = getUsersListService.statusCode
                response.message = getUsersListService.message
                response.data = getUsersListService.data
            }
            callback(response)
        } catch (e) {
            console.log(e)
            response.error = true
            response.statusCode = STRINGS.errorStatusCode
            response.message = STRINGS.oopsErrorMessage
            callback(response)
        }
    }


    this.userConnectRequestController = async (req, callback) => {
        var response = {}
        try {
            var userConnectRequestService = await myProfileServiceObject.userConnectRequestService(req)
            if (userConnectRequestService.error) {
                response.error = true
                response.statusCode = userConnectRequestService.statusCode
                response.message = userConnectRequestService.message
            } else {
                response.error = userConnectRequestService.error
                response.statusCode = userConnectRequestService.statusCode
                response.message = userConnectRequestService.message
                response.data = userConnectRequestService.data
            }
            callback(response)
        } catch (e) {
            // console.log(e)
            response.error = true
            response.statusCode = STRINGS.errorStatusCode
            response.message = STRINGS.oopsErrorMessage
            callback(response)
        }
    }


    this.getUserConnectionList = async (req, callback) => {
        var response = {}
        try {
            var userConnectionListService = await myProfileServiceObject.getUserConnectionService(req)
            if (userConnectionListService.error) {
                response.error = true
                response.statusCode = userConnectionListService.statusCode
                response.message = userConnectionListService.message
            } else {
                response.error = userConnectionListService.error
                response.statusCode = userConnectionListService.statusCode
                response.message = userConnectionListService.message
                response.totalPages = userConnectionListService.totalPages
                response.data = userConnectionListService.data
            }
            callback(response)
        } catch (e) {
            // console.log(e)
            response.error = true
            response.statusCode = STRINGS.errorStatusCode
            response.message = STRINGS.oopsErrorMessage
            callback(response)
        }
    }

    this.userDisconnectRequestController = async (req, callback) => {
        var response = {}
        try {
            var userDisconnectRequestService = await myProfileServiceObject.userDisconnectRequestService(req)
            if (userDisconnectRequestService.error) {
                response.error = true
                response.statusCode = userDisconnectRequestService.statusCode
                response.message = userDisconnectRequestService.message
            } else {
                response.error = userDisconnectRequestService.error
                response.statusCode = userDisconnectRequestService.statusCode
                response.message = userDisconnectRequestService.message
                response.data = userDisconnectRequestService.data
            }
            callback(response)
        } catch (e) {
            // console.log(e)
            response.error = true
            response.statusCode = STRINGS.errorStatusCode
            response.message = STRINGS.oopsErrorMessage
            callback(response)
        }
    }





}