module.exports = function () {
    var PinoyPreneursController = require('../../services/web/PinoyPreneursService')
    // require('../utils/error.js')()
    var PinoyPreneursServiceObject = new PinoyPreneursController()

    const STRINGS = require('../../strings.json')


    this.addPinoyPreneurController = async (req, callback) => {
        var response = {}
        try {
            var addPinoyPreneurService = await PinoyPreneursServiceObject.addPinoyPreneurService(req)
            if (addPinoyPreneurService.error) {
                response.error = true
                response.statusCode = addPinoyPreneurService.statusCode
                response.message = addPinoyPreneurService.message
            } else {
                response.error = addPinoyPreneurService.error
                response.statusCode = addPinoyPreneurService.statusCode
                response.message = addPinoyPreneurService.message
                response.data = addPinoyPreneurService.data
            }
            callback(response)
        } catch (e) {
            // console.log(e)
            response.error = true
            response.statusCode = STRINGS.errorStatusCode
            response.message = STRINGS.oopsErrorMessage
            callback(response)
        }
    }



    this.GetPinoyPreneursListController = async (req, callback) => {
        var response = {}
        try {
            var GetPinoyPreneursListService = await PinoyPreneursServiceObject.GetPinoyPreneursListService(req)
            if (GetPinoyPreneursListService.error) {
                response.error = true
                response.statusCode = GetPinoyPreneursListService.statusCode
                response.message = GetPinoyPreneursListService.message
            } else {
                response.error = GetPinoyPreneursListService.error
                response.statusCode = GetPinoyPreneursListService.statusCode
                response.message = GetPinoyPreneursListService.message
                response.totalPages = GetPinoyPreneursListService.totalPages
                response.data = GetPinoyPreneursListService.data
            }
            callback(response)
        } catch (e) {
            // console.log(e)
            response.error = true
            response.statusCode = STRINGS.errorStatusCode
            response.message = STRINGS.oopsErrorMessage
            callback(response)
        }
    }


    this.GetOnePinoyPreneurController = async (req, callback) => {
        var response = {}
        try {
            var GetOnePinoyPreneurService = await PinoyPreneursServiceObject.GetOnePinoyPreneurService(req)
            if (GetOnePinoyPreneurService.error) {
                response.error = true
                response.statusCode = GetOnePinoyPreneurService.statusCode
                response.message = GetOnePinoyPreneurService.message
            } else {
                response.error = GetOnePinoyPreneurService.error
                response.statusCode = GetOnePinoyPreneurService.statusCode
                response.message = GetOnePinoyPreneurService.message
                response.data = GetOnePinoyPreneurService.data
                // response.PinoyPreneurProducts = GetOnePinoyPreneurService.PinoyPreneurProducts

            }
            callback(response)
        } catch (e) {
            // console.log(e)
            response.error = true
            response.statusCode = STRINGS.errorStatusCode
            response.message = STRINGS.oopsErrorMessage
            callback(response)
        }
    }

    this.editPinoyPreneurController = async (req, callback) => {
        var response = {}
        try {
            var editPinoyPreneurService = await PinoyPreneursServiceObject.editPinoyPreneurService(req)
            if (editPinoyPreneurService.error) {
                response.error = true
                response.statusCode = editPinoyPreneurService.statusCode
                response.message = editPinoyPreneurService.message
            } else {
                response.error = editPinoyPreneurService.error
                response.statusCode = editPinoyPreneurService.statusCode
                response.message = editPinoyPreneurService.message
                response.data = editPinoyPreneurService.data
            }
            callback(response)
        } catch (e) {
            // console.log(e)
            response.error = true
            response.statusCode = STRINGS.errorStatusCode
            response.message = STRINGS.oopsErrorMessage
            callback(response)
        }
    }

    this.checkUserPinoyPreneurController = async (req, callback) => {
        var response = {}
        try {
            var checkUserPinoyPreneurService = await PinoyPreneursServiceObject.checkUserPinoyPreneurService(req)
            if (checkUserPinoyPreneurService.error) {
                response.error = true
                response.statusCode = checkUserPinoyPreneurService.statusCode
                response.message = checkUserPinoyPreneurService.message
            } else {
                response.error = checkUserPinoyPreneurService.error
                response.statusCode = checkUserPinoyPreneurService.statusCode
                response.message = checkUserPinoyPreneurService.message
                response.data = checkUserPinoyPreneurService.data

            }
            callback(response)
        } catch (e) {
            // console.log(e)
            response.error = true
            response.statusCode = STRINGS.errorStatusCode
            response.message = STRINGS.oopsErrorMessage
            callback(response)
        }
    }

    this.createPinoyPreneurPaymentController = async (req, callback) => {
        var response = {}
        try {
            var createPinoyPreneurPaymentService = await PinoyPreneursServiceObject.createPinoyPreneurPaymentService(req)
            if (createPinoyPreneurPaymentService.error) {
                response.error = true
                response.statusCode = createPinoyPreneurPaymentService.statusCode
                response.message = createPinoyPreneurPaymentService.message
            } else {
                response.error = createPinoyPreneurPaymentService.error
                response.statusCode = createPinoyPreneurPaymentService.statusCode
                response.message = createPinoyPreneurPaymentService.message
                response.data = createPinoyPreneurPaymentService.data
            }
            callback(response)
        } catch (e) {
            // console.log(e)
            response.error = true
            response.statusCode = STRINGS.errorStatusCode
            response.message = STRINGS.oopsErrorMessage
            callback(response)
        }
    }


}