module.exports = function () {
    var jobCentreService = require('../../services/web/jobCentreService')
    // require('../utils/error.js')()
    var jobCentreServiceObject = new jobCentreService()

    const STRINGS = require('../../strings.json')


    this.addJobPostController = async (req, callback) => {
        var response = {}
        try {
            var addJobPostService = await jobCentreServiceObject.addJobPostService(req)
            if (addJobPostService.error) {
                response.error = true
                response.statusCode = addJobPostService.statusCode
                response.message = addJobPostService.message
            } else {
                response.error = addJobPostService.error
                response.statusCode = addJobPostService.statusCode
                response.message = addJobPostService.message
                response.data = addJobPostService.data
            }
            callback(response)
        } catch (e) {
            // console.log(e)
            response.error = true
            response.statusCode = STRINGS.errorStatusCode
            response.message = STRINGS.oopsErrorMessage
            callback(response)
        }
    }


    this.getJobFairListController = async (req, callback) => {
        var response = {}
        try {
            var getJobFairListService = await jobCentreServiceObject.getJobFairListService(req)
            if (getJobFairListService.error) {
                response.error = true
                response.statusCode = getJobFairListService.statusCode
                response.message = getJobFairListService.message
            } else {
                response.error = getJobFairListService.error
                response.statusCode = getJobFairListService.statusCode
                response.message = getJobFairListService.message
                response.data = getJobFairListService.data
            }
            callback(response)
        } catch (e) {
            // console.log(e)
            response.error = true
            response.statusCode = STRINGS.errorStatusCode
            response.message = STRINGS.oopsErrorMessage
            callback(response)
        }
    }


    this.getAllJobListController = async (req, callback) => {
        var response = {}
        try {
            var getAllJobListService = await jobCentreServiceObject.getAllJobListService(req)
            if (getAllJobListService.error) {
                response.error = true
                response.statusCode = getAllJobListService.statusCode
                response.message = getAllJobListService.message
            } else {
                response.error = getAllJobListService.error
                response.statusCode = getAllJobListService.statusCode
                response.message = getAllJobListService.message
                response.totalPages = getAllJobListService.totalPages
                response.data = getAllJobListService.data
            }
            callback(response)
        } catch (e) {
            // console.log(e)
            response.error = true
            response.statusCode = STRINGS.errorStatusCode
            response.message = STRINGS.oopsErrorMessage
            callback(response)
        }
    }


    this.getOneJobPostController = async (req, callback) => {
        var response = {}
        try {
            var getOneJobPostService = await jobCentreServiceObject.getOneJobPostService(req)
            if (getOneJobPostService.error) {
                response.error = true
                response.statusCode = getOneJobPostService.statusCode
                response.message = getOneJobPostService.message
            } else {
                response.error = getOneJobPostService.error
                response.statusCode = getOneJobPostService.statusCode
                response.message = getOneJobPostService.message
                response.data = getOneJobPostService.data
            }
            callback(response)
        } catch (e) {
            // console.log(e)
            response.error = true
            response.statusCode = STRINGS.errorStatusCode
            response.message = STRINGS.oopsErrorMessage
            callback(response)
        }
    }
    this.addJobDraftController = async (req, callback) => {
        var response = {}
        try {
            var addJobDraftService = await jobCentreServiceObject.addJobDraftService(req)
            if (addJobDraftService.error) {
                response.error = true
                response.statusCode = addJobDraftService.statusCode
                response.message = addJobDraftService.message
            } else {
                response.error = addJobDraftService.error
                response.statusCode = addJobDraftService.statusCode
                response.message = addJobDraftService.message
                response.data = addJobDraftService.data
            }
            callback(response)
        } catch (e) {
            // console.log(e)
            response.error = true
            response.statusCode = STRINGS.errorStatusCode
            response.message = STRINGS.oopsErrorMessage
            callback(response)
        }
    }

    this.getOneJobDraftController = async (req, callback) => {
        var response = {}
        try {
            var getOneJobDraftService = await jobCentreServiceObject.getOneJobDraftService(req)
            if (getOneJobDraftService.error) {
                response.error = true
                response.statusCode = getOneJobDraftService.statusCode
                response.message = getOneJobDraftService.message
            } else {
                response.error = getOneJobDraftService.error
                response.statusCode = getOneJobDraftService.statusCode
                response.message = getOneJobDraftService.message
                response.data = getOneJobDraftService.data
            }
            callback(response)
        } catch (e) {
            // console.log(e)
            response.error = true
            response.statusCode = STRINGS.errorStatusCode
            response.message = STRINGS.oopsErrorMessage
            callback(response)
        }
    }

    this.createJobPaymentController = async (req, callback) => {
        var response = {}
        try {
            var createJobPaymentService = await jobCentreServiceObject.createJobPaymentService(req)
            if (createJobPaymentService.error) {
                response.error = true
                response.statusCode = createJobPaymentService.statusCode
                response.message = createJobPaymentService.message
            } else {
                response.error = createJobPaymentService.error
                response.statusCode = createJobPaymentService.statusCode
                response.message = createJobPaymentService.message
                response.data = createJobPaymentService.data
            }
            callback(response)
        } catch (e) {
            console.log(e)
            response.error = true
            response.statusCode = STRINGS.errorStatusCode
            response.message = STRINGS.oopsErrorMessage
            callback(response)
        }
    }
    this.webhookController = async (req, callback) => {
        var response = {}
        try {
            var webhookService = await jobCentreServiceObject.webhookService(req)
            if (webhookService.error) {
                response.error = true
                response.statusCode = webhookService.statusCode
                response.message = webhookService.message
            } else {
                response.error = webhookService.error
                response.statusCode = webhookService.statusCode
                response.message = webhookService.message
                response.data = webhookService.data
            }
            callback(response)
        } catch (e) {
            console.log(e)
            response.error = true
            response.statusCode = STRINGS.errorStatusCode
            response.message = STRINGS.oopsErrorMessage
            callback(response)
        }
    }


    this.editOneJobPostController = async (req, callback) => {
        var response = {}
        try {
            var editOneJobPostService = await jobCentreServiceObject.editOneJobPostService(req)
            if (editOneJobPostService.error) {
                response.error = true
                response.statusCode = editOneJobPostService.statusCode
                response.message = editOneJobPostService.message
            } else {
                response.error = editOneJobPostService.error
                response.statusCode = editOneJobPostService.statusCode
                response.message = editOneJobPostService.message
                response.data = editOneJobPostService.data
            }
            callback(response)
        } catch (e) {
            // console.log(e)
            response.error = true
            response.statusCode = STRINGS.errorStatusCode
            response.message = STRINGS.oopsErrorMessage
            callback(response)
        }
    }

    this.getOneJobFairController = async (req, callback) => {
        var response = {}
        try {
            var getOneJobFairService = await jobCentreServiceObject.getOneJobFairService(req)
            if (getOneJobFairService.error) {
                response.error = true
                response.statusCode = getOneJobFairService.statusCode
                response.message = getOneJobFairService.message
            } else {
                response.error = getOneJobFairService.error
                response.statusCode = getOneJobFairService.statusCode
                response.message = getOneJobFairService.message
                response.data = getOneJobFairService.data
            }
            callback(response)
        } catch (e) {
            // console.log(e)
            response.error = true
            response.statusCode = STRINGS.errorStatusCode
            response.message = STRINGS.oopsErrorMessage
            callback(response)
        }
    }



}