module.exports = function () {
    var notificationService = require('../../services/web/notificationService')
    // require('../utils/error.js')()
    var notificationServiceObject = new notificationService()

    const STRINGS = require('../../strings.json')


    this.getAllNotificationListController = async (req, callback) => {
        var response = {}
        try {
            var getAllNotificationListService = await notificationServiceObject.getAllNotificationListService(req)
            if (getAllNotificationListService.error) {
                response.error = true
                response.statusCode = getAllNotificationListService.statusCode
                response.message = getAllNotificationListService.message
            } else {
                response.error = getAllNotificationListService.error
                response.statusCode = getAllNotificationListService.statusCode
                response.message = getAllNotificationListService.message
                response.totalCount = getAllNotificationListService.totalCount
                response.totalPages = getAllNotificationListService.totalPages
                response.data = getAllNotificationListService.data
            }
            callback(response)
        } catch (e) {
            // console.log(e)
            response.error = true
            response.statusCode = STRINGS.errorStatusCode
            response.message = STRINGS.oopsErrorMessage
            callback(response)
        }
    }



    this.getAllUnreadNotificationCountController = async (req, callback) => {
        var response = {}
        try {
            var getAllUnreadNotificationCountService = await notificationServiceObject.getAllUnreadNotificationCountService(req)
            if (getAllUnreadNotificationCountService.error) {
                response.error = true
                response.statusCode = getAllUnreadNotificationCountService.statusCode
                response.message = getAllUnreadNotificationCountService.message
            } else {

                response.error = getAllUnreadNotificationCountService.error
                response.statusCode = getAllUnreadNotificationCountService.statusCode
                response.message = getAllUnreadNotificationCountService.message
                response.data = getAllUnreadNotificationCountService.data
            }
            callback(response)
        } catch (e) {
            // console.log(e)
            response.error = true
            response.statusCode = STRINGS.errorStatusCode
            response.message = STRINGS.oopsErrorMessage
            callback(response)
        }
    }






    this.addNotificationController = async (req, callback) => {
        var response = {}

        return new Promise(async resolve => {
            try {
                var addNotificationService = await notificationServiceObject.addNotificationService(req)
                if (addNotificationService.error) {
                    response.error = true
                    response.statusCode = addNotificationService.statusCode
                    response.message = addNotificationService.message
                } else {

                    response.error = addNotificationService.error
                    response.statusCode = addNotificationService.statusCode
                    response.message = addNotificationService.message
                    response.data = addNotificationService.data
                }
                resolve(response)
            } catch (e) {
                // console.log(e)
                response.error = true
                response.statusCode = STRINGS.errorStatusCode
                response.message = STRINGS.oopsErrorMessage
                resolve(response)
            }
        })
    }





}