module.exports = function () {
    var articleModal = require('../../modal/admin/articlesModal')
    var TagModal = require('../../modal/admin/TagsModal')
    // var ProudlyPinoyModal = require('../../modal/')
    // var PodcastModal = require('../../modal/web/PodcastModal')

this.addArticleDao = async (data) => {

    var response = {}
    return new Promise(function (resolve, reject) {
      const articleModals = new articleModal(data)
      articleModals.save(function (error, result) {

        if (error) {
          response.error = true
        } else {
          response.error = false
          response.data = result
        }
        resolve(response)
      })
    })
  }
  this.getArticleDao = async (data) => {

    var response = {}
    return new Promise(function (resolve, reject) {
      articleModal.find({is_active:1},{ 
        Uid:1,
        thumbNail_url:1,
        backGround_imageUrl:1,
        mediaType:1,
        tag_id:1,
        tag_name:1,
        title:1,
        source:1,
        province_name:1,
       is_active:1,
       createdAt:1,
       updatedAt:1,
        number_of_likes:1,
        number_of_comments:1
       
        }) .sort({"updatedAt":-1})
         .skip(data.pageNumber > 0 ? ((data.pageNumber - 1) * RowsPerpage) : 0)
        .limit(RowsPerpage)
        .then((result) => {
            response.error = false
            response.result = result
            // console.log(result);
            resolve(response)

        })
        .catch((error) => {
            response.error = true
            resolve(response)

            console.log(error);
        });
})
}


this.getTotalArticlesListCountDao = async (data) => {
  var response = {}
  return new Promise(function (resolve, reject) {
      articleModal.find({
              is_active: 1,
             
          })
          .count()
          .then((result) => {
              response.error = false
              response.result = result
              // console.log(result);
              resolve(response)

          })
          .catch((error) => {
              response.error = true
              resolve(response)

              console.log(error);
          });
  })
}

  this.getArticleDescriptionDao = async (data) => {

    var response = {}
    return new Promise(function (resolve, reject) {
      articleModal.find({is_active:1,_id:data.article_id},{ 
      title:1,
      description:1,
      backGround_imageUrl:1
       
        }, function (error, result) {
          
        if (error) {
          response.error = true
        } else {
          response.error = false
          response.data = result
        }
        resolve(response)
      })
    })
  }

  this.deleteArticleDao = async (data) => {
    var response = {}
    return new Promise(function (resolve, reject) {
      articleModal.deleteOne({
        _id: data.article_id
        },
        (err, result) => {
          if (err) {
            response.error = true
          } else {
            response.error = false
            response.result = result
          }
          resolve(response)
        });
    })
  }

  this.editArticleDao = async (data) => {
   
    var response = {}
    return new Promise(function (resolve, reject) {
      articleModal.updateMany({
        _id: data.article_id
        }, {
          $set: {
            thumbNail_url: data.thumbNail_url,
            backGround_imageUrl:data.backGround_imageUrl,
            title: data.title,
            mediaType: data.mediaType,
            tag_id: data.tag_id,
            description: data.description,
            source:data.source,
            province_name:data.province_name,
            tag_name: data.tag_name,
          }
          
        },
        (err, result) => {
          if (err) {
            response.error = true
          } else {
            response.error = false
            response.result = result
          }
          resolve(response)
        });
    })
  }
  
  
 
 
}



