module.exports = function () {
    var NiknokModal = require('../../modal/admin/NiknokModal.js')
    

this.addNiknokDao = async (data) => {

    var response = {}
    return new Promise(function (resolve, reject) {
      const NiknokModals = new NiknokModal(data)
      NiknokModals.save(function (error, result) {

        if (error) {
          response.error = true
        } else {
          response.error = false
          response.data = result
        }
        resolve(response)
      })
    })
  }

  this.getTotalNiknokListCountDao = async (data) => {
    var response = {}
    return new Promise(function (resolve, reject) {
      NiknokModal.find({
                is_active: 1,
               
            })
            .count()
            .then((result) => {
                response.error = false
                response.result = result
                // console.log(result);
                resolve(response)

            })
            .catch((error) => {
                response.error = true
                resolve(response)

                console.log(error);
            });
    })
}

  this.getNiknokListDao = async (data) => {

    var response = {}
    return new Promise(function (resolve, reject) {
        NiknokModal.find({is_active:1},{ 
          comic_images:1,
          comics_title:1,
          thumbNail_url:1
       
        }).sort({"updatedAt":-1})
        .skip(data.pageNumber > 0 ? ((data.pageNumber - 1) * RowsPerpage) : 0)
        .limit(RowsPerpage)
        .then((result) => {
            response.error = false
            response.result = result
            // console.log(result);
            resolve(response)

        })
        .catch((error) => {
            response.error = true
            resolve(response)

            console.log(error);
        });
})
}

  this.getNiknokImageDao = async (data) => {

    var response = {}
    return new Promise(function (resolve, reject) {
        NiknokModal.find({is_active:1,_id:data.Niknok_id},{ 
          comic_images:1
       
        }, function (error, result) {
          
        if (error) {
          response.error = true
        } else {
          response.error = false
          response.data = result
        }
        resolve(response)
      })
    })
  }

  
  this.deleteNiknokDao = async (data) => {
    var response = {}
    return new Promise(function (resolve, reject) {
        NiknokModal.deleteOne({_id: data.Niknok_id},
        //updateOne({_id:"6207672750a7d9912a70d457"}, {$pull : {"comic_images" : 1 }}, 
               // deleteOne({
        // _id: data.Niknok_id
        // },
        (err, result) => {
          if (err) {
            response.error = true
          } else {
            response.error = false
            response.result = result
          }
          resolve(response)
        });
    })
  }

  this.editNiknokDao = async (data) => {
   
    var response = {}
    return new Promise(function (resolve, reject) {
        NiknokModal.updateMany({
        _id: data.Niknok_id
        }, {
          $set: {
            comics_title: data.comics_title,
            thumbNail_url:data.thumbNail_url,
            comic_images:data.comic_images
          }
          
        },
        (err, result) => {
          if (err) {
            response.error = true
          } else {
            response.error = false
            response.result = result
          }
          resolve(response)
        });
    })
  }
  
}



