module.exports = function () {
    var JobFairModel = require('../../modal/admin/JobFairModel')
    var JobCentreModel = require('../../modal/web/JobCentreModel')
    var SubscriptionPlansModel = require('../../modal/admin/SubscriptionPlansModel')





    this.addOneJobPlanDao = async (data) => {
        var response = {}
        return new Promise(function (resolve, reject) {
            const SubscriptionPlansObject = new SubscriptionPlansModel(data)
            SubscriptionPlansObject.save(function (error, result) {
                if (error) {
                    console.log(error)
                    response.error = true
                } else {
                    response.error = false
                    response.data = result
                }
                resolve(response)
            })
        })
    }

    this.editOneJobPlanDao = async (data) => {
        var response = {}
        return new Promise(function (resolve, reject) {
            SubscriptionPlansModel.updateOne({
                post_type: data.type
                }, {
                    $set: {
                        subscription_fee: data.subscription_fee,
                        subscription_validity: data.subscription_validity,
                        subscription_validity_type: data.subscription_validity_type,
                    }
                })
                .then((result) => {
                    response.error = false
                    response.result = result
                    // console.log(result);
                    resolve(response)

                })
                .catch((error) => {
                    response.error = true
                    resolve(response)

                    console.log(error);
                });
        })
    }



    this.getOneSubscriptionDetailDao = async (data) => {
        var response = {}
        return new Promise(function (resolve, reject) {
            SubscriptionPlansModel.findOne({
                    is_active: 1,
                    post_type:data.type
                })
                .lean()
                .then((result) => {
                    response.error = false
                    response.result = result
                    // console.log(result);
                    resolve(response)

                })
                .catch((error) => {
                    response.error = true
                    resolve(response)

                    console.log(error);
                });
        })
    }




 
    this.getTotalSubscriptionListDao = async (data) => {
        var response = {}
        return new Promise(function (resolve, reject) {
            JobCentreModel.find({
                    is_active: 1
                })
                .count()
                .then((result) => {
                    response.error = false
                    response.result = result
                    // console.log(result);
                    resolve(response)

                })
                .catch((error) => {
                    response.error = true
                    resolve(response)

                    console.log(error);
                });
        })
    }

    this.getSubscriptionListDao = async (data) => {
        var response = {}
        return new Promise(function (resolve, reject) {
            JobFairModel.aggregate([{
                        $match: {
                            $expr: {
                                $eq: ["$is_active", 1]
                            }
                        }
                    },
                    {
                        $sort: {
                            createdAt: -1
                        }
                    },
                    {
                        $skip: data.pageNumber > 0 ? ((data.pageNumber - 1) * 10) : 0
                    },
                    {
                        $limit: data.RowsPerpage
                    },
                    // {
                    //     $project: {
                    //         _id: 1,
                    //         thumbNail_url: 1,
                    //         // backGround_imageUrl: 1,
                    //         title: 1,
                    //         is_active: 1,
                    //         createdAt: 1,
                    //     }
                    // }
                ])
                .then((result) => {
                    response.error = false
                    response.result = result
                    // console.log(result);
                    resolve(response)

                })
                .catch((error) => {
                    response.error = true
                    resolve(response)

                    console.log(error);
                });
        })
    }


}