module.exports = function () {
  var foodTripModal = require('../../modal/web/FoodTripModal')
  var commentsModal = require('../../modal/web/Comments')
  // var repliesModal = require('../../modal/web/Replies')
  var articlesModal = require('../../modal/admin/articlesModal')

  var newPinoysModal = require('../../modal/admin/newPinoysModel')
  var tambayanModal = require('../../modal/web/TambayanModal')
  var donasayonModal = require('../../modal/web/DonasyanModal')
  var BazaarCityModel = require('../../modal/web/BazaarCityModel')
  var MyProfileModal = require('../../modal/web/MyProfileModal')




  this.replyCommentsDao = async (data) => {
    console.log("savereplies")
    var response = {}
    return new Promise(function (resolve, reject) {
      const saveReplyComments = new commentsModal(data)
      saveReplyComments.save(function (error, result) {
        if (error) {
          console.log(error)
          response.error = true
        } else {
          response.error = false
          response.data = result
        }
        resolve(response)
      })
    })
  }


  this.commentsListDao = async (data) => {
    var response = {}
    return new Promise(function (resolve, reject) {
      commentsModal.find({
        _id: data.post_id
      }, function (error, result) {
        if (error) {
          console.log(error)
          response.error = true
        } else {
          response.error = false
          response.data = result
        }
        resolve(response)
      })
    })
  }

  this.getCountRepliesDao = async (data) => {
    var response = {}
    return new Promise(function (resolve, reject) {
      commentsModal.find({
        comment_ref_id: data.comment_ref_id
      }, function (error, result) {
        if (error) {
          console.log(error)
          response.error = true
        } else {
          response.error = false
          response.data = result
        }
        resolve(response)
      })
    })
  }

  this.postCommentsDao = async (data) => {
    var response = {}
    return new Promise(function (resolve, reject) {
      const commentsObject = new commentsModal(data)
      commentsObject.save(function (error, result) {
        if (error) {
          console.log(error)
          response.error = true
        } else {
          response.error = false
          response.data = result
        }
        resolve(response)
      })
    })
  }

  this.getOneProfileDao = async (data) => {
    var response = {}
    return new Promise(function (resolve, reject) {
      MyProfileModal.findOne({
        uid: data.uid
      }, function (error, result) {
        if (error) {
          console.log(error)
          response.error = true
        } else {
          response.error = false
          response.data = result
        }
        resolve(response)
      })
    })
  }

  this.putTotalCommentsDao = async (data) => {
    var store = data.post_type == "foodTripPost" ? foodTripModal :
      data.post_type == "articles" ? articlesModal :
      data.post_type == "comments" ? commentsModal :
      data.post_type == "newPinoys" ? newPinoysModal :
      data.post_type == "tambayan" ? tambayanModal :
      data.post_type == "bazaarCity" ? BazaarCityModel :
      data.post_type == "donasayon" ? donasayonModal : null
    // console.log("daaaao",data)
    var response = {}
    return new Promise(function (resolve, reject) {
      store.updateOne({
        _id: data.comment_ref_id
      }, {
        $set: {
          number_of_comments: data.updatecount,
        }
      }, function (error, result) {
        if (error) {
          console.log(error)
          response.error = true
        } else {
          response.error = false
          response.data = result
        }
        resolve(response)
      })
    })
  }

  this.putTotalRepliesDao = async (data) => {
    console.log("commentscount", data)

    var response = {}
    return new Promise(function (resolve, reject) {
      commentsModal.updateOne({
        _id: data.comment_ref_id
      }, {
        $set: {
          number_of_replies: data.updatecount,
        }
      }, function (error, result) {
        if (error) {
          console.log(error)
          response.error = true
        } else {
          response.error = false
          response.data = result
        }
        resolve(response)
      })
    })
  }

  // this.getOneCommentsDao = async (data) => {
  //   var response = {}
  //   return new Promise(function (resolve, reject) {
  //     commentsModal.find({
  //       comment_ref_id: data.comment_ref_id
  //     }, function (error, result) {
  //       if (error) {
  //         console.log(error)
  //         response.error = true
  //       } else {
  //         response.error = false
  //         response.data = result
  //       }
  //       console.log("aggregate", result)
  //       resolve(response)
  //     })
  //   })
  // }

  this.getOneCommentsDao = async (data) => {
    var response = {}
    return new Promise(function (resolve, reject) {
      //console.log("iew",data)

      commentsModal.find({
          $and: [{
            comment_ref_id: data.comment_ref_id
          }, {
            is_active: 1
          }]
        }).lean()
        .then((result) => {
          response.error = false
          response.data = result
          // console.log(result);
          resolve(response)

        })
        .catch((error) => {
          response.error = true
          resolve(response)

          console.log(error);
        });
    })
  }


  this.getOnePostDao = async (data) => {
    var store = data.post_type == "foodTripPost" ? foodTripModal :
      data.post_type == "articles" ? articlesModal :
      data.post_type == "comments" ? commentsModal :
      data.post_type == "newPinoys" ? newPinoysModal :
      data.post_type == "tambayan" ? tambayanModal :
      data.post_type == "bazaarCity" ? BazaarCityModel :
      data.post_type == "donasayon" ? donasayonModal : null
    // console.log("daaaao",data)
    var response = {}
    return new Promise(function (resolve, reject) {
      store.find({
        _id: data.comment_ref_id
      }, function (error, result) {
        if (error) {
          console.log(error)
          response.error = true
        } else {
          response.error = false
          response.data = result
        }
        resolve(response)
      })
    })
  }








  this.removeCommentsDao = async (data) => {
    var response = {}
    return new Promise(function (resolve, reject) {
      commentsModal.deleteOne({
        $and: [{
          uid: data.uid
        }, {
          post_id: data.post_id
        }]
      }, function (error, result) {
        if (error) {
          console.log(error)
          response.error = true
        } else {
          response.error = false
          response.data = result
        }
        console.log("aggregate", result)
        resolve(response)
      })
    })
  }

}