module.exports = function () {
    var articleModal = require('../../modal/admin/articlesModal')
    var newPinoysModel = require('../../modal/admin/newPinoysModel')
    var SurveyModel = require('../../modal/web/SurveyModel')
    var SurveyVotesModel = require('../../modal/web/SurveyVotesModel')
    var goodVibesModel = require('../../modal/admin/goodVibesModel')
    var ShoutOutsModel = require('../../modal/admin/ShoutOutsModel')
    var MyProfileModal = require('../../modal/web/MyProfileModal')

    var PinoyPreneursModel = require('../../modal/web/PinoyPreneursModel')
    var JobFairModel = require('../../modal/admin/JobFairModel')
    var DonasyanModal = require('../../modal/web/DonasyanModal')


    var BazaarCityModel = require('../../modal/web/BazaarCityModel')


    var NationCalendarModel = require('../../modal/web/P-NationCalendarModel')




    this.getTotalArticlesListCountDao = async (data) => {
        var response = {}
        return new Promise(function (resolve, reject) {
            articleModal.find({
                    $and: [{
                        is_active: 1
                    }, {
                        $or: [{
                                title: {
                                    $regex: `${data.search}`,
                                    $options: 'i'
                                }
                            },
                            {
                                description: {
                                    $regex: `${data.search}`,
                                    $options: 'i'
                                }
                            }
                        ]
                    }]
                })
                .count()
                .then((result) => {
                    response.error = false
                    response.result = result
                    // console.log(result);
                    resolve(response)

                })
                .catch((error) => {
                    response.error = true
                    resolve(response)

                    console.log(error);
                });
        })
    }



    this.getArticlesListDao = async (data) => {
        var response = {}
        return new Promise(function (resolve, reject) {
            articleModal.aggregate([{
                        $match: {
                            $and: [{
                                    $expr: {
                                        $eq: ["$is_active", 1]
                                    }
                                },
                                {
                                    $or: [{
                                        title: {
                                            $regex: `${data.search}`,
                                            $options: 'i'
                                        }
                                    }, {
                                        description: {
                                            $regex: `${data.search}`,
                                            $options: 'i'
                                        }
                                    }]
                                }
                            ]
                        }
                    },
                    {
                        $sort: {
                            createdAt: -1
                        }
                    },
                    {
                        $skip: data.articlePageNumber > 0 ? ((data.articlePageNumber - 1) * 10) : 0
                    },
                    {
                        $limit: 10
                    },
                    {
                        $project: {
                            _id: 1,
                            thumbNail_url: 1,
                            mediaType: 1,
                            tag_id: 1,
                            tag_name: 1,
                            title: 1,
                            description: {
                                $substrBytes: ["$description", 0, 160]
                            },
                            source: 1,
                            province_name: 1,
                            createdAt: 1,
                        }
                    }
                ])
                // .skip(data.articlePageNumber > 0 ? ((data.articlePageNumber - 1) * 10) : 0)
                // .limit(10).
                .then((result) => {
                    response.error = false
                    response.result = result
                    // console.log(result);
                    resolve(response)

                })
                .catch((error) => {
                    response.error = true
                    resolve(response)

                    console.log(error);
                });
        })
    }


    this.getTotalNewPinoysListCountDao = async (data) => {
        var response = {}
        return new Promise(function (resolve, reject) {
            newPinoysModel.find({
                    $and: [{
                        is_active: 1
                    }, {
                        $or: [{
                                title: {
                                    $regex: `${data.search}`,
                                    $options: 'i'
                                }
                            },
                            {
                                description: {
                                    $regex: `${data.search}`,
                                    $options: 'i'
                                }
                            }
                        ]
                    }]
                })
                .count()
                .then((result) => {
                    response.error = false
                    response.result = result
                    //   console.log(result);
                    resolve(response)

                })
                .catch((error) => {
                    response.error = true
                    resolve(response)

                    console.log(error);
                });
        })
    }

    this.getNewPinoysListDao = async (data) => {
        var response = {}
        return new Promise(function (resolve, reject) {
            newPinoysModel.aggregate([{
                        $match: {
                            $and: [{
                                    $expr: {
                                        $eq: ["$is_active", 1]
                                    }
                                },
                                {
                                    $or: [{
                                        title: {
                                            $regex: `${data.search}`,
                                            $options: 'i'
                                        }
                                    }, {
                                        description: {
                                            // $regex: `/^${data.search}/i`,
                                            $regex: `${data.search}`,
                                            $options: 'i'
                                        }
                                    }]
                                }
                            ]
                        }
                    },
                    {
                        $sort: {
                            createdAt: -1
                        }
                    },
                    {
                        $skip: data.articlePageNumber > 0 ? ((data.articlePageNumber - 1) * 10) : 0
                    },
                    {
                        $limit: 10
                    },
                    {
                        $project: {
                            _id: 1,
                            thumbNail_url: 1,
                            mediaType: 1,
                            province_name: 1,
                            title: 1,
                            description: 1,
                            description: {
                                $substrBytes: ["$description", 0, 160]
                            },
                            createdAt: 1
                        }
                    }
                ])
                .then((result) => {
                    response.error = false
                    response.result = result
                    // console.log(result);
                    resolve(response)

                })
                .catch((error) => {
                    response.error = true
                    resolve(response)

                    console.log(error);
                });
        })
    }


    this.shoutOutsListDao = async (data) => {
        var response = {}
        return new Promise(function (resolve, reject) {
            ShoutOutsModel.aggregate([{
                        $match: {
                            $and: [{
                                    $expr: {
                                        $eq: ["$is_active", 1]
                                    }
                                },
                                {
                                    $expr: {
                                        $eq: ["$status", 'approved']
                                    }
                                }
                            ]
                        }
                    },
                    {
                        $sort: {
                            updatedAt: -1
                        }
                    },
                    {
                        $limit: parseInt(data.limit)
                    },
                    {
                        $project: {
                            _id: 1,
                            uid: 1,
                            post_id: 1,
                            post_type: 1,
                            post_description: 1,
                            post_images: 1,
                            profile_photo: 1,
                            full_name: 1,
                            is_active: 1,
                            status: 1,
                            createdAt: 1
                        }
                    }
                ])
                .then((result) => {
                    response.error = false
                    response.result = result
                    // console.log(result);
                    resolve(response)

                })
                .catch((error) => {
                    response.error = true
                    resolve(response)

                    console.log(error);
                });
        })
    }


    this.getOneSurveyDao = async (data) => {
        var response = {}
        return new Promise(function (resolve, reject) {
            SurveyModel.findOne({
                    is_active: 1,
                    _id: data.survey_id
                }).lean()
                .then((result) => {
                    response.error = false
                    response.result = result
                    // console.log(result);
                    resolve(response)

                })
                .catch((error) => {
                    response.error = true
                    resolve(response)

                    console.log(error);
                });
        })
    }

    this.getOneSurveyOptionDao = async (data) => {
        var response = {}
        return new Promise(function (resolve, reject) {
            SurveyVotesModel.findOne({
                    is_active: 1,
                    survey_id: data.survey_id,
                    uid: data.uid
                })
                .then((result) => {
                    response.error = false
                    response.result = result
                    // console.log(result);
                    resolve(response)

                })
                .catch((error) => {
                    response.error = true
                    resolve(response)

                    console.log(error);
                });
        })
    }


    this.addOneSurveyOptionDao = async (data) => {
        var response = {}
        return new Promise(function (resolve, reject) {
            const SurveyModelObject = new SurveyVotesModel(data)
            SurveyModelObject.save(function (error, result) {
                if (error) {
                    console.log(error)
                    response.error = true
                } else {
                    response.error = false
                    response.data = result
                }
                resolve(response)
            })
        })
    }

    this.updateSurveyVotesDao = async (data) => {
        var response = {}
        return new Promise(function (resolve, reject) {
            SurveyModel.updateOne({
                    is_active: 1,
                    _id: data.survey_id
                }, {
                    $set: {
                        votes: data.votes
                    }
                })
                .then((result) => {
                    response.error = false
                    response.result = result
                    // console.log(result);
                    resolve(response)

                })
                .catch((error) => {
                    response.error = true
                    resolve(response)

                    console.log(error);
                });
        })
    }


    this.UserSurveyListDao = async (data) => {
        var response = {}
        return new Promise(function (resolve, reject) {
            SurveyModel.find({
                    is_active: 1,
                })
                .sort({
                    createdAt: -1
                })
                .limit(data.limit)
                .then((result) => {
                    response.error = false
                    response.result = result
                    // console.log(result);
                    resolve(response)

                })
                .catch((error) => {
                    response.error = true
                    resolve(response)

                    console.log(error);
                });
        })
    }


    this.UserSurveyListDao1 = async (data) => {
        var response = {}
        return new Promise(function (resolve, reject) {
            SurveyModel.aggregate([{
                        $match: {
                            $and: [{
                                $expr: {
                                    $eq: ["$is_active", 1]
                                }
                            }]
                        }
                    },
                    {
                        $lookup: {
                            from: "surveyvotes",
                            let: {
                                surveyId: {
                                    "$toString": "$_id"
                                },
                                // userId: "$uid"
                            },
                            pipeline: [{
                                $match: {
                                    $expr: {
                                        $and: [{
                                            $eq: ["$survey_id", "$$surveyId"],
                                            $eq: ["$uid",data.uid ]
                                        }]
                                    }
                                }
                            }],
                            as: "surveyvotes"
                        }
                    },
                    {
                        $sort: {
                            createdAt: -1
                        }
                    },
                    // {
                    //     $skip: data.pageNumber > 0 ? ((data.pageNumber - 1) * 10) : 0
                    // },
                    {
                        $limit: parseInt(data.limit)
                    },
                    {
                        $project: {
                            _id: 1,
                            uid: 1,
                            survey_id: 1,
                            question: 1,
                            options: 1,
                            votes: 1,
                            isVoted: {
                                $cond: {
                                    if: {
                                        $gt: [{
                                            $size: "$surveyvotes"
                                        }, 0]
                                    },
                                    then: 1,
                                    else: 0
                                }
                            },
                            is_active: 1,
                            createdAt: 1,

                        }
                    }
                ])
                .then((result) => {
                    response.error = false
                    response.result = result
                    // console.log(result);
                    resolve(response)

                })
                .catch((error) => {
                    response.error = true
                    resolve(response)

                    console.log(error);
                });
        })
    }












    this.getOneSurveyVotesDao = async (data) => {
        var response = {}
        return new Promise(function (resolve, reject) {
            SurveyVotesModel.find({
                    is_active: 1,
                    survey_id: data.survey_id,
                    option: data.option
                })
                .count()
                .then((result) => {
                    response.error = false
                    response.result = result
                    // console.log(result);
                    resolve(response)

                })
                .catch((error) => {
                    response.error = true
                    resolve(response)

                    console.log(error);
                });
        })
    }

    this.getOneUserSurveyVote = async (data) => {
        var response = {}
        return new Promise(function (resolve, reject) {
            SurveyVotesModel.find({
                    is_active: 1,
                    survey_id: data.survey_id,
                    uid: data.uid
                })
                .count()
                .then((result) => {
                    response.error = false
                    response.result = result
                    // console.log(result);
                    resolve(response)

                })
                .catch((error) => {
                    response.error = true
                    resolve(response)

                    console.log(error);
                });
        })
    }






    this.GoodVibesListDao = async (data) => {
        var response = {}
        return new Promise(function (resolve, reject) {
            goodVibesModel.find({
                    is_active: 1,
                })
                .sort({
                    createdAt: -1
                })
                .limit(data.limit)
                .then((result) => {
                    response.error = false
                    response.result = result
                    // console.log(result);
                    resolve(response)

                })
                .catch((error) => {
                    response.error = true
                    resolve(response)

                    console.log(error);
                });
        })
    }

    this.getTotaluserGlobalSearchDao = async (data) => {
        var response = {}
        return new Promise(function (resolve, reject) {
            MyProfileModal.find({
                    $and: [{
                        is_active: 1
                    }, {
                        full_name: {
                            $regex: `${data.search}`,
                            $options: 'i'
                        }
                    }]
                })
                .count()
                .then((result) => {
                    response.error = false
                    response.result = result
                    // console.log(result);
                    resolve(response)

                })
                .catch((error) => {
                    response.error = true
                    resolve(response)

                    console.log(error);
                });
        })
    }

    this.userGlobalSearchDao = async (data) => {
        var response = {}
        return new Promise(function (resolve, reject) {
            MyProfileModal.aggregate([{
                        $match: {
                            $and: [{
                                    $expr: {
                                        $eq: ["$is_active", 1]
                                    }
                                },
                                {
                                    full_name: {
                                        $regex: `${data.search}`,
                                        $options: 'i'
                                    }
                                }
                            ]
                        }
                    },
                    {
                        $sort: {
                            createdAt: -1
                        }
                    },
                    {
                        $skip: data.articlePageNumber > 0 ? ((data.articlePageNumber - 1) * 10) : 0
                    },
                    {
                        $limit: 10
                    },
                    {
                        $project: {
                            _id: 1,
                            uid: 1,
                            full_name: 1,
                            profile_photo: 1,
                            eMail_id: 1,
                            gender: 1,
                            home_country: 1,
                            province: 1,
                            current_city: 1,
                            user_status: 1,
                            pinoy_preneur: 1,
                            is_active: 1,
                            createdAt: 1,
                        }
                    }
                ])

                .then((result) => {
                    response.error = false
                    response.result = result
                    // console.log(result);
                    resolve(response)

                })
                .catch((error) => {
                    response.error = true
                    resolve(response)

                    console.log(error);
                });
        })
    }


    this.HomePagePinoypreneursListDao = async (data) => {
        var response = {}
        return new Promise(function (resolve, reject) {
            PinoyPreneursModel.aggregate([{
                        $match: {
                            $and: [{
                                $expr: {
                                    $eq: ["$is_active", 1]
                                }
                            }]
                        }
                    },
                    {
                        $lookup: {
                            from: "pinoypreneursproducts",
                            let: {
                                pinoy_preneurId: {
                                    "$toString": "$_id"
                                },
                                userId: "$uid"
                            },
                            pipeline: [{
                                $match: {
                                    $expr: {
                                        $and: [{
                                            $eq: ["$PinoyPreneur_id", "$$pinoy_preneurId"],
                                            //   $eq: ["$uid", "$$userId"]
                                        }]
                                    }
                                }
                            }],
                            as: "pinoyPreneur_products"
                        }
                    },
                    {
                        $sort: {
                            createdAt: -1
                        }
                    },
                    // {
                    //     $skip: data.pageNumber > 0 ? ((data.pageNumber - 1) * 10) : 0
                    // },
                    {
                        $limit: parseInt(data.limit)
                    },
                    {
                        $project: {
                            _id: 1,
                            business_logo: 1,
                            business_name: 1,
                            business_description: 1,
                            category: 1,
                            province_name: 1,
                            postal_code: 1,
                            template_id: 1,
                            uid: 1,
                            profile_photo: 1,
                            full_name: 1,
                            position: 1,
                            is_active: 1,
                            createdAt: 1,
                            pinoyPreneur_products: 1,

                        }
                    }
                ])
                .then((result) => {
                    response.error = false
                    response.result = result
                    // console.log(result);
                    resolve(response)

                })
                .catch((error) => {
                    response.error = true
                    resolve(response)

                    console.log(error);
                });
        })
    }


    this.getJobFairListDao = async (data) => {
        var response = {}
        return new Promise(function (resolve, reject) {
            JobFairModel.aggregate([{
                        $match: {
                            $expr: {
                                $eq: ["$is_active", 1]
                            }
                        }
                    },
                    {
                        $sort: {
                            createdAt: -1
                        }
                    },
                    // {
                    //     $skip: data.pageNumber > 0 ? ((data.pageNumber - 1) * 10) : 0
                    // },
                    {
                        $limit: 10
                    },
                    {
                        $project: {
                            _id: 1,
                            thumbNail_url: 1,
                            // backGround_imageUrl: 1,
                            title: 1,
                            description: {
                                $substrBytes: ["$description", 0, 250]
                            },
                            is_active: 1,
                            createdAt: 1,
                        }
                    }
                ])
                .then((result) => {
                    response.error = false
                    response.result = result
                    // console.log(result);
                    resolve(response)

                })
                .catch((error) => {
                    response.error = true
                    resolve(response)

                    console.log(error);
                });
        })
    }



    this.getDonasaynListDao = async (data) => {
        var response = {}
        return new Promise(function (resolve, reject) {


            DonasyanModal
                .aggregate([{
                        $match: {
                            $and: [{
                                $expr: {
                                    $eq: ["$is_active", 1]
                                }
                            }]
                        }
                    },
                    {
                        $sort: {
                            createdAt: -1
                        }
                    },
                    {
                        $limit: 10
                    },
                    {
                        $project: {
                            _id: 1,
                            uid: 1,
                            item_name: 1,
                            purpose_to_add: 1,
                            enter_your_price: 1,
                            is_this_price: 1,
                            post_images: 1,
                            number_of_likes: 1,
                            number_of_comments: 1,
                            category: 1,
                            full_name: 1,
                            profile_photo: 1,
                            is_active: 1,
                            createdAt: 1,
                        }
                    }
                ]).then((result) => {
                    response.error = false
                    response.data = result
                    //   console.log("getList", result);
                    resolve(response)

                })
                .catch((error) => {
                    response.error = true
                    resolve(response)

                    console.log(error);
                });
        })
    }

    this.homePageBazaarCityListDao = async (data) => {
        var response = {}
        return new Promise(function (resolve, reject) {


            BazaarCityModel.aggregate([{
                        $match: {
                            $and: [{
                                $expr: {
                                    $eq: ["$is_active", 1]
                                }
                            }]

                        }
                    },
                    {
                        $sort: {
                            createdAt: -1
                        }
                    },
                    // {
                    //     $skip: data.pageNumber > 0 ? ((data.pageNumber - 1) * 10) : 0
                    // },
                    {
                        $limit: 10
                    },
                    {
                        $project: {
                            _id: 1,
                            uid: 1,
                            item_name: 1,
                            item_images: 1,
                            category: 1,
                            price: 1,
                            province_name: 1,
                            profile_photo: 1,
                            full_name: 1,
                            number_of_likes: 1,
                            number_of_comments: 1,
                            is_active: 1,
                            createdAt: 1,
                        }
                    },
                    {
                        $sort: {
                            createdAt: -1
                        }
                    }
                ])
                .then((result) => {
                    response.error = false
                    response.result = result
                    // console.log(result);
                    resolve(response)

                })
                .catch((error) => {
                    response.error = true
                    resolve(response)

                    console.log(error);
                });
        })
    }


    this.homePagePnationCalendarListDao = async (data) => {
        var response = {}
        return new Promise(function (resolve, reject) {

            NationCalendarModel
                .aggregate([{
                        $match: {
                            $and: [{
                                    $expr: {
                                        $eq: ["$is_active", 1]
                                    }
                                },
                                {
                                    event_date: {
                                        $gte: new Date()
                                    }

                                }
                            ]

                        }
                    },
                    {
                        $sort: {
                            event_date: 1
                        }
                    },
                    {
                        $skip: data.PageNumber > 0 ? ((data.PageNumber - 1) * 10) : 0
                    },
                    {
                        $limit: 10
                    },
                    {
                        $project: {
                            _id: 1,
                            name_of_the_event: 1,
                            is_active: 1,
                            createdAt: 1,
                            event_date: 1,
                            event_time: 1,
                            event_date_in_local: 1,
                            city: 1,
                            province_name: 1,
                            poster_image: 1,
                            organization_type: 1,
                            organization_name: 1,
                            authorized_by_organization: 1,
                            state_of_organization: 1
                        }
                    }
                ])

                .then((result) => {
                    response.error = false
                    response.data = result
                    // console.log(result);
                    resolve(response)

                })
                .catch((error) => {
                    response.error = true
                    resolve(response)

                    console.log(error);
                });
        })
    }






}