module.exports = function () {
  var newPinoysModal = require('../../modal/admin/newPinoysModel')
  var articlesModal = require('../../modal/admin/articlesModal')
  var myProfileModal = require('../../modal/web/MyProfileModal')

  this.getOneProfileDao = async (data) => {
    var response = {}
    return new Promise(function (resolve, reject) {
      myProfileModal.findOne({
          uid: data.uid
        }).lean()
        .then((result) => {
          response.error = false
          response.result = result
          // console.log(result);
          resolve(response)

        })
        .catch((error) => {
          response.error = true
          resolve(response)

          console.log(error);
        });
    })
  }

  this.articlesListDao = async (data) => {
    var response = {}
    return new Promise(function (resolve, reject) {
      newPinoysModal.find({}, function (error, result) {
        if (error) {
          console.log(error)
          response.error = true
        } else {
          response.error = false
          response.data = result
        }
        resolve(response)
      })
    })
  }

  this.getTotalListCountDao = async (data) => {
    var response = {}
    return new Promise(function (resolve, reject) {
      newPinoysModal.find({
        $and: [{
          is_active: 1
        }, {
          $or: [{
              title: {
                $regex: `${data.search}`,
                $options: 'i'
              }
            },
            {
              description: {
                $regex: `${data.search}`,
                $options: 'i'
              }
            }
          ]
        }]
      })
        .count()
        .then((result) => {
          response.error = false
          response.result = result
          // console.log(result);
          resolve(response)

        })
        .catch((error) => {
          response.error = true
          resolve(response)

          console.log(error);
        });
    })
  }
  this.getArticlesListDao = async (data) => {
    var response = {}
    return new Promise(function (resolve, reject) {
      newPinoysModal.aggregate([{
        $match: {
          $and: [{
              $expr: {
                $eq: ["$is_active", 1]
              }
            },
            {
              $or: [{
                title: {
                  $regex: `${data.search}`,
                  $options: 'i'
                }
              }, {
                description: {
                  $regex: `${data.search}`,
                  $options: 'i'
                }
              }]
            }
          ]
        }
      },
     
      {
        $project: {
          _id: 1,
          thumbNail_url: 1,
          mediaType: 1,
          tag_id: 1,
          tag_name: 1,
          title: 1,
          number_of_likes:1,
          number_of_comments:1,
          // description: {
          //   $substrBytes: ["$description", 0, 160]
          // },
          description: 1,
          source: 1,
          province_name: 1,
          createdAt: 1,
          priority: {
            "$eq": [
              "$province_name",
              data.province
            ]
          }
        }
      },
      {
        $sort: {
          priority: -1,
          createdAt:-1
        }
      },
      {
        $skip: data.pageNumber > 0 ? ((data.pageNumber - 1) * 10) : 0
      },
      {
        $limit: 10
      },
    ])
        .then((result) => {
          response.error = false
          response.result = result
          // console.log(result);
          resolve(response)

        })
        .catch((error) => {
          response.error = true
          resolve(response)

          console.log(error);
        });
    })
  }

  this.getOneArticleDetailsDao = async (data) => {
    var response = {}
    return new Promise(function (resolve, reject) {
      newPinoysModal.find({
        _id: data.post_id
      }, function (error, result) {
        if (error) {
          console.log(error)
          response.error = true
        } else {
          response.error = false
          response.data = result
        }
        resolve(response)
      })
    })
  }

  this.getNewPinoysRelatedArticlesDao = async (data) => {
    var response = {}
    return new Promise(function (resolve, reject) {
      newPinoysModal
        .find({
          $and: [
            //   {
            //   province_name: data.province_name
            // }
            {
              is_active: 1
            }, {
              _id: {
                $not: {
                  $eq: data.post_id
                }
              }
            }
          ]
        }).sort({
          "createdAt": -1
        })
        .limit(7)

        .then((result) => {
          response.error = false
          response.data = result
          // console.log(result);
          resolve(response)

        })
        .catch((error) => {
          response.error = true
          resolve(response)

          console.log(error);
        });
    })
  }
  this.getNewPinoysHomeRelatedArticlesDao = async (data) => {
    var response = {}
    return new Promise(function (resolve, reject) {
      articlesModal
        .find({
          is_active: 1
        }).sort({
          "createdAt": -1
        })
        .limit(10)
        .then((result) => {
          response.error = false
          response.data = result
          // console.log(result);
          resolve(response)

        })
        .catch((error) => {
          response.error = true
          resolve(response)

          console.log(error);
        });
    })
  }
}