module.exports = function () {
  var pNationCalanderModal = require('../../modal/web/P-NationCalendarModel')
  var ShoutOutsModel = require('../../modal/admin/ShoutOutsModel')
  var myProfileModal = require('../../modal/web/MyProfileModal')

 
  this.getOneProfileForPnationDao = async (data) => {
    var response = {}
    return new Promise(function (resolve, reject) {
      myProfileModal.findOne({
          is_active: 1,
          uid: data.uid
        }).lean()
        .then((result) => {
          response.error = false
          response.result = result
          // console.log(result);
          resolve(response)

        })
        .catch((error) => {
          response.error = true
          resolve(response)

          console.log(error);
        });
    })
  }





  this.getTotalpNationCalanderListCountDao = async (data) => {
    var response = {}
    return new Promise(function (resolve, reject) {
      pNationCalanderModal.find({
          $and: [{
            is_active: 1
          }, {
            $or: [{
                city: {
                  $regex: `${data.search}`,
                  $options: 'i'
                }
              },
              {
                name_of_the_event: {
                  $regex: `${data.search}`,
                  $options: 'i'
                }
              },
              {
                province_name: {
                  $regex: `${data.search}`,
                  $options: 'i'
                }
              }
            ]
          }]
        })
        .count()
        .then((result) => {
          response.error = false
          response.data = result
          // console.log(result);
          resolve(response)

        })
        .catch((error) => {
          response.error = true
          resolve(response)

          console.log(error);
        });
    })
  }


  this.getpNationCalanderListDao = async (data) => {
    console.log("pnation", data.dateFilter[0], new Date("2020-01-25").toISOString())
    var response = {}
    return new Promise(function (resolve, reject) {
      var filterLocation = {
        is_active: 1
      }

      if (data.filterLocation.length > 0) {
        filterLocation = {
          province_name: {
            $in: data.filterLocation
          }
        }
      }
      if (data.dateFilter.length > 0) {
        var gt = new Date(data.dateFilter[0])
        var con = new Date()

        //for get 
        var date = new Date(data.dateFilter[1]);
        var a = date.toISOString().substring(0, 10);
        var b = new Date(a)
        //fromdate `
        var lt = new Date(data.dateFilter[0])
        var lessarthan = lt.toISOString().substring(0, 10);

        var c = b.setHours(b.getHours() + 23);
        var d = new Date(c).toISOString()
        var e = b.setMinutes(b.getMinutes() + 59);
        var f = new Date(e).toISOString()
        //sec
        var e = b.setSeconds(b.getSeconds() + 59);
        var f = new Date(e).toISOString()

        var e = b.setMilliseconds(b.getMilliseconds() + 999);
        var f = new Date(e)
        //0000min
        var zeromin = new Date(lessarthan)
        console.log("logging", zeromin, f)
      }
      // var getting=data.dateFilter.length==0?{$gte:  new Date()}:{$gte:  new Date(data.dateFilter[0]), $lt: new Date(data.dateFilter[1])}
      var getting = data.dateFilter.length == 0 ? {
        $gte: new Date()
      } : {
        $gte: zeromin,
        $lt: f
      }


      pNationCalanderModal
        .aggregate([{
            $match: {
              $and: [{
                  $expr: {
                    $eq: ["$is_active", 1]
                  }
                },
                {
                  $or: [{
                      name_of_the_event: {
                        $regex: `${data.search}`,
                        $options: 'i'
                      }
                    },
                    {
                      city: {
                        $regex: `${data.search}`,
                        $options: 'i'
                      }
                    },
                    {
                      province_name: {
                        $regex: `${data.search}`,
                        $options: 'i'
                      }
                    }
                  ]
                },
                filterLocation,

                {
                  event_date: getting
                  //   {
                  //   $gte: (data.dateFilter.length==0? new Date():new Date(data.dateFilter[0])), $lt: new Date("2022-02-28T00:00:00.0Z")} 
                }
                //{city: {$eq:"city2"}}
              ]

            }
          },
          {
            $sort: {
              event_date: 1
            }
          },
          {
            $skip: data.PageNumber > 0 ? ((data.PageNumber - 1) * 10) : 0
          },
          {
            $limit: 10
          },
          {
            $project: {
              _id: 1,
              name_of_the_event: 1,
              is_active: 1,
              createdAt: 1,
              event_date: 1,
              event_time: 1,
              event_date_in_local: 1,
              city: 1,
              province_name: 1,
              poster_image: 1,
              organization_type: 1,
              organization_name: 1,
              authorized_by_organization: 1,
              state_of_organization: 1
            }
          }
        ])

        .then((result) => {
          response.error = false
          response.data = result
          // console.log(result);
          resolve(response)

        })
        .catch((error) => {
          response.error = true
          resolve(response)

          console.log(error);
        });
    })
  }

  //used for forloop=>
  //to-2022-03-02T18:30:00Z 
  this.getTotalpNationGroupDao = async (data) => {
    console.log("daaatass", data)
    var response = {}
    var date = new Date(data.event_date);
    var a = date.toISOString().substring(0, 10);
    var b = new Date(a)

    var c = b.setHours(b.getHours() + 18);
    var d = new Date(c).toISOString()
    var e = b.setMinutes(b.getMinutes() + 29);
    var f = new Date(e).toISOString()
    //sec
    var e = b.setSeconds(b.getSeconds() + 59);
    var f = new Date(e).toISOString()

    var e = b.setMilliseconds(b.getMilliseconds() + 000);
    var f = new Date(e).toISOString()
    //0000min
    var zeromin = new Date(a).toISOString()


    console.log("dataasasa", f, zeromin)
    return new Promise(function (resolve, reject) {
      pNationCalanderModal

        .find({
          event_date: {
            $gte: new Date(zeromin),
            $lte: new Date(f)
          }
        })
        // .find({
        //   event_date:data.event_date
        //       })
        .then((result) => {
          response.error = false
          response.data = result
          console.log("ressuult", result);
          resolve(response)

        })
        .catch((error) => {
          response.error = true
          resolve(response)

          console.log(error);
        });
    })
  }



  this.pNationCalanderPostDao = async (data) => {
    var response = {}
    // console.log("postpnationdao",data)
    return new Promise(function (resolve, reject) {

      const pNationCalanderModalObject = new pNationCalanderModal(data)
      pNationCalanderModalObject.save(function (error, result) {
        console.log("res", result)
        if (error) {
          console.log(error)
          response.error = true
        } else {
          response.error = false
          response.data = result
        }
        //console.log("daata",response)
        resolve(response)
      })
    })
  }

  // this.getpNationCalanderDao = async (data) => {
  //   var response = {}
  //   return new Promise(function (resolve, reject) {

  //     pNationCalanderModal.find({$and:[{_id:data.post_id},{is_active:1}]},
  //       {_id:1,
  //         name_of_the_event:1,
  //         event_date:1,
  //         event_time:1,
  //         city:1,
  //         province_name: 1,
  //       poster_image: 1,
  //       organization_type: 1,
  //       organization_name: 1,
  //       authorized_by_organization: 1,
  //       state_of_organization: 1,
  //       }
  //       ,function (error, result) {
  //         // console.log("res",result)
  //       if (error) {
  //         console.log(error)
  //         response.error = true
  //       } else {
  //         response.error = false
  //         response.data = result
  //       }
  //       //console.log("daata",response)
  //       resolve(response)
  //     })
  //   })
  // }

  this.getpNationCalanderDao = async (data) => {
    var response = {}
    return new Promise(function (resolve, reject) {
      pNationCalanderModal.findOne({
          is_active: 1,
          _id: data.post_id
        }).lean()
        .then((result) => {
          response.error = false
          response.result = result
          // console.log(result);
          resolve(response)

        })
        .catch((error) => {
          response.error = true
          resolve(response)

          console.log(error);
        });
    })
  }

  this.checkFeaturePostDao = async (data) => {
    var response = {}
    return new Promise(function (resolve, reject) {
      pNationCalanderModal.find({
          is_active: 1,
          _id: data.post_id,
          uid: data.uid
        }).count()
        .then((result) => {
          response.error = false
          response.result = result
          // console.log(result);
          resolve(response)

        })
        .catch((error) => {
          response.error = true
          resolve(response)

          console.log(error);
        });
    })
  }



  this.checkUserFeaturePostDao = async (data) => {
    var response = {}
    return new Promise(function (resolve, reject) {
      ShoutOutsModel.find({
          is_active: 1,
          post_id: data.post_id,
          uid: data.uid
        }).count()
        .then((result) => {
          response.error = false
          response.result = result
          // console.log(result);
          resolve(response)

        })
        .catch((error) => {
          response.error = true
          resolve(response)

          console.log(error);
        });
    })
  }



  this.searchpNationCalanderDao = async (data) => {
    var response = {}
    console.log("searchh", data);
    return new Promise(function (resolve, reject) {
      pNationCalanderModal
        .find({
          $or: [{
              name_of_the_event: {
                $regex: `${data.search}`,
                $options: 'm'
              }
            }, {
              city: {
                $regex: `${data.search}`,
                $options: 'm'
              }
            },
            {
              province_name: {
                $regex: `${data.search}`,
                $options: 'm'
              }
            },
            {
              $or: [{
                category: {
                  $in: data.arr
                }
              }]
            }
          ]
        }).then((result) => {
          response.error = false
          response.data = result
          console.log(result);
          resolve(response)

        })
        .catch((error) => {
          response.error = true
          resolve(response)

          console.log(error);
        });
    })
  }


  this.editOnePnationCalanderPostDao = async (data) => {
    var response = {}
    return new Promise(function (resolve, reject) {
      pNationCalanderModal.updateOne({
          _id: data.post_id
        }, {
          $set: {
            authorized_by_organization: data.authorized_by_organization,
            city: data.city,
            event_date: data.event_date,
            event_time: data.event_time,
            name_of_the_event: data.name_of_the_event,
            organization_name: data.organization_name,
            organization_type: data.organization_type,
            poster_image: data.poster_image,
            province_name: data.province_name,
            state_of_organization: data.state_of_organization
          }
        })
        .then((result) => {
          response.error = false
          response.result = result
          // console.log(result);
          resolve(response)

        })
        .catch((error) => {
          response.error = true
          resolve(response)

          console.log(error);
        });
    })
  }


  this.deleteOnePnationCalanderDao = async (data) => {
    var response = {}
    return new Promise(function (resolve, reject) {
      pNationCalanderModal.deleteOne({
          _id: data.post_id
        })
        .then((result) => {
          response.error = false
          response.result = result
          // console.log(result);
          resolve(response)

        })
        .catch((error) => {
          response.error = true
          resolve(response)

          console.log(error);
        });
    })
  }

}