module.exports = function () {
  var articleModal = require('../../modal/admin/articlesModal')
  var proudlyPinoyModel = require('../../modal/admin/proudlyPinoyModel')
  var podcastsModel = require('../../modal/admin/podcastsModel')
  var podcastEpisodesModel = require('../../modal/admin/podcastEpisodesModel')
  var videosFeedModel = require('../../modal/admin/videosFeedModel')
  var LikesModel = require('../../modal/web/Likes')

  var myProfileModal = require('../../modal/web/MyProfileModal')




  this.getTotalArticlesListCountDao = async (data) => {
    var response = {}
    return new Promise(function (resolve, reject) {
      articleModal.find({
          $and: [{
            is_active: 1
          }, {
            $or: [{
                title: {
                  $regex: `${data.search}`,
                  $options: 'i'
                }
              },
              {
                description: {
                  $regex: `${data.search}`,
                  $options: 'i'
                }
              }
            ]
          }]
        })
        .count()
        .then((result) => {
          response.error = false
          response.result = result
          // console.log(result);
          resolve(response)

        })
        .catch((error) => {
          response.error = true
          resolve(response)

          console.log(error);
        });
    })
  }



  this.getOneProfileDao = async (data) => {
    var response = {}
    return new Promise(function (resolve, reject) {
      myProfileModal.findOne({
          uid: data.uid
        }).lean()
        .then((result) => {
          response.error = false
          response.result = result
          // console.log(result);
          resolve(response)

        })
        .catch((error) => {
          response.error = true
          resolve(response)

          console.log(error);
        });
    })
  }




  this.getArticlesListDao = async (data) => {
    var response = {}
    return new Promise(function (resolve, reject) {
      articleModal.aggregate([{
            $match: {
              $and: [{
                  $expr: {
                    $eq: ["$is_active", 1]
                  }
                },
                {
                  $or: [{
                    title: {
                      $regex: `${data.search}`,
                      $options: 'i'
                    }
                  }, {
                    description: {
                      $regex: `${data.search}`,
                      $options: 'i'
                    }
                  }]
                }
              ]
            }
          },
         
          {
            $project: {
              _id: 1,
              thumbNail_url: 1,
              mediaType: 1,
              tag_id: 1,
              tag_name: 1,
              title: 1,
              // description: {
              //   $substrBytes: ["$description", 0, 160]
              // },
              description: 1,
              source: 1,
              province_name: 1,
              createdAt: 1,
              priority: {
                "$eq": [
                  "$province_name",
                  data.province
                ]
              }
            }
          },
          {
            $sort: {
              // priority: -1,
              createdAt:-1
            }
          },
          {
            $skip: data.articlePageNumber > 0 ? ((data.articlePageNumber - 1) * 10) : 0
          },
          {
            $limit: 10
          },
         
        ])
        // .skip(data.articlePageNumber > 0 ? ((data.articlePageNumber - 1) * 10) : 0)
        // .limit(10).
        .then((result) => {
          response.error = false
          response.result = result
          // console.log(result);
          resolve(response)

        })
        .catch((error) => {
          response.error = true
          resolve(response)

          console.log(error);
        });
    })
  }

  this.viewOneArticleDao = async (data) => {
    var response = {}
    return new Promise(function (resolve, reject) {
      articleModal.find({
          is_active: 1,
          _id: data.id
        }, {
          _id: 1,
          thumbNail_url: 1,
          backGround_imageUrl: 1,
          mediaType: 1,
          tag_id: 1,
          tag_name: 1,
          title: 1,
          number_of_likes: 1,
          number_of_comments: 1,
          province_name: 1,
          description: 1,
          createdAt: 1

        }).then((result) => {
          response.error = false
          response.result = result
          // console.log(result);
          resolve(response)

        })
        .catch((error) => {
          response.error = true
          resolve(response)

          console.log(error);
        });
    })
  }
  this.getTotalProudlyPinoyListCountDao = async (data) => {
    var response = {}
    return new Promise(function (resolve, reject) {
      proudlyPinoyModel.find({
          $and: [{
            is_active: 1
          }, {
            $or: [{
                title: {
                  $regex: `${data.search}`,
                  $options: 'i'
                }
              },
              {
                description: {
                  $regex: `${data.search}`,
                  $options: 'i'
                }
              }
            ]
          }]
        })
        .count()
        .then((result) => {
          response.error = false
          response.result = result
          // console.log(result);
          resolve(response)

        })
        .catch((error) => {
          response.error = true
          resolve(response)

          console.log(error);
        });
    })
  }
  this.getProudlyPinoyListDao = async (data) => {
    var response = {}
    return new Promise(function (resolve, reject) {
      proudlyPinoyModel.aggregate([{
            $match: {
              $and: [{
                  $expr: {
                    $eq: ["$is_active", 1]
                  }
                },
                {
                  $or: [{
                    title: {
                      $regex: `${data.search}`,
                      $options: 'i'
                    }
                  }, {
                   
                  }]
                }
              ]
            }
          },
         
          {
            $project: {
              _id: 1,
          title: 1,
          video_url: 1,
          createdAt: 1,
          is_active: 1
            }
          },
          {
            $sort: {
              priority: -1,
              createdAt:-1
            }
          },
          {
            $skip: data.proudlyPinoyPage > 0 ? ((data.proudlyPinoyPage - 1) * 10) : 0
          },
          {
            $limit: 10
          },
         
        ])
        .then((result) => {
          response.error = false
          response.result = result
          // console.log(result);
          resolve(response)

        })
        .catch((error) => {
          response.error = true
          resolve(response)

          console.log(error);
        });
    })
  }

  this.getTotalPodcastListCountDao = async (data) => {
    var response = {}
    return new Promise(function (resolve, reject) {
      podcastsModel.find({
          $and: [{
            is_active: 1
          }, {
            $or: [{
                title: {
                  $regex: `${data.search}`,
                  $options: 'i'
                }
              },
              {
                description: {
                  $regex: `${data.search}`,
                  $options: 'i'
                }
              }
            ]
          }]
        })
        .count()
        .then((result) => {
          response.error = false
          response.result = result
          // console.log(result);
          resolve(response)

        })
        .catch((error) => {
          response.error = true
          resolve(response)

          console.log(error);
        });
    })
  }
  this.getPodcastListDao = async (data) => {
    var response = {}
    return new Promise(function (resolve, reject) {
      podcastsModel.aggregate([{
            $match: {
              $and: [{
                  $expr: {
                    $eq: ["$is_active", 1]
                  }
                },
                {
                  $or: [{
                    title: {
                      $regex: `${data.search}`,
                      $options: 'i'
                    }
                  }, {
                   
                  }]
                }
              ]
            }
          },
          
          {
            $project: {
            _id: 1,
          title: 1,
          author_imageUrl: 1,
          team: 1,
          description: 1,
          is_active: 1,
          createdAt: 1
            }
          },
          {
            $sort: {
              priority: -1,
              createdAt:-1
            }
          },
          {
            $skip: data.podcastPage > 0 ? ((data.podcastPage - 1) * 10) : 0
          },
          {
            $limit: 10
          },
         
        ])
        .then((result) => {
          response.error = false
          response.result = result
          // console.log(result);
          resolve(response)

        })
        .catch((error) => {
          response.error = true
          resolve(response)

          console.log(error);
        });
    })
  }


  this.viewPodcastDao = async (data) => {
    var response = {}
    return new Promise(function (resolve, reject) {
      podcastEpisodesModel.find({
          is_active: 1,
          podcast_id: data.podcast_id
        }, {
          _id: 1,
          podcast_id: 1,
          audio_url: 1,
          title: 1,
          description: 1,
          createdAt: 1

        })
        .sort({
          createdAt: 1
        })
        .then((result) => {
          response.error = false
          response.result = result
          // console.log(result);
          resolve(response)

        })
        .catch((error) => {
          response.error = true
          resolve(response)

          console.log(error);
        });
    })
  }

  this.getTotalVideoFeedCountDao = async (data) => {
    var response = {}
    return new Promise(function (resolve, reject) {
      videosFeedModel.find({
          $and: [{
            is_active: 1
          }, {
            $or: [{
                title: {
                  $regex: `${data.search}`,
                  $options: 'i'
                }
              },
              {
                description: {
                  $regex: `${data.search}`,
                  $options: 'i'
                }
              }
            ]
          }]
        })
        .count()
        .then((result) => {
          response.error = false
          response.result = result
          // console.log(result);
          resolve(response)

        })
        .catch((error) => {
          response.error = true
          resolve(response)

          console.log(error);
        });
    })
  }

  this.getVideosFeedListDao = async (data) => {
    var response = {}
    return new Promise(function (resolve, reject) {
      videosFeedModel.aggregate([{
            $match: {
              $and: [{
                  $expr: {
                    $eq: ["$is_active", 1]
                  }
                },
                {
                  $or: [{
                    title: {
                      $regex: `${data.search}`,
                      $options: 'i'
                    }
                  }, {
                   
                  }]
                }
              ]
            }
          },
         
          {
            $project: {
              _id: 1,
          title: 1,
          video_url: 1,
          createdAt: 1,
          is_active: 1
            }
          },
          {
            $sort: {
              priority: -1,
              createdAt:-1
            }
          },
          {
            $skip: data.videoPage > 0 ? ((data.videoPage - 1) * 10) : 0
          },
          {
            $limit: 5
          },
        ])
        .then((result) => {
          response.error = false
          response.result = result
          // console.log(result);
          resolve(response)

        })
        .catch((error) => {
          response.error = true
          resolve(response)

          console.log(error);
        });
    })
  }

  this.getPodcastDetailDao = async (data) => {
    var response = {}
    return new Promise(function (resolve, reject) {
      podcastsModel.findOne({
          is_active: 1,
          _id: data.podcast_id
        }, {
          _id: 1,
          title: 1,
          author_imageUrl: 1,
          team: 1,
          description: 1,
          total_episodes: 1,
          is_active: 1,
          createdAt: 1

        })
        .then((result) => {
          response.error = false
          response.result = result
          // console.log(result);
          resolve(response)

        })
        .catch((error) => {
          response.error = true
          resolve(response)

          console.log(error);
        });
    })
  }


  this.relatedPodcastListDao = async (data) => {
    var response = {}
    return new Promise(function (resolve, reject) {
      podcastsModel.find({
          is_active: 1,
          _id: {
            $ne: data.podcast_id
          }
        }, {
          _id: 1,
          title: 1,
          author_imageUrl: 1,
          team: 1,
          description: 1,
          is_active: 1,
          createdAt: 1

        })
        .sort({
          createdAt: -1
        })
        .limit(10)
        .then((result) => {
          response.error = false
          response.result = result
          // console.log(result);
          resolve(response)

        })
        .catch((error) => {
          response.error = true
          resolve(response)

          console.log(error);
        });
    })
  }

  this.viewOneArticleLikeDao = async (data) => {
    var response = {}
    return new Promise(function (resolve, reject) {
      LikesModel.findOne({
          is_active: 1,
          uid: data.uid,
          post_id: data.id
        }, {
          _id: 1,
          uid: 1

        }).then((result) => {
          response.error = false
          response.result = result
          // console.log(result);
          resolve(response)

        })
        .catch((error) => {
          response.error = true
          resolve(response)

          console.log(error);
        });
    })
  }

  this.relatedArticleListDao = async (data) => {
    var response = {}
    return new Promise(function (resolve, reject) {
      articleModal.aggregate([{
            $match: {
              $and: [{
                  $expr: {
                    $eq: ["$is_active", 1]
                  }
                },
                {
                  $expr: {
                    $ne: ["$_id", data.article_id]
                  }
                }
              ]
            }
          },
          {
            $sort: {
              createdAt: -1
            }
          },
          // {
          //   $skip: data.articlePageNumber > 0 ? ((data.articlePageNumber - 1) * 10) : 0
          // },
          {
            $limit: 10
          },
          {
            $project: {
              _id: 1,
              thumbNail_url: 1,
              mediaType: 1,
              tag_id: 1,
              tag_name: 1,
              title: 1,
              description: {
                $substrBytes: ["$description", 0, 160]
              },
              source: 1,
              province_name: 1,
              createdAt: 1,
            }
          }
        ])
        .then((result) => {
          response.error = false
          response.result = result
          // console.log(result);
          resolve(response)

        })
        .catch((error) => {
          response.error = true
          resolve(response)

          console.log(error);
        });
    })
  }


  this.relatedArticleListDao1 = async (data) => {
    var response = {}
    return new Promise(function (resolve, reject) {
      articleModal.find({
          is_active: 1,
          _id: {
            $ne: data.article_id
          }
        }, {
          _id: 1,
          thumbNail_url: 1,
          mediaType: 1,
          tag_id: 1,
          tag_name: 1,
          title: 1,
          description: 1,
          source: 1,
          province_name: 1,
          createdAt: 1,
        }).sort({
          createdAt: -1
        })
        .limit(10)
        .then((result) => {
          response.error = false
          response.result = result
          // console.log(result);
          resolve(response)

        })
        .catch((error) => {
          response.error = true
          resolve(response)

          console.log(error);
        });
    })
  }

}