module.exports = function () {
    var JobCentreModel = require('../../modal/web/JobCentreModel')
    var MyProfileModal = require('../../modal/web/MyProfileModal')
    var jobCentreDraftModel = require('../../modal/web/jobCentreDraftModel')
    var JobFairModel = require('../../modal/admin/JobFairModel')
    var SubscriptionModel = require('../../modal/web/SubscriptionModel')
    var SubscriptionPlansModel = require('../../modal/admin/SubscriptionPlansModel')
    var notificationModel = require('../../modal/web/notificationModel')





    this.getTotalNotificationListDao = async (data) => {
        var response = {}
        return new Promise(function (resolve, reject) {

            notificationModel.find({
                    $and: [{
                        is_active: 1
                    }, {
                        uid: data.uid
                    }]
                })
                .count()
                .then((result) => {
                    response.error = false
                    response.result = result
                    // console.log(result);
                    resolve(response)

                })
                .catch((error) => {
                    response.error = true
                    resolve(response)

                    console.log(error);
                });
        })
    }


    this.getNotificationListDao = async (data) => {
        var response = {}
        return new Promise(function (resolve, reject) {

            notificationModel.aggregate([{
                        $match: {
                            $and: [{
                                $expr: {
                                    $eq: ["$is_active", 1]
                                }
                            }, {
                                uid: data.uid
                            }]
                        }
                    },
                    {
                        $sort: {
                            createdAt: -1
                        }
                    },
                    {
                        $skip: data.pageNumber > 0 ? ((data.pageNumber - 1) * 10) : 0
                    },
                    {
                        $limit: 10
                    },
                    {
                        $project: {
                            _id: 1,
                            uid: 1,
                            post_id: 1,
                            post_type: 1,
                            user_name: 1,
                            user_profile: 1,
                            post_module:1,
                            notification_message: 1,
                            read: 1,
                            is_active: 1,
                            createdAt: 1,
                            updatedAt: 1,
                        }
                    }
                ])
                // .skip(data.pageNumber > 0 ? ((data.pageNumber - 1) * 10) : 0)
                // .limit(10)
                .then((result) => {
                    response.error = false
                    response.result = result
                    // console.log(result);
                    resolve(response)

                })
                .catch((error) => {
                    response.error = true
                    resolve(response)

                    console.log(error);
                });
        })
    }



    this.getNotificationUnreadCountListDao = async (data) => {
        var response = {}
        return new Promise(function (resolve, reject) {

            notificationModel.find({
                    $and: [{
                            is_active: 1
                        }, {
                            uid: data.uid
                        },
                        {
                            read: 0
                        },
                    ]
                })
                .count()
                .then((result) => {
                    response.error = false
                    response.result = result
                    // console.log(result);
                    resolve(response)

                })
                .catch((error) => {
                    response.error = true
                    resolve(response)

                    console.log(error);
                });
        })
    }



    this.updateNotificationDao = async (data) => {
        var response = {}
        return new Promise(function (resolve, reject) {
            notificationModel.updateOne({
                    _id: data.id
                }, {
                    $set: {
                        read: 1
                    }
                })
                .then((result) => {
                    response.error = false
                    response.result = result
                    // console.log(result);
                    resolve(response)

                })
                .catch((error) => {
                    response.error = true
                    resolve(response)

                    console.log(error);
                });
        })
    }



    this.addNotificationDao = async (data) => {
        var response = {}
        return new Promise(function (resolve, reject) {
            const notificationModelObject = new notificationModel(data)
            notificationModelObject.save(function (error, result) {
                // console.log("res", result)
                if (error) {
                    console.log(error)
                    response.error = true
                } else {
                    response.error = false
                    response.data = result
                    global.io.emit("notifications",JSON.stringify(result))

                }
                resolve(response)
            })
        })
    }










}