const mongoose = require('mongoose')

const Schema = mongoose.Schema;

const subscriptionPlansSchema = new Schema({
    uid: {
        type: String,
        default: null
    },
    post_type: {
        type: String,
        default: null
    },
    subscription_fee: {
        type: mongoose.Types.Decimal128,
        default: null
    },
    subscription_validity: {
        type: Number,
        default: 0
    },
    subscription_validity_type: {
        type: String,
        default: null
    },
    is_active: {
        type: Number,
        default: 0
    },
    status: {
        type: String,
        default: null
    }
}, {
    timestamps: {
        createdAt: 'createdAt',
        updatedAt: 'updatedAt'
    },

}, {
    versionKey: false
})

const subscriptionPlans = mongoose.model('subscriptionPlans', subscriptionPlansSchema)
module.exports = subscriptionPlans