const mongoose = require("mongoose")

const Schema = mongoose.Schema;

const AdminUserSchema = new Schema({

    uid: {
        type: String,
        required: false,
        default: null
    },
    name: {
        type: String,
        required: [false, 'name is required'],
        default: null
    },
    email: {
        type: String,
        required: [false, 'email is required'],
        default: null
    },

    admin_type: {
        type: String,
        required: [false, 'admin_type is required'],
        default: null
    },

    sections: {
        type: Array,
        required: [false, 'sections is required'],
        default: []
    },
    is_active: {
        type: Number,
        default: 0
    },
    status: {
        type: String,
        required: [false, 'status is required'],
        default: null
    }
}, {
    timestamps: {
        createdAt: 'createdAt',
        updatedAt: 'updatedAt'
    },
}, {
    versionKey: false
});


const AdminUserModal = mongoose.model('adminuser', AdminUserSchema)

module.exports = AdminUserModal