const mongoose = require("mongoose")

const Schema = mongoose.Schema;

const ArticleSchema = new Schema({

    Uid: {
        type: String,
        required: false,
        default: null
    },
    thumbNail_url: {
        type: String,
        required: [false, 'thumbNail_url is required']
    },
    backGround_imageUrl: {
        type: String,
        required: [false, 'backGround_imageUrl is required']
    },

    mediaType: {
        type: String,
        required: [false, 'mediaType is required']
    },

    tag_id: {
        type: String,
        required: [false, 'tag_id is required']
    },
    tag_name: {
        type: String,
        required: [false, 'tag_name is required'],
        default: null
    },
    source: {
        type: String,
        required: [false, 'source is required'],
        default: null
    },
    province_name: {
        type: String,
        required: [false, 'province_name is required'],
        default: null
    },
    title: {
        type: String,
        required: [false, 'title is required']
    },
    description: {
        type: String,
        required: [false, 'description is required']
    },

    is_active: {
        type: Number,
        required: false,
        default: 0
    },

    number_of_likes: {
        type: Number,
        default: 0
    },
    number_of_comments: {
        type: Number,
        default: 0
    },
}, {
    timestamps: {
        createdAt: 'createdAt',
        updatedAt: 'updatedAt'
    },
}, {
    versionKey: false
});


const ArticleModal = mongoose.model('articles', ArticleSchema)

module.exports = ArticleModal