const mongoose = require('mongoose')

const Schema = mongoose.Schema;

const videosFeedSchema = new Schema({

    uid: {
        type: String,
        required: false,
        default: null
    },

    title: {
        type: String,
        required: false,
        default: null
    },
    video_url: {
        type: String,
        required: false,
        default: null
    },
    is_active: {
        type: Number,
        default: 0,
        required: false
    },
}, {
    timestamps: {
        createdAt: 'createdAt',
        updatedAt: 'updatedAt'
    }
}, {
    versionKey: false
})

const videosFeedModel = mongoose.model('videosFeed', videosFeedSchema)
module.exports = videosFeedModel