const mongoose = require('mongoose')

const Schema = mongoose.Schema;

const bazaarCitySchema = new Schema({
    uid: {
        type: String,
        default: null
    },
    item_name: {
        type: String,
        default: null

    },
    item_images: {
        type: Array,
        default: []
    },
    category: {
        type: String,
        default: null
    },
    price: {
        type: Number,
        default: null
    },
    post_description: {
        type: String,
        default: null
    },
    province_name: {
        type: String,
        default: null
    },
    profile_photo: {
        type: String,
        default: null
    },

    full_name: {
        type: String,
        default: null
    },
    number_of_likes: {
        type: Number,
        default: 0
    },
    number_of_comments: {
        type: Number,
        default: 0
    },
    is_active: {
        type: Number,
        default: 0
    },
    status: {
        type: String,
        default: null
    }
}, {
    timestamps: {
        createdAt: 'createdAt',
        updatedAt: 'updatedAt'
    },

}, {
    versionKey: false
})

const bazaarCity = mongoose.model('bazaarCity', bazaarCitySchema)
module.exports = bazaarCity