const mongoose = require('mongoose')

const Schema = mongoose.Schema;

const jobCentreSchema = new Schema({
    uid: {
        type: String,
        default: null
    },
    job_id: {
        type: Number,
        default: 0
    },
    company_name: {
        type: String,
        default: null

    },
    contact_number: {
        type: String,
        default: null

    },
    company_address: {
        type: String,
        default: null
    },
    postal_code: {
        type: String,
        default: null
    },
    job_position: {
        type: String,
        default: null
    },
    job_description: {
        type: String,
        default: null
    },

    working_type: {
        type: String,
        default: 0
    },
    job_constraint: {
        type: String,
        default: null
    },
    number_of_position_available: {
        type: Number,
        default: null
    },
    salary_hour_Rate: {
        type: Number,
        default: null
    },
    industry: {
        type: String,
        default: 0
    },
    email_id: {
        type: String,
        default: null
    },
    city: {
        type: String,
        default: null
    },

    province_name: {
        type: String,
        default: null
    },
    skills_required: {
        type: String,
        default: null
    },

    No_of_hours_work_weekly: {
        type: Number,
        default: null
    },
    late_date_to_apply: {
        type: Date,
        default: null
    },
    website: {
        type: String,
        default: null
    },
    how_to_apply: {
        type: String,
        default: null
    },
    posted_by: {
        type: String,
        default: null
    },
    is_active: {
        type: Number,
        default: 0
    },
    payment_status: {
        type: String,
        default: null
    },
    end_time: {
        type:  Date,
        default: 0
    },
    payment_ref_id: {
        type: String,
        default: null
    },
    status: {
        type: String,
        default: null
    }
}, {
    timestamps: {
        createdAt: 'createdAt',
        updatedAt: 'updatedAt'
    },

}, {
    versionKey: false
})

const jobCentre = mongoose.model('jobCentre', jobCentreSchema)
module.exports = jobCentre