const express = require('express');
const app = express();
require('dotenv').config()


app.use((req, res, next) => {
    if (req.originalUrl === '/webhook') {
        console.log("req.originalUrl", req.originalUrl)
        next();
    } else {
        express.json()(req, res, next);
    }
});


const cors = require('cors')
const bodyParser = require('body-parser')

const mongoose = require('./config/dfConfig')

app.use(cors())

// app.use(bodyParser.json({
//     limit: '2mb'
// }))
app.use(bodyParser.urlencoded({
    limit: '2mb',
    extended: true
}))

app.use((req, res, next) => {
    if (req.originalUrl === '/webhook') {
        console.log("req.originalUrl body parser", req.originalUrl)
        next();
    } else {
        bodyParser.json({
            limit: '2mb'
        })(req, res, next);
    }
});

//   app.use((req, res, next) => {
//     if (req.originalUrl === '/webhook') {
//         console.log("req.originalUrl body parser",req.originalUrl)
//       next();
//     } else {
//         bodyParser.urlencoded({
//             limit: '2mb',
//             extended: true
//         })(req, res, next);
//     }
//   });




app.disable("x-powered-by")

app.use('/', function (request, response, next) {
    request.headers.lang = request.headers.lang || 'default'
    console.log('Method: ' + request.method + ' Route: ' + request.originalUrl + ' Body: ' +
        JSON.stringify(request.body)
    )
    next()
})
const http = require('http').Server(app)


var admin = require("firebase-admin");
var serviceAccount = require('./Auth/Key/mykapitbahay-firebase-adminsdk.json');

admin.initializeApp({
    credential: admin.credential.cert(serviceAccount)
});


async function Verifyauth(request, res, next) {
    var error = {}
    var response = {}
    try {
        var authorization = request.headers.authorization
        request.body.uid = 0;

        if (authorization == 'NoAuth') {
            switch (request.originalUrl) {
                case '/web/WhatsUpCanadaHome':
                    console.log('/web/WhatsUpCanadaHome')
                    request.body.uid = null;
                    next();
                    break;
                    case '/web/getArticleList':
                        console.log('/web/getArticleList')
                        request.body.uid = null;
                        next();
                        break;
                    case '/web/getProudlyPinoyList':
                    console.log('/web/getProudlyPinoyList')
                    request.body.uid = null;
                    next();
                    break;
                    case '/web/getPodcastList':
                    console.log('/web/getPodcastList')
                    request.body.uid = null;
                    next();
                    break;
                    case '/web/getVideoFeedList':
                    console.log('/web/getVideoFeedList')
                    request.body.uid = null;
                    next();
                    break;      
                case '/web/viewOneArticle':
                    console.log('/web/viewOneArticle')
                    request.body.uid = null;
                    next();
                    break;
                case '/web/viewPodcast':
                    console.log('/web/viewPodcast')
                    request.body.uid = null;
                    next();
                    break;
                case '/web/relatedPodcastList':
                    console.log('/web/relatedPodcastList')
                    request.body.uid = null;
                    next();
                    break;
                case '/web/relatedArticleList':
                    console.log('/web/relatedArticleList')
                    request.body.uid = null;
                    next();
                    break;
                case '/web/newPinoysArticleList':
                    console.log('/web/newPinoysArticleList')
                    request.body.uid = null;
                    next();
                    break;
                case '/web/newPinoysArticleDetails':
                    console.log('/web/newPinoysArticleDetails')
                    request.body.uid = null;
                    next();
                    break;
                case '/web/newPinoysRelatedArticles':
                    console.log('/web/newPinoysRelatedArticles')
                    request.body.uid = null;
                    next();
                    break;
                case '/web/newPinoysHomeRelatedArticles':
                    console.log('/web/newPinoysHomeRelatedArticles')
                    request.body.uid = null;
                    next();
                    break;
                    case '/web/UserSurveyList':
                    console.log('/web/UserSurveyList')
                    request.body.uid = null;
                    next();
                    break;
                default:
                    request.body.uid = 0;
                    break;
            }
        }
        if (request.body.uid == 0) {

            var idToken = authorization
            admin
                .auth()
                .verifyIdToken(idToken)
                .then((decodedToken) => {
                    // See the UserRecord reference doc for the contents of userRecord.
                    const uid = decodedToken.uid;
                    // console.log("auth details",decodedToken)
                    // console.log(`Successfully fetched user data: ${uid}`);
                    // response.error = "false"
                    // response.status = "200"
                    // response.result = uid
                    console.log("auth success", decodedToken.uid)
                    request.body.uid = decodedToken.uid
                    next()
                })
                .catch((error) => {
                    console.log('Error fetching user data:', error);
                    response.error = "true"
                    response.status = "401"
                    response.message = "UNAUTHORIZED"
                    // console.log(error)
                    return res.status(401).send(response)
                });
        }
    } catch (err) {
        error.error = "true"
        error.status = "401"
        error.message = "UNAUTHORIZED"
        console.log("service error", err)
        return res.status(401).send(error)
    }
}



app.admin = admin
app.Verifyauth = Verifyauth



//admin routes

require('./routes/admin/ArticleRoutes')(app)
require('./routes/admin/TagRoutes')(app)
require('./routes/admin/ProudlyPinoyRoutes')(app)
require('./routes/admin/PodcastRoutes')(app)
require('./routes/admin/PodcastEpisodesRoutes')(app)
require('./routes/admin/VideosFeedsRoutes')(app)
require('./routes/admin/NewPinoysRoute')(app)
require('./routes/admin/NiknokRoutes')(app)
require('./routes/admin/ProvincesNameRoutes')(app)
require('./routes/admin/ShoutOutsRoutes')(app)
require('./routes/admin/CategoryRoutes')(app)
require('./routes/admin/AdminUserRoutes')(app)
require('./routes/admin/SurveyRoutes')(app)
require('./routes/admin/PinoyPreneursRoutes')(app)
require('./routes/admin/JobCentreRoutes')(app)
require('./routes/admin/SubscriptionRoutes')(app)
require('./routes/admin/goodVibesRoutes')(app)


//web routes

require('./routes/web/WhatsUpRoutes')(app)
require('./routes/web/MyProfileRoutes')(app)
require('./routes/web/FoodTripRoutes')(app)
require('./routes/web/LikesRoutes')(app)
require('./routes/web/CommentRoutes')(app)
require('./routes/web/NiknokRoutes')(app)
require('./routes/web/HomeRoutes')(app)
require('./routes/web/NewPinoysRoutes')(app)
require('./routes/web/TambayanRoutes')(app)
require('./routes/web/DonasyanRoutes')(app)
require('./routes/web/FeaturePostRoutes')(app)
require('./routes/web/PinoyPreneursRoutes')(app)
require('./routes/web/P-NationCalendarRoutes')(app)
require('./routes/web/bazaarCityRoutes')(app)
require('./routes/web/jobCentreRoutes')(app)
require('./routes/web/notificationRoutes')(app)
require('./routes/web/RatingRoutes')(app)




port = process.env.PORT || 5000;
const server = http.listen(port, () => {
    console.log(`listening in port ${port}`)
})

const io = require('socket.io')(server, { cors: { origin:'*' } });

io.on('connection', (client) => {
    client.on('online', roomId => {
        client.join(roomId);
      
    });
    client.on('unreadcount',()=>{
        client.emit({"error":"false"})
    })
      
});

global.io = io;