module.exports = function (app, validator) {
    const {
      check,
      validationResult
    } = require('express-validator/check')
    var userPath = '/admin'
    // require('../../utils/error.js')()
  
    var userController = require('../../controller/admin/AdminWhatsUpController')
    require('dotenv').config()
    var userControllerObject = new userController()

    const multer = require('multer')

    const storage = multer.diskStorage({
      destination:function(req,file, cb) {
        cb(null, './uploads/')
      },
      filename: function(req, file, cb) {
        cb(null, Date.now() + file.originalname);
      }
    });
    const fileFilter =(req, file, cb)=>{
      //reject
      if(file.mimetype ==='image/jpeg' || file.mimetype ==='image/png'){
        cb(null, true);
      }
      else{
      cb(null, false);
      }
    }

  const upload= multer({storage :storage, limits : {
    fileSize: 1024*1024*50
  },
  fileFilter:fileFilter
  });
    app.post(userPath + '/addArticle', upload.single('articleImage'),
    // [
    //   check('label').exists().withMessage('label is Empty'),
    //   check('title').exists().withMessage('title is Empty'),
    //   check('description').optional().exists().withMessage('description is Empty'),
    //   check('media').optional().exists().withMessage('media is Empty'),
    //   check('mediaType').optional().exists().withMessage('mediaType is Empty'),
      // check('email').exists().isLength({ min: 1 }).withMessage('email is Empty')
    // ]
    
    (request, response, next) => {
      // console.log("fileNAME",request.file)
      const errors = validationResult(request)
  console.log("l",request.body)
      if (!errors.isEmpty()) {
        console.log(errors)
        var errorArray = errors.array()
        var errorResponse = {}
        errorResponse.error = true
        errorResponse.message = errorArray[0].msg
        return response.send(errorResponse)
      }
      userControllerObject.addArticle(request, function (results) {
        return response.send(results)
      })
    })

    app.post(userPath + '/getArticleList',(request,response)=>{
      const errors=validationResult(request)
      if(!errors.isEmpty()){
          var errorArray =errors.array()
          var errorResponse = {}
          errorResponse.error = true
          errorResponse.message = errorArray[0].msg
          return response.send(errorResponse)
      }
      userControllerObject.getArticle(request, function (results) {
          return response.send(results)
        })
  })

  app.post(userPath + '/deleteArticleList',[
    // check('email').exists().isLength({ min: 1 }).withMessage('email is Empty'),
  ], (request, response) => {
    const errors = validationResult(request)
    if (!errors.isEmpty()) {
        var errorArray = errors.array()
        var errorResponse = {}
        errorResponse.error = true
        errorResponse.message = errorArray[0].msg
        return response.send(errorResponse)
    }
   
    userControllerObject.deleteArticleController(request, function(results) {
        return response.send(results)
    })
  })

  app.post(userPath + '/editArticleList',[
    // check('email').exists().isLength({ min: 1 }).withMessage('email is Empty'),
  ], (request, response) => {
    const errors = validationResult(request)
    if (!errors.isEmpty()) {
        var errorArray = errors.array()
        var errorResponse = {}
        errorResponse.error = true
        errorResponse.message = errorArray[0].msg
        return response.send(errorResponse)
    }
   
    userControllerObject.editArticleController(request, function(results) {
        return response.send(results)
    })
  })

  app.post(userPath + '/addTagList',[
    // check('email').exists().isLength({ min: 1 }).withMessage('email is Empty'),
  ], (request, response) => {
    const errors = validationResult(request)
    if (!errors.isEmpty()) {
        var errorArray = errors.array()
        var errorResponse = {}
        errorResponse.error = true
        errorResponse.message = errorArray[0].msg
        return response.send(errorResponse)
    }
   
    userControllerObject.addTagController(request, function(results) {
        return response.send(results)
    })
  })

  app.post(userPath + '/getTagList',[
    // check('email').exists().isLength({ min: 1 }).withMessage('email is Empty'),
  ], (request, response) => {
    const errors = validationResult(request)
    if (!errors.isEmpty()) {
        var errorArray = errors.array()
        var errorResponse = {}
        errorResponse.error = true
        errorResponse.message = errorArray[0].msg
        return response.send(errorResponse)
    }
   
    userControllerObject.getTagController(request, function(results) {
        return response.send(results)
    })
  })

  app.post(userPath + '/deleteOneTag',[
    // check('email').exists().isLength({ min: 1 }).withMessage('email is Empty'),
  ], (request, response) => {
    const errors = validationResult(request)
    if (!errors.isEmpty()) {
        var errorArray = errors.array()
        var errorResponse = {}
        errorResponse.error = true
        errorResponse.message = errorArray[0].msg
        return response.send(errorResponse)
    }
   
    userControllerObject.deleteTagController(request, function(results) {
        return response.send(results)
    })
  })
    app.post(userPath + '/addProudlyPinoy',
    (request, response, next) => {
      // console.log("fileNAME",request.file)
      const errors = validationResult(request)
  console.log("l",request.body)
      if (!errors.isEmpty()) {
        console.log(errors)
        var errorArray = errors.array()
        var errorResponse = {}
        errorResponse.error = true
        errorResponse.message = errorArray[0].msg
        return response.send(errorResponse)
      }
      userControllerObject.addProudlyPinoy(request, function (results) {
        return response.send(results)
      })
    })

    app.post(userPath + '/addPodcast',
    (request, response, next) => {
      // console.log("fileNAME",request.file)
      const errors = validationResult(request)
  console.log("l",request.body)
      if (!errors.isEmpty()) {
        console.log(errors)
        var errorArray = errors.array()
        var errorResponse = {}
        errorResponse.error = true
        errorResponse.message = errorArray[0].msg
        return response.send(errorResponse)
      }
      userControllerObject.addPodcast(request, function (results) {
        return response.send(results)
      })
    })
}