module.exports = function (app, validator) {
    const {
      check,
      validationResult
    } = require('express-validator')
    var userPath = '/admin'
    // require('../../utils/error.js')()
  
    var userController = require('../../controller/admin/NiknokController')
    require('dotenv').config()
    var userControllerObject = new userController()

    const multer = require('multer')

    const storage = multer.diskStorage({
      destination:function(req,file, cb) {
        cb(null, './uploads/')
      },
      filename: function(req, file, cb) {
        cb(null, Date.now() + file.originalname);
      }
    });
    const fileFilter =(req, file, cb)=>{
      //reject
      if(file.mimetype ==='image/jpeg' || file.mimetype ==='image/png'){
        cb(null, true);
      }
      else{
      cb(null, false);
      }
    }

  const upload= multer({storage :storage, limits : {
    fileSize: 1024*1024*50
  },
  fileFilter:fileFilter
  });
    app.post(userPath + '/addNiknok', upload.single('articleImage'),app.Verifyauth, 
    // [
    //   check('label').exists().withMessage('label is Empty'),
    //   check('title').exists().withMessage('title is Empty'),
    //   check('description').optional().exists().withMessage('description is Empty'),
    //   check('media').optional().exists().withMessage('media is Empty'),
    //   check('mediaType').optional().exists().withMessage('mediaType is Empty'),
      // check('email').exists().isLength({ min: 1 }).withMessage('email is Empty')
    // ]
    
    (request, response, next) => {
      // console.log("fileNAME",request.file)
      const errors = validationResult(request)
      if (!errors.isEmpty()) {
        var errorArray =errors.array()
        var errorResponse = {}
        errorResponse.error = true
        errorResponse.message = errorArray[0].msg
        response.status(404);
        return response.send(errorResponse)
      }
      userControllerObject.addNiknok(request, function (results) {
        if(results.error){
          response.status(results.statusCode);
          return response.send(results)
      }else{
          return response.send(results)
      }      })
    })

    app.post(userPath + '/getNiknokList',app.Verifyauth, (request,response)=>{
      const errors=validationResult(request)
      if(!errors.isEmpty()){
        var errorArray =errors.array()
        var errorResponse = {}
        errorResponse.error = true
        errorResponse.message = errorArray[0].msg
        response.status(404);
        return response.send(errorResponse)
      }
      userControllerObject.getNiknokList(request, function (results) {
        if(results.error){
          response.status(results.statusCode);
          return response.send(results)
      }else{
          return response.send(results)
      }        })
  })



    app.post(userPath + '/getNiknokImages',app.Verifyauth, (request,response)=>{
      const errors=validationResult(request)
      if(!errors.isEmpty()){
        var errorArray =errors.array()
        var errorResponse = {}
        errorResponse.error = true
        errorResponse.message = errorArray[0].msg
        response.status(404);
        return response.send(errorResponse)
      }
      userControllerObject.getNiknok(request, function (results) {
        if(results.error){
          response.status(results.statusCode);
          return response.send(results)
      }else{
          return response.send(results)
      }        })
  })

 
  app.post(userPath + '/deleteNiknokList',app.Verifyauth, [
    // check('email').exists().isLength({ min: 1 }).withMessage('email is Empty'),
  ], (request, response) => {
    const errors = validationResult(request)
    if (!errors.isEmpty()) {
      var errorArray =errors.array()
      var errorResponse = {}
      errorResponse.error = true
      errorResponse.message = errorArray[0].msg
      response.status(404);
      return response.send(errorResponse)
    }
   
    userControllerObject.deleteNiknokController(request, function(results) {
      if(results.error){
        response.status(results.statusCode);
        return response.send(results)
    }else{
        return response.send(results)
    }    })
  })

  app.post(userPath + '/editNiknokList',app.Verifyauth, [
    // check('email').exists().isLength({ min: 1 }).withMessage('email is Empty'),
  ], (request, response) => {
    const errors = validationResult(request)
    if (!errors.isEmpty()) {
      var errorArray =errors.array()
      var errorResponse = {}
      errorResponse.error = true
      errorResponse.message = errorArray[0].msg
      response.status(404);
      return response.send(errorResponse)
    }
   
    userControllerObject.editNiknokController(request, function(results) {
      if(results.error){
        response.status(results.statusCode);
        return response.send(results)
    }else{
        return response.send(results)
    }    })
  })

 
  
}