module.exports = function (app) {
    const {
        check,
        validationResult
    } = require('express-validator')
    const userPath = '/web'
    const commentController = require('../../controller/web/CommentController')
    const commentRoutesObject = new commentController()

    require('dotenv').config()

    app.post(userPath + "/comments", app.Verifyauth, (request, response) => {
        const errors = validationResult(request)
        if (!errors.isEmpty()) {
            const errorArray = errors.array()
            const errorResponse = {}
            errorResponse = true
            errorResponse.message = errorArray[0].msg
            response.status(404);
            return response.send(errorResponse)
        }
        commentRoutesObject.postComments(request, function (results) {
            if (results.error) {
                response.status(results.statusCode);
                return response.send(results)
            } else {
                return response.send(results)
            }
        })
    })

    app.post(userPath + "/commentsList", app.Verifyauth, (request, response) => {
        const errors = validationResult(request)
        if (!errors.isEmpty()) {
            const errorArray = errors.array()
            const errorResponse = {}
            errorResponse = true
            errorResponse.message = errorArray[0].msg
            response.status(404);
            return response.send(errorResponse)
        }
        commentRoutesObject.getCommentsList(request, function (results) {
            if (results.error) {
                response.status(results.status);
                return response.send(results)
            } else {
                return response.send(results)
            }
        })
    })

    app.post(userPath + "/getReplyList", (request, response) => {
        const errors = validationResult(request)
        if (!errors.isEmpty()) {
            const errorArray = errors.array()
            const errorResponse = {}
            errorResponse = true
            errorResponse.message = errorArray[0].msg
            response.status(404);
            return response.send(errorResponse)
        }
        commentRoutesObject.getReplyList(request, function (results) {
            if (results.error) {
                response.status(results.status);
                return response.send(results)
            } else {
                return response.send(results)
            }
        })
    })

}