module.exports = function(app){
const { check, validationResult} =require('express-validator')
const { append } = require('express/lib/response')
const userPath = '/web'
const foodTripController = require('../../controller/web/FoodTripController')

require('dotenv').config()

const foodTripControllerObject = new foodTripController()

app.post(userPath + "/PostfoodTrip" ,app.Verifyauth, (request,response)=>{
    const errors =validationResult(request)
    if(!errors.isEmpty()){
        const errorArray =errors.array()
        const errorResponse ={}
        errorResponse = true
        errorResponse.message = errorArray[0].msg
        response.status(404);
        return response .send(errorResponse)
    }
    foodTripControllerObject.addfoodTripController(request, function(results){
        if(results.error){
            response.status(results.statusCode);
            return response.send(results)
        }else{
            return response.send(results)
        }    })
})


app.post(userPath + "/ListfoodTrip" ,app.Verifyauth, (request,response)=>{
    const errors =validationResult(request)
    if(!errors.isEmpty()){
        const errorArray =errors.array()
        const errorResponse ={}
        errorResponse = true
        errorResponse.message = errorArray[0].msg
        response.status(404);
        return response .send(errorResponse)
    }
    foodTripControllerObject.listFoodTripController(request, function(results){
        if(results.error){
            response.status(results.statusCode);
            return response.send(results)
        }else{
            return response.send(results)
        }    })
})

app.post(userPath + "/getOnefoodTrip" ,app.Verifyauth, (request,response)=>{
    const errors =validationResult(request)
    if(!errors.isEmpty()){
        const errorArray =errors.array()
        const errorResponse ={}
        errorResponse = true
        errorResponse.message = errorArray[0].msg
        response.status(404);
        return response .send(errorResponse)
    }
    foodTripControllerObject.getOneFoodTripController(request, function(results){
        if(results.error){
            response.status(results.statusCode);
            return response.send(results)
        }else{
            return response.send(results)
        }    })
})



app.post(userPath + "/getFeaturePostList" ,app.Verifyauth, (request,response)=>{
    const errors =validationResult(request)
    if(!errors.isEmpty()){
        const errorArray =errors.array()
        const errorResponse ={}
        errorResponse = true
        errorResponse.message = errorArray[0].msg
        response.status(404);
        return response .send(errorResponse)
    }
    foodTripControllerObject.getFeaturePostListController(request, function(results){
        if(results.error){
            response.status(results.statusCode);
            return response.send(results)
        }else{
            return response.send(results)
        }    })
})

app.post(userPath + "/shareFoodTripPost" ,app.Verifyauth, (request,response)=>{
    const errors =validationResult(request)
    if(!errors.isEmpty()){
        const errorArray =errors.array()
        const errorResponse ={}
        errorResponse = true
        errorResponse.message = errorArray[0].msg
        response.status(404);
        return response .send(errorResponse)
    }
    foodTripControllerObject.shareFoodTripPostController(request, function(results){
        if(results.error){
            response.status(results.statusCode);
            return response.send(results)
        }else{
            return response.send(results)
        }    })
})


app.post(userPath + "/recipeSharingList" ,app.Verifyauth, (request,response)=>{
    const errors =validationResult(request)
    if(!errors.isEmpty()){
        const errorArray =errors.array()
        const errorResponse ={}
        errorResponse = true
        errorResponse.message = errorArray[0].msg
        response.status(404);
        return response .send(errorResponse)
    }
    foodTripControllerObject.recipeSharingListController(request, function(results){
        if(results.error){
            response.status(results.statusCode);
            return response.send(results)
        }else{
            return response.send(results)
        }    })
})



}


