module.exports = function (app) {
    const {
        check,
        validationResult
    } = require('express-validator')
    const userPath = '/web'
    const myProfileController = require('../../controller/web/MyProfileController')
    require('dotenv').config()
    const myprofileControllerObject = new myProfileController()

    app.post(userPath + '/addUser', (request, response) => {
        const errors = validationResult(request)
        if (!errors.isEmpty()) {
            const errorArray = errors.array()
            const errorResponse = {}
            errorResponse = true
            errorResponse.message = errorArray[0].msg
            response.status(404);
            return response.send(errorResponse)
        }
        myprofileControllerObject.addMyProfileController(request, function (results) {
            if (results.error) {
                response.status(results.statusCode);
                return response.send(results)
            } else {
                return response.send(results)
            }
        })
    })

    app.post(userPath + '/getOneUserProfile',app.Verifyauth,  (request, response) => {
        const errors = validationResult(request)
        if (!errors.isEmpty()) {
            const errorArray = errors.array()
            const errorResponse = {}
            errorResponse = true
            errorResponse.message = errorArray[0].msg
            response.status(404);
            return response.send(errorResponse)
        }
        myprofileControllerObject.getOneProfileController(request, function (results) {
            if (results.error) {
                response.status(results.statusCode);
                return response.send(results)
            } else {
                return response.send(results)
            }
        })
    })

    
    app.post(userPath + '/editMyProfile',app.Verifyauth, [
        // check('search').exists().isLength({ min: 1 }).withMessage('id is Empty'),
    ], (request, response) => {
        const errors = validationResult(request)
        if (!errors.isEmpty()) {
            var errorArray = errors.array()
            var errorResponse = {}
            errorResponse.error = true
            errorResponse.message = errorArray[0].msg
            response.status(404);
            return response.send(errorResponse)
        }
        myprofileControllerObject.editMyProfileController(request, function (results) {
            if (results.error) {
                response.status(results.statusCode);
                return response.send(results)
            } else {
                return response.send(results)
            }
        })
    })

    app.post(userPath + '/userFoodTripList', app.Verifyauth, [
        // check('search').exists().isLength({ min: 1 }).withMessage('id is Empty'),
    ], (request, response) => {
        const errors = validationResult(request)
        if (!errors.isEmpty()) {
            var errorArray = errors.array()
            var errorResponse = {}
            errorResponse.error = true
            errorResponse.message = errorArray[0].msg
            response.status(404);
            return response.send(errorResponse)
        }
        myprofileControllerObject.userFoodTripListController(request, function (results) {
            if (results.error) {
                response.status(results.statusCode);
                return response.send(results)
            } else {
                return response.send(results)
            }
        })
    })


    app.post(userPath + '/getOneFoodTripPost', app.Verifyauth, [
        // check('search').exists().isLength({ min: 1 }).withMessage('id is Empty'),
    ], (request, response) => {
        const errors = validationResult(request)
        if (!errors.isEmpty()) {
            var errorArray = errors.array()
            var errorResponse = {}
            errorResponse.error = true
            errorResponse.message = errorArray[0].msg
            response.status(404);
            return response.send(errorResponse)
        }
        myprofileControllerObject.getOnePostController(request, function (results) {
            if (results.error) {
                response.status(results.statusCode);
                return response.send(results)
            } else {
                return response.send(results)
            }
        })
    })


    app.post(userPath + '/editOneFoodTripPost', app.Verifyauth, [
        // check('search').exists().isLength({ min: 1 }).withMessage('id is Empty'),
    ], (request, response) => {
        const errors = validationResult(request)
        if (!errors.isEmpty()) {
            var errorArray = errors.array()
            var errorResponse = {}
            errorResponse.error = true
            errorResponse.message = errorArray[0].msg
            response.status(404);
            return response.send(errorResponse)
        }
        myprofileControllerObject.editOnePostController(request, function (results) {
            if (results.error) {
                response.status(results.statusCode);
                return response.send(results)
            } else {
                return response.send(results)
            }
        })
    })


    app.post(userPath + '/deleteOneFoodTripPost', app.Verifyauth, [
        // check('search').exists().isLength({ min: 1 }).withMessage('id is Empty'),
    ], (request, response) => {
        const errors = validationResult(request)
        if (!errors.isEmpty()) {
            var errorArray = errors.array()
            var errorResponse = {}
            errorResponse.error = true
            errorResponse.message = errorArray[0].msg
            response.status(404);
            return response.send(errorResponse)
        }
        myprofileControllerObject.deleteOnePostController(request, function (results) {
            if (results.error) {
                response.status(results.statusCode);
                return response.send(results)
            } else {
                return response.send(results)
            }
        })
    })

    app.post(userPath + '/userBazaarCityList', app.Verifyauth, [
        // check('search').exists().isLength({ min: 1 }).withMessage('id is Empty'),
    ], (request, response) => {
        const errors = validationResult(request)
        if (!errors.isEmpty()) {
            var errorArray = errors.array()
            var errorResponse = {}
            errorResponse.error = true
            errorResponse.message = errorArray[0].msg
            response.status(404);
            return response.send(errorResponse)
        }
        myprofileControllerObject.userBazaarCityListController(request, function (results) {
            if (results.error) {
                response.status(results.statusCode);
                return response.send(results)
            } else {
                return response.send(results)
            }
        })
    })


    app.post(userPath + '/getOneBazaarCityPost', app.Verifyauth, [
        // check('search').exists().isLength({ min: 1 }).withMessage('id is Empty'),
    ], (request, response) => {
        const errors = validationResult(request)
        if (!errors.isEmpty()) {
            var errorArray = errors.array()
            var errorResponse = {}
            errorResponse.error = true
            errorResponse.message = errorArray[0].msg
            response.status(404);
            return response.send(errorResponse)
        }
        myprofileControllerObject.getOneBazaarCityPostController(request, function (results) {
            if (results.error) {
                response.status(results.statusCode);
                return response.send(results)
            } else {
                return response.send(results)
            }
        })
    })


    app.post(userPath + '/deleteOneBazaarCityPost', app.Verifyauth, [
        // check('search').exists().isLength({ min: 1 }).withMessage('id is Empty'),
    ], (request, response) => {
        const errors = validationResult(request)
        if (!errors.isEmpty()) {
            var errorArray = errors.array()
            var errorResponse = {}
            errorResponse.error = true
            errorResponse.message = errorArray[0].msg
            response.status(404);
            return response.send(errorResponse)
        }
        myprofileControllerObject.deleteOneBazaarCityPostController(request, function (results) {
            if (results.error) {
                response.status(results.statusCode);
                return response.send(results)
            } else {
                return response.send(results)
            }
        })
    })

    app.post(userPath + '/editOneBazaarCityPost', app.Verifyauth, [
        // check('search').exists().isLength({ min: 1 }).withMessage('id is Empty'),
    ], (request, response) => {
        const errors = validationResult(request)
        if (!errors.isEmpty()) {
            var errorArray = errors.array()
            var errorResponse = {}
            errorResponse.error = true
            errorResponse.message = errorArray[0].msg
            response.status(404);
            return response.send(errorResponse)
        }
        myprofileControllerObject.editOneBazaarCityPostController(request, function (results) {
            if (results.error) {
                response.status(results.statusCode);
                return response.send(results)
            } else {
                return response.send(results)
            }
        })
    })
    app.post(userPath + '/ListUserByeBuyItem', app.Verifyauth,[
        // check('search').exists().isLength({ min: 1 }).withMessage('id is Empty'),
    ], (request, response) => {
        const errors = validationResult(request)
        if (!errors.isEmpty()) {
            var errorArray = errors.array()
            var errorResponse = {}
            errorResponse.error = true
            errorResponse.message = errorArray[0].msg
            response.status(404);
            return response.send(errorResponse)
        }
        myprofileControllerObject.userBuyBuyItemsListController(request, function (results) {
            if (results.error) {
                response.status(results.statusCode);
                return response.send(results)
            } else {
                return response.send(results)
            }
        })
    })
    app.post(userPath + '/viewOneUserByeBuyItem',app.Verifyauth, [
        // check('search').exists().isLength({ min: 1 }).withMessage('id is Empty'),
    ], (request, response) => {
        const errors = validationResult(request)
        if (!errors.isEmpty()) {
            var errorArray = errors.array()
            var errorResponse = {}
            errorResponse.error = true
            errorResponse.message = errorArray[0].msg
            response.status(404);
            return response.send(errorResponse)
        }
        myprofileControllerObject.viewUserBuyBuyItemController(request, function (results) {
            if (results.error) {
                response.status(results.statusCode);
                return response.send(results)
            } else {
                return response.send(results)
            }
        })
    })
    
    app.post(userPath + '/editOneByeBuyItem',app.Verifyauth, [
        // check('search').exists().isLength({ min: 1 }).withMessage('id is Empty'),
    ], (request, response) => {
        const errors = validationResult(request)
        if (!errors.isEmpty()) {
            var errorArray = errors.array()
            var errorResponse = {}
            errorResponse.error = true
            errorResponse.message = errorArray[0].msg
            response.status(404);
            return response.send(errorResponse)
        }
        myprofileControllerObject.EditUserBuyBuyItemController(request, function (results) {
            if (results.error) {
                response.status(results.statusCode);
                return response.send(results)
            } else {
                return response.send(results)
            }
        })
    })


    app.post(userPath + '/DeleteUserBuyBuyItem',app.Verifyauth, [
        // check('search').exists().isLength({ min: 1 }).withMessage('id is Empty'),
    ], (request, response) => {
        const errors = validationResult(request)
        if (!errors.isEmpty()) {
            var errorArray = errors.array()
            var errorResponse = {}
            errorResponse.error = true
            errorResponse.message = errorArray[0].msg
            response.status(404);
            return response.send(errorResponse)
        }
        myprofileControllerObject.DeleteUserBuyBuyItemController(request, function (results) {
            if (results.error) {
                response.status(results.statusCode);
                return response.send(results)
            } else {
                return response.send(results)
            }
        })
    })



    app.post(userPath + '/getUsersList',app.Verifyauth,  [
        // check('search').exists().isLength({ min: 1 }).withMessage('id is Empty'),
    ], (request, response) => {
        const errors = validationResult(request)
        if (!errors.isEmpty()) {
            var errorArray = errors.array()
            var errorResponse = {}
            errorResponse.error = true
            errorResponse.message = errorArray[0].msg
            response.status(404);
            return response.send(errorResponse)
        }
        myprofileControllerObject.getUsersListController(request, function (results) {
            if (results.error) {
                response.status(results.statusCode);
                return response.send(results)
            } else {
                return response.send(results)
            }
        })
    })



    app.post(userPath + '/userConnectRequest',app.Verifyauth,  [
        // check('search').exists().isLength({ min: 1 }).withMessage('id is Empty'),
    ], (request, response) => {
        const errors = validationResult(request)
        if (!errors.isEmpty()) {
            var errorArray = errors.array()
            var errorResponse = {}
            errorResponse.error = true
            errorResponse.message = errorArray[0].msg
            response.status(404);
            return response.send(errorResponse)
        }
        myprofileControllerObject.userConnectRequestController(request, function (results) {
            if (results.error) {
                response.status(results.statusCode);
                return response.send(results)
            } else {
                return response.send(results)
            }
        })
    })



    app.post(userPath + '/getUserConnectionList',app.Verifyauth,  [
        // check('search').exists().isLength({ min: 1 }).withMessage('id is Empty'),
    ], (request, response) => {
        const errors = validationResult(request)
        if (!errors.isEmpty()) {
            var errorArray = errors.array()
            var errorResponse = {}
            errorResponse.error = true
            errorResponse.message = errorArray[0].msg
            response.status(404);
            return response.send(errorResponse)
        }
        myprofileControllerObject.getUserConnectionList(request, function (results) {
            if (results.error) {
                response.status(results.statusCode);
                return response.send(results)
            } else {
                return response.send(results)
            }
        })
    })


    app.post(userPath + '/userDisconnectRequest',app.Verifyauth,  [
        // check('search').exists().isLength({ min: 1 }).withMessage('id is Empty'),
    ], (request, response) => {
        const errors = validationResult(request)
        if (!errors.isEmpty()) {
            var errorArray = errors.array()
            var errorResponse = {}
            errorResponse.error = true
            errorResponse.message = errorArray[0].msg
            response.status(404);
            return response.send(errorResponse)
        }
        myprofileControllerObject.userDisconnectRequestController(request, function (results) {
            if (results.error) {
                response.status(results.statusCode);
                return response.send(results)
            } else {
                return response.send(results)
            }
        })
    })





}