module.exports = function(app){
    const { check, validationResult} =require('express-validator')
    const userPath = '/web'
    const tambayanController = require('../../controller/web/TambayanController')
    const tambayanRoutesObject = new tambayanController()

    require('dotenv').config()


    app.post(userPath + "/PostTambayan" ,app.Verifyauth, (request,response)=>{
        const errors =validationResult(request)
        if(!errors.isEmpty()){
            const errorArray =errors.array()
            const errorResponse ={}
            errorResponse = true
            errorResponse.message = errorArray[0].msg
            response.status(404);
            return response .send(errorResponse)
        }
        tambayanRoutesObject.tambayanPostController(request, function(results){
            if(results.error){
                response.status(results.statusCode);
                return response.send(results)
            }else{
                return response.send(results)
            }
        })
    })

    app.post(userPath + "/tambayanList" ,app.Verifyauth, (request,response)=>{
        const errors =validationResult(request)
        if(!errors.isEmpty()){
            const errorArray =errors.array()
            const errorResponse ={}
            errorResponse = true
            errorResponse.message = errorArray[0].msg
            response.status(404);
            return response .send(errorResponse)
        }
        tambayanRoutesObject.tambayanListController(request, function(results){
            if(results.error){
                response.status(results.statusCode);
                return response.send(results)
            }else{
                return response.send(results)
            }
        })
    })

    app.post(userPath + "/viewTambayanPost" ,app.Verifyauth, (request,response)=>{
        const errors =validationResult(request)
        if(!errors.isEmpty()){
            const errorArray =errors.array()
            const errorResponse ={}
            errorResponse = true
            errorResponse.message = errorArray[0].msg
            response.status(404);
            return response .send(errorResponse)
        }
        tambayanRoutesObject.viewPostController(request, function(results){
            if(results.error){
                response.status(results.statusCode);
                return response.send(results)
            }else{
                return response.send(results)
            }
        })
    })

    app.post(userPath + "/editOneTambayanPost" ,app.Verifyauth, (request,response)=>{
        const errors =validationResult(request)
        if(!errors.isEmpty()){
            const errorArray =errors.array()
            const errorResponse ={}
            errorResponse = true
            errorResponse.message = errorArray[0].msg
            response.status(404);
            return response .send(errorResponse)
        }
        tambayanRoutesObject.editOneTambayanPostController(request, function(results){
            if(results.error){
                response.status(results.statusCode);
                return response.send(results)
            }else{
                return response.send(results)
            }
        })
    })


    app.post(userPath + "/deleteOneTambayanPost" ,app.Verifyauth, (request,response)=>{
        const errors =validationResult(request)
        if(!errors.isEmpty()){
            const errorArray =errors.array()
            const errorResponse ={}
            errorResponse = true
            errorResponse.message = errorArray[0].msg
            response.status(404);
            return response .send(errorResponse)
        }
        tambayanRoutesObject.deleteOneTambayanPostController(request, function(results){
            if(results.error){
                response.status(results.statusCode);
                return response.send(results)
            }else{
                return response.send(results)
            }
        })
    })


    
}