const {
    request
} = require('express')

module.exports = function (app) {
    const {
        check,
        validationResult
    } = require('express-validator')
    var userPath = '/web'
    var jobCentreController = require('../../controller/web/jobCentreController')
    require('dotenv').config()
    var jobCentreControllerObject = new jobCentreController()


    const bodyParser = require('body-parser')

    app.post(userPath + '/addJobPost', app.Verifyauth, [
        // check('search').exists().isLength({ min: 1 }).withMessage('id is Empty'),
    ], (request, response) => {
        const errors = validationResult(request)
        if (!errors.isEmpty()) {
            var errorArray = errors.array()
            var errorResponse = {}
            errorResponse.error = true
            errorResponse.message = errorArray[0].msg
            response.status(404);
            return response.send(errorResponse)
        }
        jobCentreControllerObject.addJobPostController(request, function (results) {
            if (results.error) {
                response.status(results.statusCode);
                return response.send(results)
            } else {
                return response.send(results)
            }
        })
    })





    app.post(userPath + '/getAllJobList', app.Verifyauth, [
        // check('search').exists().isLength({ min: 1 }).withMessage('id is Empty'),
    ], (request, response) => {
        const errors = validationResult(request)
        if (!errors.isEmpty()) {
            var errorArray = errors.array()
            var errorResponse = {}
            errorResponse.error = true
            errorResponse.message = errorArray[0].msg
            response.status(404);
            return response.send(errorResponse)
        }
        jobCentreControllerObject.getAllJobListController(request, function (results) {
            if (results.error) {
                response.status(results.statusCode);
                return response.send(results)
            } else {
                return response.send(results)
            }
        })
    })



    app.post(userPath + '/getOneJobPost', app.Verifyauth, [
        // check('search').exists().isLength({ min: 1 }).withMessage('id is Empty'),
    ], (request, response) => {
        const errors = validationResult(request)
        if (!errors.isEmpty()) {
            var errorArray = errors.array()
            var errorResponse = {}
            errorResponse.error = true
            errorResponse.message = errorArray[0].msg
            response.status(404);
            return response.send(errorResponse)
        }
        jobCentreControllerObject.getOneJobPostController(request, function (results) {
            if (results.error) {
                response.status(results.statusCode);
                return response.send(results)
            } else {
                return response.send(results)
            }
        })
    })

    app.post(userPath + '/addJobDraft', app.Verifyauth, [
        // check('search').exists().isLength({ min: 1 }).withMessage('id is Empty'),
    ], (request, response) => {
        const errors = validationResult(request)
        if (!errors.isEmpty()) {
            var errorArray = errors.array()
            var errorResponse = {}
            errorResponse.error = true
            errorResponse.message = errorArray[0].msg
            response.status(404);
            return response.send(errorResponse)
        }
        jobCentreControllerObject.addJobDraftController(request, function (results) {
            if (results.error) {
                response.status(results.statusCode);
                return response.send(results)
            } else {
                return response.send(results)
            }
        })
    })

    app.post(userPath + '/getOneJobDraft', app.Verifyauth, [
        // check('search').exists().isLength({ min: 1 }).withMessage('id is Empty'),
    ], (request, response) => {
        const errors = validationResult(request)
        if (!errors.isEmpty()) {
            var errorArray = errors.array()
            var errorResponse = {}
            errorResponse.error = true
            errorResponse.message = errorArray[0].msg
            response.status(404);
            return response.send(errorResponse)
        }
        jobCentreControllerObject.getOneJobDraftController(request, function (results) {
            if (results.error) {
                response.status(results.statusCode);
                return response.send(results)
            } else {
                return response.send(results)
            }
        })
    })

    app.post(userPath + '/getJobFairList', app.Verifyauth, [
        // check('search').exists().isLength({ min: 1 }).withMessage('id is Empty'),
    ], (request, response) => {
        const errors = validationResult(request)
        if (!errors.isEmpty()) {
            var errorArray = errors.array()
            var errorResponse = {}
            errorResponse.error = true
            errorResponse.message = errorArray[0].msg
            response.status(404);
            return response.send(errorResponse)
        }
        jobCentreControllerObject.getJobFairListController(request, function (results) {
            if (results.error) {
                response.status(results.statusCode);
                return response.send(results)
            } else {
                return response.send(results)
            }
        })
    })

    app.post(userPath + '/createJobPayment', app.Verifyauth, [
        // check('search').exists().isLength({ min: 1 }).withMessage('id is Empty'),
    ], (request, response) => {
        const errors = validationResult(request)
        if (!errors.isEmpty()) {
            var errorArray = errors.array()
            var errorResponse = {}
            errorResponse.error = true
            errorResponse.message = errorArray[0].msg
            response.status(404);
            return response.send(errorResponse)
        }
        jobCentreControllerObject.createJobPaymentController(request, function (results) {
            if (results.error) {
                response.status(results.statusCode);
                return response.send(results)

            } else {
                return response.send(results)
                //    return response.redirect(303, results.data);

            }
        })
    })

    app.post('/webhook', bodyParser.raw({
        type: 'application/json'
    }), (request, response) => {
      
        jobCentreControllerObject.webhookController(request, function (results) {
            if(results.error){
                response.status(results.statusCode);
                return response.send(results)

            }else{
                return response.send(results)
            //    return response.redirect(303, results.data);

            }
          })   
    })

    app.post(userPath + '/editOneJobPost', app.Verifyauth, [
        // check('search').exists().isLength({ min: 1 }).withMessage('id is Empty'),
    ], (request, response) => {
        const errors = validationResult(request)
        if (!errors.isEmpty()) {
            var errorArray = errors.array()
            var errorResponse = {}
            errorResponse.error = true
            errorResponse.message = errorArray[0].msg
            response.status(404);
            return response.send(errorResponse)
        }
        jobCentreControllerObject.editOneJobPostController(request, function (results) {
            if (results.error) {
                response.status(results.statusCode);
                return response.send(results)
            } else {
                return response.send(results)
            }
        })
    })

    app.post(userPath + '/getOneJobFair', app.Verifyauth, [
        // check('search').exists().isLength({ min: 1 }).withMessage('id is Empty'),
    ], (request, response) => {
        const errors = validationResult(request)
        if (!errors.isEmpty()) {
            var errorArray = errors.array()
            var errorResponse = {}
            errorResponse.error = true
            errorResponse.message = errorArray[0].msg
            response.status(404);
            return response.send(errorResponse)
        }
        jobCentreControllerObject.getOneJobFairController(request, function (results) {
            if (results.error) {
                response.status(results.statusCode);
                return response.send(results)
            } else {
                return response.send(results)
            }
        })
    })


}