module.exports = function () {
    var goodVibesDao = require('../../dao/admin/goodVibesDao')

    const STRINGS = require('../../strings.json')
    // const common= require('../../utils/common')
    require('../../utils/common')()


    require('dotenv').config()
    var goodVibesDaoObject = new goodVibesDao()
    // var commonObject = new common()

    this.addOneGoodVibeService = async (request) => {
        const response = {}
        return new Promise(async function (resolve) {
            try {
                // request.body.uid = '4c19d0cd-aa55-4751-a43a-efc9ef6e63c8'
                request.body.is_active = 1
                var addOneGoodVibeDao = await goodVibesDaoObject.addOneGoodVibeDao(request.body)
                if (addOneGoodVibeDao.error) {
                    response.error = true
                    response.statusCode = STRINGS.errorStatusCode
                    response.message = STRINGS.oopsErrorMessage
                    resolve(response)
                } else {
                    response.error = false
                    response.statusCode = STRINGS.successStatusCode
                    response.message = STRINGS.SuccessString
                    response.data = addOneGoodVibeDao.data
                    resolve(response)
                }
            } catch (e) {
                console.log(e)
                response.error = true
                response.statusCode = STRINGS.errorStatusCode
                response.message = STRINGS.oopsErrorMessage
                resolve(response)
            }
        })
    }



    this.getGoodVibesListService = async (request) => {
        const response = {}
        return new Promise(async function (resolve) {
            try {
                // request.body.uid = '4c19d0cd-aa55-4751-a43a-efc9ef6e63c8'
                request.body.is_active = 1
                request.body.pageNumber = request.body.pageNumber.length == 0 ? 0 : request.body.pageNumber
                var pageNumber = request.body.pageNumber
                request.body.RowsPerpage =  request.body.RowsPerpage.length == 0 ? 0: request.body.RowsPerpage
                RowsPerpage = request.body.RowsPerpage
                var getTotalGoodVibesListDao = await goodVibesDaoObject.getTotalGoodVibesListDao(request.body)
                if (getTotalGoodVibesListDao.error) {
                    response.error = true
                    response.statusCode = STRINGS.errorStatusCode
                    response.message = STRINGS.oopsErrorMessage
                    resolve(response)
                } else if (getTotalGoodVibesListDao.result > 0) {
                    var lenght = getTotalGoodVibesListDao.result
                    var paginationDetails = await this.getPaginationDetailsWithSize(lenght, pageNumber,RowsPerpage )

                    var getGoodVibesListDao = await goodVibesDaoObject.getGoodVibesListDao(request.body)
                    if (getGoodVibesListDao.error) {
                        response.error = true
                        response.statusCode = STRINGS.errorStatusCode
                        response.message = STRINGS.oopsErrorMessage
                        resolve(response)
                    } else {
                        response.error = false
                        response.statusCode = STRINGS.successStatusCode
                        response.message = STRINGS.SuccessString
                        response.totalPages = paginationDetails.totalPages
                        response.data = getGoodVibesListDao.result
                        resolve(response)
                    }
                } else {
                    response.error = false
                    response.statusCode = STRINGS.successStatusCode
                    response.message = STRINGS.SuccessString
                    response.totalPages = 0
                    response.data = []
                    resolve(response)
                }
            } catch (e) {
                console.log(e)
                response.error = true
                response.statusCode = STRINGS.errorStatusCode
                response.message = STRINGS.oopsErrorMessage
                resolve(response)
            }
        })
    }



    this.viewOneGoodVibePostService = async (request) => {
        const response = {}
        return new Promise(async function (resolve) {
            try {
                // request.body.uid = '4c19d0cd-aa55-4751-a43a-efc9ef6e63c8'
                var viewOneGoodVibePostDao = await goodVibesDaoObject.viewOneGoodVibePostDao(request.body)
                if (viewOneGoodVibePostDao.error) {
                    response.error = true
                    response.statusCode = STRINGS.errorStatusCode
                    response.message = STRINGS.oopsErrorMessage
                    resolve(response)
                } else {
                    response.error = false
                    response.statusCode = STRINGS.successStatusCode
                    response.message = STRINGS.SuccessString
                    response.data = viewOneGoodVibePostDao.result
                    resolve(response)
                }
            } catch (e) {
                // console.log(e)
                response.error = true
                response.statusCode = STRINGS.errorStatusCode
                response.message = STRINGS.oopsErrorMessage
                resolve(response)
            }
        })
    }


    this.editOneGoodVibePostService = async (request) => {
        const response = {}
        return new Promise(async function (resolve) {
            try {
                // request.body.uid = '4c19d0cd-aa55-4751-a43a-efc9ef6e63c8'
                var editOneGoodVibePostDao = await goodVibesDaoObject.editOneGoodVibePostDao(request.body)
                if (editOneGoodVibePostDao.error) {
                    response.error = true
                    response.statusCode = STRINGS.errorStatusCode
                    response.message = STRINGS.oopsErrorMessage
                    resolve(response)
                } else {
                    response.error = false
                    response.statusCode = STRINGS.successStatusCode
                    response.message = STRINGS.SuccessString
                    response.data = editOneGoodVibePostDao.result
                    resolve(response)
                }
            } catch (e) {
                // console.log(e)
                response.error = true
                response.statusCode = STRINGS.errorStatusCode
                response.message = STRINGS.oopsErrorMessage
                resolve(response)
            }
        })
    }



    this.deleteOneGoodVibeService = async (request) => {
        const response = {}
        return new Promise(async function (resolve) {
            try {
                // request.body.uid = '4c19d0cd-aa55-4751-a43a-efc9ef6e63c8'
                var deleteOneGoodVibeDao = await goodVibesDaoObject.deleteOneGoodVibeDao(request.body)
                if (deleteOneGoodVibeDao.error) {
                    response.error = true
                    response.statusCode = STRINGS.errorStatusCode
                    response.message = STRINGS.oopsErrorMessage
                    resolve(response)
                } else {
                    response.error = false
                    response.statusCode = STRINGS.successStatusCode
                    response.message = STRINGS.SuccessString
                    response.data = deleteOneGoodVibeDao.result
                    resolve(response)
                }
            } catch (e) {
                // console.log(e)
                response.error = true
                response.statusCode = STRINGS.errorStatusCode
                response.message = STRINGS.oopsErrorMessage
                resolve(response)
            }
        })
    }


}