module.exports = function () {
    const donasayonDao = require('../../dao/web/DonasyanDao')
    const profiledao = require('../../dao/web/MyProfileDao')
    const STRINGS = require('../../strings.json')
    require('dotenv').config()
    const donasayonDaoObject = new donasayonDao()
    const likesDao = require('../../dao/web/LikesDao')
    const likesObject = new likesDao()
    const profileDao = new profiledao()
    const FoodTripDao = require('../../dao/web/FoodTripDao')

    const foodTripDaoObject = new FoodTripDao()

    this.DonasyanPostService = async (request) => {

        const response = {}
        return new Promise(async function (resolve) {
            try {
                var object = {}
                request.body.user_id  = request.body.uid
                var getOneProfileDao = await profileDao.getOneProfileDao(request.body)
                console.log("getOneProfileDao", getOneProfileDao)
                object.profile_photo = getOneProfileDao.data.profile_photo
                object.full_name = getOneProfileDao.data.full_name
                object.location = getOneProfileDao.data.province
                object.is_active = 1
                var persist = Object.assign(request.body, object)
                var donasayonDaoResponse = await donasayonDaoObject.DonasaynPostDao(persist)

                if (donasayonDaoObject.error) {
                    response.error = true
                    response.statusCode = STRINGS.errorStatusCode
                    response.message = STRINGS.oopsErrorMessage
                    resolve(response)
                } else {
                    response.error = false
                    response.statusCode = STRINGS.successStatusCode
                    response.message = STRINGS.SuccessString
                    response.data = donasayonDaoResponse.data

                    resolve(response)
                }
            } catch (e) {
                console.log(e)
                response.error = true
                response.statusCode = STRINGS.errorStatusCode
                response.message = STRINGS.oopsErrorMessage
                resolve(response)
            }
        })
    }
    this.getListOfDonasayonService = async (request) => {
        const response = {}
        return new Promise(async function (resolve) {
            try {
                var object = {}

                request.body.pageNumber = request.body.pageNumber.length == 0 ? 0 : request.body.pageNumber
                pageNumber = request.body.pageNumber
                var getTotalDonasaynListCountDao = await donasayonDaoObject.getTotalDonasaynListCountDao(request.body)
                //console.log("totttttttttttt",getTotalDonasaynListCountDao)
                if (foodTripDaoObject.error) {
                    response.error = true
                    response.statusCode = STRINGS.errorStatusCode
                    response.message = STRINGS.oopsErrorMessage
                    resolve(response)
                } else {
                    var lenght = getTotalDonasaynListCountDao.data
                    var paginationDetails = await this.getPaginationDetailsWithSize(lenght, pageNumber, 10)
                    var myDonasayonDaoResponse = await donasayonDaoObject.getDonasaynListDao(request.body)

                    //
                    var iteraration = myDonasayonDaoResponse.data.length
                    var datas = myDonasayonDaoResponse.data
                    var arr = []
                    var storeall = {}
                    // console.log("logging",datas)
                    var uid = request.body.uid
                    for (var i = 0; i < iteraration; i++) {
                        // console.log("loop beginning",datas[i])

                        var convert = (datas[i]._id).toString()
                        var obj = {}
                        obj.post_id = convert
                        obj.uid = uid
                        //console.log("input for likedbydao",obj)
                        var searchinlike = await likesObject.forlikedbyList(obj)
                        var a = searchinlike.data

                        var updatecount = Object.keys(a).length
                        // console.log("searchinlike", searchinlike)
                        if (updatecount >= 1) {
                            var getOneDonasayonpDao = await donasayonDaoObject.getOneByeBuyDao(obj)

                            // console.log("consolw", getOneDonasayonpDao.data[0])

                            // let p2 = Object.assign({}, getOneDonasayonpDao.data._doc);
                            // console.log("getOneDonasayonpDao",getOneDonasayonpDao)
                            if (getOneDonasayonpDao.error) {
                                response.error = true
                                response.statusCode = STRINGS.errorStatusCode
                                response.message = STRINGS.oopsErrorMessage
                                resolve(response)
                            }
                            var p2 = getOneDonasayonpDao.result

                            p2.likedBy = "1"
                            arr.push(p2)

                            // console.log("true",p2)
                        } else {
                            var getOneDonasayonpDao = await donasayonDaoObject.getOneByeBuyDao(obj)
                            // console.log("getone list", getOneDonasayonpDao)
                            // let p2 = Object.assign({}, getOneDonasayonpDao.data._doc);

                            if (getOneDonasayonpDao.error) {
                                response.error = true
                                response.statusCode = STRINGS.errorStatusCode
                                response.message = STRINGS.oopsErrorMessage
                                resolve(response)
                            }
                            var p2 = getOneDonasayonpDao.result

                            p2.likedBy = "0"
                            arr.push(p2)
                            // console.log("getOneDonasayonpDao",getOneDonasayonpDao)

                        }
                        //console.log("loop ending",datas)

                    }
                    // console.log("logging",arr)
                    response.error = false
                    response.statusCode = STRINGS.successStatusCode
                    response.message = STRINGS.SuccessString
                    response.totalPages = paginationDetails.totalPages
                    response.data = arr
                    resolve(response)
                }
            } catch (e) {
                console.log(e)
                response.error = true
                response.statusCode = STRINGS.errorStatusCode
                response.message = STRINGS.oopsErrorMessage
                resolve(response)
            }
        })
    }

    this.getOneByeBuyService = async (request) => {
        const response = {}
        return new Promise(async function (resolve) {
            try {
                var object = {}
                var getOneByeBuyResponse = await donasayonDaoObject.getOneByeBuyDao(request.body)
                console.log(getOneByeBuyResponse)
                if (getOneByeBuyResponse.error) {
                    response.error = true
                    response.statusCode = STRINGS.errorStatusCode
                    response.message = STRINGS.oopsErrorMessage
                    resolve(response)
                } else {
                    var searchinlike = await likesObject.forlikedbyList(request.body)
                    console.log(searchinlike)
                    if (searchinlike.error) {
                        response.error = true
                        response.statusCode = STRINGS.errorStatusCode
                        response.message = STRINGS.oopsErrorMessage
                        resolve(response)
                    } else {
                        object = getOneByeBuyResponse.result
                        object.LikedBy = searchinlike.data.length > 0 ? 1 : 0
                        //console.log("mydonasayon",getOneByeBuyResponse)
                        response.error = false
                        response.statusCode = STRINGS.successStatusCode
                        response.message = STRINGS.SuccessString
                        response.data = object
                        resolve(response)
                    }
                }
            } catch (e) {
                console.log(e)
                response.error = true
                response.statusCode = STRINGS.errorStatusCode
                response.message = STRINGS.oopsErrorMessage
                resolve(response)
            }
        })

    }


    this.searchByeBuyService = async (request) => {
        const response = {}
        return new Promise(async function (resolve) {
            try {
                var object = {}
                console.log("searchresponse", request.body)
                if (request.body.arr.length == 0 && request.body.search == '') {
                    object.search = request.body.search
                    console.log("searchresponse3")
                    var searchByeBuyResponse = await donasayonDaoObject.searchByeBuyDao(object)

                } else if (request.body.arr.length != 0 && request.body.search !== '') {

                    console.log("searchresponse4")
                    var searchByeBuyResponse = await donasayonDaoObject.filterByeBuyDao1(request.body)

                } else if (request.body.search == "") {
                    object.arr = request.body.arr
                    console.log("searchresponse1")
                    var searchByeBuyResponse = await donasayonDaoObject.searchByeBuyDao(object)

                } else if (request.body.arr.length == 0) {
                    object.search = request.body.search
                    console.log("searchresponse2")
                    var searchByeBuyResponse = await donasayonDaoObject.searchByeBuyDao(object)

                } else {
                    var searchByeBuyResponse = await donasayonDaoObject.searchByeBuyDao(request.body)
                }
                if (donasayonDaoObject.error) {
                    response.error = true
                    response.statusCode = STRINGS.errorStatusCode
                    response.message = STRINGS.oopsErrorMessage
                    resolve(response)
                } else {
                    response.error = false
                    response.statusCode = STRINGS.successStatusCode
                    response.message = STRINGS.SuccessString
                    response.data = searchByeBuyResponse.data

                    resolve(response)
                }
            } catch (e) {
                console.log(e)
                response.error = true
                response.statusCode = STRINGS.errorStatusCode
                response.message = STRINGS.oopsErrorMessage
                resolve(response)
            }
        })
    }

}