    module.exports = function () {
        const MyProfileDao = require('../../dao/web/MyProfileDao')
        const STRINGS = require('../../strings.json')
        require('dotenv').config()
        const myProfileDaoObject = new MyProfileDao()

        const bazaarCityDao = require('../../dao/web/bazaarCityDao')

        const bazaarCityDaoObject = new bazaarCityDao()




        this.addMyProfileService = async (request) => {
            const response = {}
            return new Promise(async function (resolve) {
                try {
                    var object = {}
                    object.uid = request.body.uid
                    object.full_name = request.body.full_name
                    object.eMail_id = request.body.eMail_id
                    object.phone_number = request.body.phone_number
                    object.gender = request.body.gender
                    object.age_group = request.body.age_group
                    object.home_country = request.body.home_country
                    object.current_country = request.body.current_country
                    object.province = request.body.province
                    object.hobbies = request.body.hobbies
                    object.industry_working_in = request.body.industry_working_in
                    object.favorite_quote = request.body.favorite_quote
                    object.profile_photo = request.body.profile_photo
                    object.is_active = 1
                    var myProfileDaoResponse = await myProfileDaoObject.addMyProfileDao(object)

                    if (myProfileDaoObject.error) {
                        response.error = true
                        response.statusCode = STRINGS.errorStatusCode
                        response.message = STRINGS.oopsErrorMessage
                        resolve(response)
                    } else {
                        response.error = false
                        response.statusCode = STRINGS.successStatusCode
                        response.message = STRINGS.SuccessString
                        response.data = myProfileDaoResponse.data
                        resolve(response)
                    }
                } catch (e) {
                    console.log(e)
                    response.error = true
                    response.statusCode = STRINGS.errorStatusCode
                    response.message = STRINGS.oopsErrorMessage
                    resolve(response)
                }
            })

        }
        this.getOneProfileService = async (request) => {
            const response = {}
            return new Promise(async function (resolve) {
                try {

                    var myProfileDao = await myProfileDaoObject.getOneProfileDao(request.body)

                    // console.log("myProfileDaoResponse", myProfileDaoResponse)
                    if (myProfileDao.error) {
                        response.error = true
                        response.statusCode = STRINGS.errorStatusCode
                        response.message = STRINGS.oopsErrorMessage
                        resolve(response)
                    } else if (myProfileDao.data) {

                        var object = {}
                        // request.body.uid = request.body.user_id
                        var ListUserPostedBuyBuyItemDao = await myProfileDaoObject.ListUserPostedBuyBuyItemDao(request.body)
                        if (ListUserPostedBuyBuyItemDao.error) {
                            response.error = true
                            response.statusCode = STRINGS.errorStatusCode
                            response.message = STRINGS.oopsErrorMessage
                            resolve(response)
                        } else {
                            var a = ListUserPostedBuyBuyItemDao.result.length
                            var userFoodTripListDao = await myProfileDaoObject.userFoodTripListDao(request.body)
                            if (userFoodTripListDao.error) {
                                response.error = true
                                response.statusCode = STRINGS.errorStatusCode
                                response.message = STRINGS.oopsErrorMessage
                                resolve(response)
                            } else {
                                var b = userFoodTripListDao.result.length
                                var myProfileDaoResponse = await myProfileDaoObject.getOneProfileDao(request.body)

                                // console.log("myProfileDaoResponse", myProfileDaoResponse)
                                if (myProfileDaoResponse.error) {
                                    response.error = true
                                    response.statusCode = STRINGS.errorStatusCode
                                    response.message = STRINGS.oopsErrorMessage
                                    resolve(response)
                                } else {

                                    var PinoyPreneurDetailsDao = await myProfileDaoObject.PinoyPreneurDetailsDao(request.body)

                                    // console.log("myProfileDaoResponse", myProfileDaoResponse)
                                    if (PinoyPreneurDetailsDao.error) {
                                        response.error = true
                                        response.statusCode = STRINGS.errorStatusCode
                                        response.message = STRINGS.oopsErrorMessage
                                        resolve(response)
                                    } else {
                                        var checkUserConnectionDao = await myProfileDaoObject.checkUserConnectionDao(request.body)

                                        // console.log("myProfileDaoResponse", myProfileDaoResponse)
                                        if (checkUserConnectionDao.error) {
                                            response.error = true
                                            response.statusCode = STRINGS.errorStatusCode
                                            response.message = STRINGS.oopsErrorMessage
                                            resolve(response)
                                        } else {


                                            var userBazaarCityCountDao = await myProfileDaoObject.userBazaarCityCountDao(request.body)

                                            // console.log("myProfileDaoResponse", myProfileDaoResponse)
                                            if (userBazaarCityCountDao.error) {
                                                response.error = true
                                                response.statusCode = STRINGS.errorStatusCode
                                                response.message = STRINGS.oopsErrorMessage
                                                resolve(response)
                                            } else {
                                                var bazaarcityCount = parseInt(userBazaarCityCountDao.result)
                                                var total_posts = a + b + bazaarcityCount
                                                object.uid = request.body.uid
                                                var construct = Object.assign({}, myProfileDaoResponse.data._doc)
                                                construct.total_posts = total_posts
                                                construct.business_details = PinoyPreneurDetailsDao.result
                                                construct.isOwnProfile = request.body.uid == request.body.user_id ? 1 : 0
                                                construct.isConnected = checkUserConnectionDao.result.length > 0 ? 1 : 0
                                                response.error = false
                                                response.statusCode = STRINGS.successStatusCode
                                                response.message = STRINGS.SuccessString
                                                response.data = construct
                                                resolve(response)
                                            }
                                        }
                                    }
                                }
                            }
                        }
                    } else {
                        response.error = true
                        response.statusCode = STRINGS.errorStatusCode
                        response.message = "User Not Exist"
                        resolve(response)
                    }
                } catch (e) {
                    console.log(e)
                    response.error = true
                    response.statusCode = STRINGS.errorStatusCode
                    response.message = STRINGS.oopsErrorMessage
                    resolve(response)
                }
            })

        }

        this.editMyprofileService = async (request) => {
            const response = {}
            return new Promise(async function (resolve) {
                var noErrors = {

                }
                try {
                    var object = {}
                    // request.body.uid = "W2k97w8fN8dQspbOL8BMRsPTmnD2"
                    var editMyprofileDao = await myProfileDaoObject.editMyprofileDao(request.body)
                    if (editMyprofileDao.error) {
                        response.error = true
                        response.statusCode = STRINGS.errorStatusCode
                        response.message = STRINGS.oopsErrorMessage
                        resolve(response)
                    } else {
                        var editMyprofileLikeDao = await myProfileDaoObject.editMyprofileLikeDao(request.body)
                        if (editMyprofileLikeDao.error) {
                            response.error = true
                            response.statusCode = STRINGS.errorStatusCode
                            response.message = STRINGS.oopsErrorMessage
                            resolve(response)
                        } else {
                            var editMyprofileCommentsDao = await myProfileDaoObject.editMyprofileCommentsDao(request.body)
                            if (editMyprofileCommentsDao.error) {
                                response.error = true
                                response.statusCode = STRINGS.errorStatusCode
                                response.message = STRINGS.oopsErrorMessage
                                resolve(response)
                            } else {
                                var editMyprofileFoodTripDao = await myProfileDaoObject.editMyprofileFoodTripDao(request.body)
                                if (editMyprofileFoodTripDao.error) {
                                    response.error = true
                                    response.statusCode = STRINGS.errorStatusCode
                                    response.message = STRINGS.oopsErrorMessage
                                    resolve(response)
                                } else {
                                    var editMyprofileBazaarCityDao = await myProfileDaoObject.editMyprofileBazaarCityDao(request.body)
                                    if (editMyprofileBazaarCityDao.error) {
                                        response.error = true
                                        response.statusCode = STRINGS.errorStatusCode
                                        response.message = STRINGS.oopsErrorMessage
                                        resolve(response)
                                    } else {
                                        var editMyprofileByeBuyItemsDao = await myProfileDaoObject.editMyprofileByeBuyItemsDao(request.body)
                                        if (editMyprofileByeBuyItemsDao.error) {
                                            response.error = true
                                            response.statusCode = STRINGS.errorStatusCode
                                            response.message = STRINGS.oopsErrorMessage
                                            resolve(response)
                                        } else {

                                            var editMyprofileTambayanDao = await myProfileDaoObject.editMyprofileTambayanDao(request.body)
                                            if (editMyprofileTambayanDao.error) {
                                                response.error = true
                                                response.statusCode = STRINGS.errorStatusCode
                                                response.message = STRINGS.oopsErrorMessage
                                                resolve(response)
                                            } else {
                                                var editMyprofileShoutOutsModelDao = await myProfileDaoObject.editMyprofileShoutOutsModelDao(request.body)
                                                if (editMyprofileShoutOutsModelDao.error) {
                                                    response.error = true
                                                    response.statusCode = STRINGS.errorStatusCode
                                                    response.message = STRINGS.oopsErrorMessage
                                                    resolve(response)
                                                } else {

                                                    var obj = {}
                                                    if (request.body.business_details) {
                                                        obj = request.body.business_details
                                                        obj.full_name = request.body.full_name
                                                        obj.profile_photo = request.body.profile_photo
                                                    } else {
                                                        obj.full_name = request.body.full_name
                                                        obj.profile_photo = request.body.profile_photo
                                                    }
                                                    // console.log("obj", obj)
                                                    var editMyprofilePinoyPreneurDao = await myProfileDaoObject.editMyprofilePinoyPreneurDao(request.body, obj)
                                                    // console.log("editMyprofilePinoyPreneurDao",editMyprofilePinoyPreneurDao)
                                                    if (editMyprofilePinoyPreneurDao.error) {
                                                        response.error = true
                                                        response.statusCode = STRINGS.errorStatusCode
                                                        response.message = STRINGS.oopsErrorMessage
                                                        resolve(response)
                                                    } else {
                                                        response.error = false
                                                        response.statusCode = STRINGS.successStatusCode
                                                        response.message = STRINGS.SuccessString
                                                        response.data = editMyprofileDao.result
                                                        resolve(response)
                                                    }
                                                }

                                            }

                                        }

                                    }

                                }

                            }

                        }
                    }
                } catch (e) {
                    console.log(e)
                    response.error = true
                    response.statusCode = STRINGS.errorStatusCode
                    response.message = STRINGS.oopsErrorMessage
                    resolve(response)
                }
            })

        }

        this.userFoodTripListService = async (request) => {
            const response = {}
            return new Promise(async function (resolve) {
                try {
                    var object = {}
                    request.body.uid = request.body.user_id

                    // request.body.uid = '4c19d0cd-aa55-4751-a43a-efc9ef6e63c7'
                    var userFoodTripListDao = await myProfileDaoObject.userFoodTripListDao(request.body)
                    if (userFoodTripListDao.error) {
                        response.error = true
                        response.statusCode = STRINGS.errorStatusCode
                        response.message = STRINGS.oopsErrorMessage
                        resolve(response)
                    } else {
                        response.error = false
                        response.statusCode = STRINGS.successStatusCode
                        response.message = STRINGS.SuccessString
                        response.data = userFoodTripListDao.result
                        resolve(response)
                    }
                } catch (e) {
                    console.log(e)
                    response.error = true
                    response.statusCode = STRINGS.errorStatusCode
                    response.message = STRINGS.oopsErrorMessage
                    resolve(response)
                }
            })

        }

        this.getOnePostService = async (request) => {
            const response = {}
            return new Promise(async function (resolve) {
                try {
                    var object = {}
                    var getOnePostDao = await myProfileDaoObject.getOnePostDao(request.body)
                    if (getOnePostDao.error) {
                        response.error = true
                        response.statusCode = STRINGS.errorStatusCode
                        response.message = STRINGS.oopsErrorMessage
                        resolve(response)
                    } else {
                        response.error = false
                        response.statusCode = STRINGS.successStatusCode
                        response.message = STRINGS.SuccessString
                        response.data = getOnePostDao.result
                        resolve(response)
                    }
                } catch (e) {
                    console.log(e)
                    response.error = true
                    response.statusCode = STRINGS.errorStatusCode
                    response.message = STRINGS.oopsErrorMessage
                    resolve(response)
                }
            })

        }
        this.editOnePostService = async (request) => {
            const response = {}
            return new Promise(async function (resolve) {
                try {
                    var object = {}
                    var getOnePostDao = await myProfileDaoObject.getOnePostDao(request.body)

                    if (getOnePostDao.error) {
                        response.error = true
                        response.statusCode = STRINGS.errorStatusCode
                        response.message = STRINGS.oopsErrorMessage
                        resolve(response)
                    } else if (getOnePostDao.result.is_active == 1) {
                        var editOnePostDao = await myProfileDaoObject.editOnePostDao(request.body)
                        if (editOnePostDao.error) {
                            response.error = true
                            response.statusCode = STRINGS.errorStatusCode
                            response.message = STRINGS.oopsErrorMessage
                            resolve(response)
                        } else {
                            response.error = false
                            response.statusCode = STRINGS.successStatusCode
                            response.message = STRINGS.SuccessString
                            response.data = editOnePostDao.result
                            resolve(response)
                        }
                    } else {
                        response.error = false
                        response.statusCode = STRINGS.successStatusCode
                        response.message = STRINGS.SuccessString
                        response.data = "FoodTrip Post Not Available"
                        resolve(response)
                    }
                } catch (e) {
                    console.log(e)
                    response.error = true
                    response.statusCode = STRINGS.errorStatusCode
                    response.message = STRINGS.oopsErrorMessage
                    resolve(response)
                }
            })

        }

        this.deleteOnePostService = async (request) => {
            const response = {}
            return new Promise(async function (resolve) {
                try {
                    var object = {}
                    var deleteOnePostDao = await myProfileDaoObject.deleteOnePostDao(request.body)
                    if (deleteOnePostDao.error) {
                        response.error = true
                        response.statusCode = STRINGS.errorStatusCode
                        response.message = STRINGS.oopsErrorMessage
                        resolve(response)
                    } else {
                        response.error = false
                        response.statusCode = STRINGS.successStatusCode
                        response.message = STRINGS.SuccessString
                        response.data = deleteOnePostDao.result
                        resolve(response)
                    }
                } catch (e) {
                    console.log(e)
                    response.error = true
                    response.statusCode = STRINGS.errorStatusCode
                    response.message = STRINGS.oopsErrorMessage
                    resolve(response)
                }
            })

        }

        this.userBazaarCityListService = async (request) => {
            const response = {}
            return new Promise(async function (resolve) {
                try {
                    var object = {}
                    request.body.uid = request.body.user_id

                    // request.body.uid = 'JLACxJhmGjVXkhX1jtnXJxI2tht2'
                    var userBazaarCityListServiceDao = await myProfileDaoObject.userBazaarCityListServiceDao(request.body)
                    if (userBazaarCityListServiceDao.error) {
                        response.error = true
                        response.statusCode = STRINGS.errorStatusCode
                        response.message = STRINGS.oopsErrorMessage
                        resolve(response)
                    } else {

                        var length = userBazaarCityListServiceDao.result.length
                        for (let i = 0; i < length; i++) {
                            var data = {}
                            data.bazzarCityPost_id = userBazaarCityListServiceDao.result[i]._id
                            data.uid = request.body.uid
                            // console.log("data",data)
                            var GetOneBazaarCityLikedDao = await bazaarCityDaoObject.GetOneBazaarCityLikedDao(data)
                            // console.log("GetOneBazaarCityLikedDao", GetOneBazaarCityLikedDao)
                            if (GetOneBazaarCityLikedDao.error) {
                                response.error = true
                                response.statusCode = STRINGS.errorStatusCode
                                response.message = STRINGS.commanErrorString
                                resolve(response)
                            } else {
                                userBazaarCityListServiceDao.result[i].likedBy = GetOneBazaarCityLikedDao.result ? 1 : 0
                            }
                        }

                        response.error = false
                        response.statusCode = STRINGS.successStatusCode
                        response.message = STRINGS.SuccessString
                        response.data = userBazaarCityListServiceDao.result
                        resolve(response)
                    }
                } catch (e) {
                    console.log(e)
                    response.error = true
                    response.statusCode = STRINGS.errorStatusCode
                    response.message = STRINGS.oopsErrorMessage
                    resolve(response)
                }
            })

        }


        this.getOneBazaarCityPostService = async (request) => {
            const response = {}
            return new Promise(async function (resolve) {
                try {
                    var object = {}
                    var getOneBazaarCityPostDao = await myProfileDaoObject.getOneBazaarCityPostDao(request.body)
                    if (getOneBazaarCityPostDao.error) {
                        response.error = true
                        response.statusCode = STRINGS.errorStatusCode
                        response.message = STRINGS.oopsErrorMessage
                        resolve(response)
                    } else {

                        request.body.bazzarCityPost_id = request.body.post_id

                        var GetOneBazaarCityLikedDao = await bazaarCityDaoObject.GetOneBazaarCityLikedDao(request.body)
                        if (GetOneBazaarCityLikedDao.error) {
                            response.error = true
                            response.statusCode = STRINGS.errorStatusCode
                            response.message = STRINGS.commanErrorString
                            resolve(response)
                        } else {

                            getOneBazaarCityPostDao.result.likedBy = GetOneBazaarCityLikedDao.result ? 1 : 0

                            response.error = false
                            response.statusCode = STRINGS.successStatusCode
                            response.message = STRINGS.SuccessString
                            response.data = getOneBazaarCityPostDao.result
                            resolve(response)
                        }
                    }
                } catch (e) {
                    console.log(e)
                    response.error = true
                    response.statusCode = STRINGS.errorStatusCode
                    response.message = STRINGS.oopsErrorMessage
                    resolve(response)
                }
            })

        }

        this.deleteOneBazaarCityPostService = async (request) => {
            const response = {}
            return new Promise(async function (resolve) {
                try {
                    var object = {}
                    var deleteOneBazaarCityPostDao = await myProfileDaoObject.deleteOneBazaarCityPostDao(request.body)
                    if (deleteOneBazaarCityPostDao.error) {
                        response.error = true
                        response.statusCode = STRINGS.errorStatusCode
                        response.message = STRINGS.oopsErrorMessage
                        resolve(response)
                    } else {
                        response.error = false
                        response.statusCode = STRINGS.successStatusCode
                        response.message = STRINGS.SuccessString
                        response.data = deleteOneBazaarCityPostDao.result
                        resolve(response)
                    }
                } catch (e) {
                    console.log(e)
                    response.error = true
                    response.statusCode = STRINGS.errorStatusCode
                    response.message = STRINGS.oopsErrorMessage
                    resolve(response)
                }
            })

        }


        this.editOneBazaarCityPostService = async (request) => {
            const response = {}
            return new Promise(async function (resolve) {
                try {
                    var object = {}
                    var getOneBazaarCityPostDao = await myProfileDaoObject.getOneBazaarCityPostDao(request.body)

                    if (getOneBazaarCityPostDao.error) {
                        response.error = true
                        response.statusCode = STRINGS.errorStatusCode
                        response.message = STRINGS.oopsErrorMessage
                        resolve(response)
                    } else if (getOneBazaarCityPostDao.result) {
                        var editOneBazaarCityPostDao = await myProfileDaoObject.editOneBazaarCityPostDao(request.body)
                        if (editOneBazaarCityPostDao.error) {
                            response.error = true
                            response.statusCode = STRINGS.errorStatusCode
                            response.message = STRINGS.oopsErrorMessage
                            resolve(response)
                        } else {
                            response.error = false
                            response.statusCode = STRINGS.successStatusCode
                            response.message = STRINGS.SuccessString
                            response.data = editOneBazaarCityPostDao.result
                            resolve(response)
                        }
                    } else {
                        response.error = false
                        response.statusCode = STRINGS.successStatusCode
                        response.message = STRINGS.SuccessString
                        response.data = "BazaarCity Post Not Available"
                        resolve(response)
                    }
                } catch (e) {
                    console.log(e)
                    response.error = true
                    response.statusCode = STRINGS.errorStatusCode
                    response.message = STRINGS.oopsErrorMessage
                    resolve(response)
                }
            })

        }


        this.userBuyBuyItemsListService = async (request) => {
            const response = {}
            return new Promise(async function (resolve) {
                try {
                    var object = {}


                    // request.body.uid = '4c19d0cd-aa55-4751-a43a-efc9ef6e63c7'
                    var userBuyBuyItemsListDao = await myProfileDaoObject.userBuyBuyItemsListDao1(request.body)
                    console.log(userBuyBuyItemsListDao)
                    if (userBuyBuyItemsListDao.error) {
                        response.error = true
                        response.statusCode = STRINGS.errorStatusCode
                        response.message = STRINGS.oopsErrorMessage
                        resolve(response)
                    } else {
                        response.error = false
                        response.statusCode = STRINGS.successStatusCode
                        response.message = STRINGS.SuccessString
                        response.data = userBuyBuyItemsListDao.result
                        resolve(response)
                    }
                } catch (e) {
                    console.log(e)
                    response.error = true
                    response.statusCode = STRINGS.errorStatusCode
                    response.message = STRINGS.oopsErrorMessage
                    resolve(response)
                }
            })

        }
        this.ListUserPostedBuyBuyItemService = async (request) => {
            const response = {}
            return new Promise(async function (resolve) {
                try {
                    var object = {}

                    // request.body.uid = '4c19d0cd-aa55-4751-a43a-efc9ef6e63c7'
                    var ListUserPostedBuyBuyItemService = await myProfileDaoObject.ListUserPostedBuyBuyItemDao(request.body)
                    if (ListUserPostedBuyBuyItemService.error) {
                        response.error = true
                        response.statusCode = STRINGS.errorStatusCode
                        response.message = STRINGS.oopsErrorMessage
                        resolve(response)
                    } else {
                        response.error = false
                        response.statusCode = STRINGS.successStatusCode
                        response.message = STRINGS.SuccessString
                        response.data = ListUserPostedBuyBuyItemService.result
                        resolve(response)
                    }
                } catch (e) {
                    console.log(e)
                    response.error = true
                    response.statusCode = STRINGS.errorStatusCode
                    response.message = STRINGS.oopsErrorMessage
                    resolve(response)
                }
            })

        }

        this.ViewUserBuyBuyItemService = async (request) => {
            const response = {}
            return new Promise(async function (resolve) {
                try {
                    var object = {}
                    // request.body.uid = '4c19d0cd-aa55-4751-a43a-efc9ef6e63c7'
                    var ViewUserBuyBuyItemService = await myProfileDaoObject.ViewUserBuyBuyItemDao(request.body)
                    if (ViewUserBuyBuyItemService.error) {
                        response.error = true
                        response.statusCode = STRINGS.errorStatusCode
                        response.message = STRINGS.oopsErrorMessage
                        resolve(response)
                    } else {
                        response.error = false
                        response.statusCode = STRINGS.successStatusCode
                        response.message = STRINGS.SuccessString
                        response.data = ViewUserBuyBuyItemService.result
                        resolve(response)
                    }
                } catch (e) {
                    console.log(e)
                    response.error = true
                    response.statusCode = STRINGS.errorStatusCode
                    response.message = STRINGS.oopsErrorMessage
                    resolve(response)
                }
            })

        }


        this.EditUserBuyBuyItemService = async (request) => {
            const response = {}
            return new Promise(async function (resolve) {
                try {
                    var object = {}
                    // request.body.uid = '4c19d0cd-aa55-4751-a43a-efc9ef6e63c7'
                    var EditUserBuyBuyItemService = await myProfileDaoObject.EditUserBuyBuyItemDao(request.body)
                    if (EditUserBuyBuyItemService.error) {
                        response.error = true
                        response.statusCode = STRINGS.errorStatusCode
                        response.message = STRINGS.oopsErrorMessage
                        resolve(response)
                    } else {
                        response.error = false
                        response.statusCode = STRINGS.successStatusCode
                        response.message = STRINGS.SuccessString
                        response.data = EditUserBuyBuyItemService.result
                        resolve(response)
                    }
                } catch (e) {
                    console.log(e)
                    response.error = true
                    response.statusCode = STRINGS.errorStatusCode
                    response.message = STRINGS.oopsErrorMessage
                    resolve(response)
                }
            })

        }

        this.DeleteUserBuyBuyItemsService = async (request) => {
            const response = {}
            return new Promise(async function (resolve) {
                try {
                    var object = {}
                    // request.body.uid = '4c19d0cd-aa55-4751-a43a-efc9ef6e63c7'
                    var DeleteUserBuyBuyItemtDao = await myProfileDaoObject.DeleteUserBuyBuyItemDao(request.body)
                    if (DeleteUserBuyBuyItemtDao.error) {
                        response.error = true
                        response.statusCode = STRINGS.errorStatusCode
                        response.message = STRINGS.oopsErrorMessage
                        resolve(response)
                    } else {
                        response.error = false
                        response.statusCode = STRINGS.successStatusCode
                        response.message = STRINGS.SuccessString
                        response.data = DeleteUserBuyBuyItemtDao.result
                        resolve(response)
                    }
                } catch (e) {
                    console.log(e)
                    response.error = true
                    response.statusCode = STRINGS.errorStatusCode
                    response.message = STRINGS.oopsErrorMessage
                    resolve(response)
                }
            })

        }


        this.getUsersListService = async (request) => {
            var response = {}
            return new Promise(async function (resolve) {
                try {
                    var object = {}
                    request.body.pageNumber = request.body.pageNumber.length == 0 ? 0 : request.body.pageNumber
                    pageNumber = request.body.pageNumber
                    // console.log(pageNumber);
                    // request.body.uid = 'pm4KO6oFYQO4Hj7xlRla9BfO6Zn2'

                    var GetTotalUserListCountDao = await myProfileDaoObject.GetTotalUserListCountDao(request.body)
                    // console.log("getTotaltPinoyPreneursListCountDao",getTotaltPinoyPreneursListCountDao);

                    if (GetTotalUserListCountDao.error) {
                        response.error = true
                        response.statusCode = STRINGS.errorStatusCode
                        response.message = STRINGS.commanErrorString
                        resolve(response)
                    } else if (GetTotalUserListCountDao.result > 0) {
                        var lenght = GetTotalUserListCountDao.result
                        var paginationDetails = await this.getPaginationDetailsWithSize(lenght, pageNumber, 10)

                        var GetUserListDao = await myProfileDaoObject.GetUserListDao(request.body)
                        if (GetUserListDao.error) {
                            response.error = true
                            response.statusCode = STRINGS.errorStatusCode
                            response.message = STRINGS.commanErrorString
                            resolve(response)
                        } else {
                            response.error = false
                            response.statusCode = STRINGS.successStatusCode
                            response.message = STRINGS.SuccessString
                            response.totalPages = paginationDetails.totalPages
                            response.data = GetUserListDao.result
                            resolve(response)
                        }
                    } else {
                        response.error = false
                        response.statusCode = STRINGS.successStatusCode
                        response.message = STRINGS.SuccessString
                        response.totalPages = 0
                        response.data = []
                        resolve(response)
                    }
                } catch (e) {
                    console.log(e)
                    response.error = true
                    response.statusCode = STRINGS.errorStatusCode
                    response.message = STRINGS.oopsErrorMessage
                    resolve(response)
                }

            })

        }



        this.userConnectRequestService = async (request) => {
            const response = {}
            return new Promise(async function (resolve) {
                try {
                    var object = {}
                    object.uid = request.body.uid
                    object.ConnectionUser_uid = request.body.ConnectionUser_uid

                    var getOneConnectionProfile = await myProfileDaoObject.getOneConnectionProfile(request.body)
                    // console.log(getOneConnectionProfile)
                    if (getOneConnectionProfile.error) {
                        response.error = true
                        response.statusCode = STRINGS.errorStatusCode
                        response.message = STRINGS.oopsErrorMessage
                        resolve(response)
                    } else if (getOneConnectionProfile.result.length > 0) {
                        var checkUserConnectionDao = await myProfileDaoObject.checkUserConnectionDao1(request.body)
                        // console.log(getOneConnectionProfile)
                        if (checkUserConnectionDao.error) {
                            response.error = true
                            response.statusCode = STRINGS.errorStatusCode
                            response.message = STRINGS.oopsErrorMessage
                            resolve(response)
                        } else if (checkUserConnectionDao.result.length > 0) {
                            console.log("already Connected")
                            response.error = false
                            response.statusCode = STRINGS.successStatusCode
                            response.message = STRINGS.SuccessString
                            return resolve(response)
                        } else {
                            object.ConnectionUser_full_name = getOneConnectionProfile.result[0].full_name
                            object.ConnectionUser_profile_photo = getOneConnectionProfile.result[0].profile_photo
                            object.is_active = 1
                            var userConnectRequestDao = await myProfileDaoObject.userConnectRequestDao(object)
                            // console.log("userConnectRequestDao", userConnectRequestDao)
                            if (userConnectRequestDao.error) {
                                response.error = true
                                response.statusCode = STRINGS.errorStatusCode
                                response.message = STRINGS.oopsErrorMessage
                                resolve(response)
                            } else {

                                var getOneConnectionProfile1 = await myProfileDaoObject.getOneConnectionProfile1(request.body)
                                // console.log("userConnectRequestDao", userConnectRequestDao)
                                if (getOneConnectionProfile1.error) {
                                    response.error = true
                                    response.statusCode = STRINGS.errorStatusCode
                                    response.message = STRINGS.oopsErrorMessage
                                    resolve(response)
                                } else {
                                    var user_name = getOneConnectionProfile1.result[0].full_name
                                    var user_profile = getOneConnectionProfile1.result[0].profile_photo

                                    var obj = {};
                                    obj.uid = request.body.ConnectionUser_uid
                                    obj.post_id = userConnectRequestDao.data._id
                                    obj.post_type = "connection"
                                    obj.user_name = user_name
                                    obj.post_module="user"
                                    obj.user_profile = user_profile
                                    obj.notification_message = `have connected with you`
                                    obj.is_active = 1
                                    var addUserConnectNotificationDao = await myProfileDaoObject.addUserConnectNotificationDao(obj)
                                    if (addUserConnectNotificationDao.error) {
                                        response.error = true
                                        response.statusCode = STRINGS.errorStatusCode
                                        response.message = STRINGS.oopsErrorMessage
                                        resolve(response)
                                    } else {

                                        response.error = false
                                        response.statusCode = STRINGS.successStatusCode
                                        response.message = STRINGS.SuccessString
                                        // response.data = userConnectRequestDao.result
                                        resolve(response)
                                    }
                                }
                            }
                        }
                    } else {
                        response.error = true
                        response.statusCode = STRINGS.errorStatusCode
                        response.message = "User Not Exists"
                        resolve(response)
                    }
                } catch (e) {
                    console.log(e)
                    response.error = true
                    response.statusCode = STRINGS.errorStatusCode
                    response.message = STRINGS.oopsErrorMessage
                    resolve(response)
                }
            })

        }



        this.getUserConnectionService = async (request) => {
            var response = {}
            return new Promise(async function (resolve) {
                try {
                    var object = {}
                    request.body.pageNumber = request.body.pageNumber.length == 0 ? 0 : request.body.pageNumber
                    pageNumber = request.body.pageNumber
                    // console.log(pageNumber);
                    // request.body.uid = 'pm4KO6oFYQO4Hj7xlRla9BfO6Zn2'

                    var getTotalUserConnectionListDao = await myProfileDaoObject.getTotalUserConnectionListDao(request.body)
                    // console.log("getTotaltPinoyPreneursListCountDao",getTotaltPinoyPreneursListCountDao);

                    if (getTotalUserConnectionListDao.error) {
                        response.error = true
                        response.statusCode = STRINGS.errorStatusCode
                        response.message = STRINGS.commanErrorString
                        resolve(response)
                    } else if (getTotalUserConnectionListDao.result > 0) {
                        var lenght = getTotalUserConnectionListDao.result
                        var paginationDetails = await this.getPaginationDetailsWithSize(lenght, pageNumber, 10)

                        var getUserConnectionListDao = await myProfileDaoObject.getUserConnectionListDao(request.body)
                        if (getUserConnectionListDao.error) {
                            response.error = true
                            response.statusCode = STRINGS.errorStatusCode
                            response.message = STRINGS.commanErrorString
                            resolve(response)
                        } else {
                            response.error = false
                            response.statusCode = STRINGS.successStatusCode
                            response.message = STRINGS.SuccessString
                            response.totalPages = paginationDetails.totalPages
                            response.data = getUserConnectionListDao.result
                            resolve(response)
                        }
                    } else {
                        response.error = false
                        response.statusCode = STRINGS.successStatusCode
                        response.message = STRINGS.SuccessString
                        response.totalPages = 0
                        response.data = []
                        resolve(response)
                    }
                } catch (e) {
                    console.log(e)
                    response.error = true
                    response.statusCode = STRINGS.errorStatusCode
                    response.message = STRINGS.oopsErrorMessage
                    resolve(response)
                }

            })

        }


        this.userDisconnectRequestService = async (request) => {
            const response = {}
            return new Promise(async function (resolve) {
                try {
                    var object = {}
                    object.uid = request.body.uid
                    object.ConnectionUser_uid = request.body.ConnectionUser_uid

                    var getOneConnectionProfile = await myProfileDaoObject.getOneConnectionProfile(request.body)
                    // console.log(getOneConnectionProfile)
                    if (getOneConnectionProfile.error) {
                        response.error = true
                        response.statusCode = STRINGS.errorStatusCode
                        response.message = STRINGS.oopsErrorMessage
                        resolve(response)
                    } else if (getOneConnectionProfile.result.length > 0) {


                        var userDisconnectConnectDao = await myProfileDaoObject.userDisconnectConnectDao(object)
                        if (userDisconnectConnectDao.error) {
                            response.error = true
                            response.statusCode = STRINGS.errorStatusCode
                            response.message = STRINGS.oopsErrorMessage
                            resolve(response)
                        } else {
                            response.error = false
                            response.statusCode = STRINGS.successStatusCode
                            response.message = STRINGS.SuccessString
                            // response.data = userConnectRequestDao.result
                            resolve(response)
                        }

                    } else {
                        response.error = true
                        response.statusCode = STRINGS.errorStatusCode
                        response.message = "User Not Exists"
                        resolve(response)
                    }
                } catch (e) {
                    console.log(e)
                    response.error = true
                    response.statusCode = STRINGS.errorStatusCode
                    response.message = STRINGS.oopsErrorMessage
                    resolve(response)
                }
            })

        }









    }