module.exports = function () {
    var RatingDao = require('../../dao/web/RatingDao')

    const STRINGS = require('../../strings.json')
    // const common= require('../../utils/common')
    require('../../utils/common')()


    require('dotenv').config()
    var RatingDaoObject = new RatingDao()
    // var commonObject = new common()

    this.addRatingService = async (request) => {
        const response = {}
        return new Promise(async function (resolve) {
            try {
                // request.body.uid = 'JLACxJhmGjVXkhX1jtnXJxI2tht2'
                var getOneUserDao = await RatingDaoObject.getOneUserDao(request.body)
                // console.log("getOneUserDao", getOneUserDao)
                if (getOneUserDao.error) {
                    response.error = true
                    response.statusCode = STRINGS.errorStatusCode
                    response.message = STRINGS.oopsErrorMessage
                    resolve(response)
                } else if (getOneUserDao.data) {

                    if (request.body.post_type == 'pinoy_preneurs') {
                        var object = {
                            uid: request.body.uid,
                            rating_id: request.body.rating_id,
                            post_type: request.body.post_type,
                            rating: request.body.rating,
                            is_active: 1
                        }
                        var getOnePostDao = await RatingDaoObject.getOnePostDao(object)
                        // console.log("getOnePostDao", getOnePostDao)

                        if (getOnePostDao.error) {
                            response.error = true
                            response.statusCode = STRINGS.errorStatusCode
                            response.message = STRINGS.oopsErrorMessage
                            resolve(response)
                        }
                        if (getOnePostDao.data) {
                            var addRatingDao = await RatingDaoObject.updateRatingDao(object)
                        } else {
                            var addRatingDao = await RatingDaoObject.addRatingDao(object)
                        }

                        // console.log("getRatingListDao", addRatingDao)
                        if (addRatingDao.error) {
                            response.error = true
                            response.statusCode = STRINGS.errorStatusCode
                            response.message = STRINGS.oopsErrorMessage
                            resolve(response)
                        } else {
                            var getRatingListDao = await RatingDaoObject.getRatingListDao(object)
                            // console.log("getRatingListDao", getRatingListDao)

                            var total = 0;
                            var count = 0;
                            getRatingListDao.data.forEach((val, ind) => {
                                var value = parseFloat(val.rating)
                                // console.log("value", val)
                                total += value;
                                count++;
                            });

                            var avgRating = total / count;
                            avgRating = avgRating.toPrecision(2)
                            // console.log("avgRating", avgRating)
                            var updatePinoyPreneurRatingDao = await RatingDaoObject.updatePinoyPreneurRatingDao(object)
                            if (updatePinoyPreneurRatingDao.error) {
                                response.error = true
                                response.statusCode = STRINGS.errorStatusCode
                                response.message = STRINGS.oopsErrorMessage
                                resolve(response)
                            } else {
                                response.error = false
                                response.statusCode = STRINGS.successStatusCode
                                response.message = STRINGS.SuccessString
                                response.data = updatePinoyPreneurRatingDao.result

                                resolve(response)
                            }
                        }
                    }
                } else {
                    response.error = false
                    response.statusCode = STRINGS.successStatusCode
                    response.message = STRINGS.SuccessString
                    response.data = "user Not Found"
                    resolve(response)
                }
            } catch (e) {
                console.log(e)
                response.error = true
                response.statusCode = STRINGS.errorStatusCode
                response.message = STRINGS.oopsErrorMessage
                resolve(response)
            }
        })
    }












}