module.exports = function () {
    const tambayanDao = require('../../dao/web/TambayanDao')
    const profiledao = require('../../dao/web/MyProfileDao')

    const STRINGS = require('../../strings.json')
    require('dotenv').config()
    const tambayanDaoObject = new tambayanDao()
    const profileDaoObject = new profiledao()

    const likesDao = require('../../dao/web/LikesDao')
    const likesObject = new likesDao()

    this.tambayanPostService = async (request) => {
        const response = {}
        return new Promise(async function (resolve) {
            try {
                var object = {}
                request.body.user_id = request.body.uid
                var getOneProfileDao = await profileDaoObject.getOneProfileDao(request.body)
                // console.log("getOneProfileDao",getOneProfileDao)
                if (getOneProfileDao.error) {
                    response.error = true
                    response.statusCode = STRINGS.errorStatusCode
                    response.message = STRINGS.commanErrorString
                    resolve(response)
                } else {
                    if (getOneProfileDao.data == null) {
                        response.error = true
                        response.statusCode = STRINGS.errorStatusCode
                        response.message = "User Not Found"
                        resolve(response)
                    } else if (getOneProfileDao.data.length !== 0) {
                        object.profile_photo = getOneProfileDao.data.profile_photo
                        object.full_name = getOneProfileDao.data.full_name
                    }

                    object.is_active = 1
                    // console.log("fetch2tambayan",request.body)
                    var persist = Object.assign(request.body, object)
                    // console.log("fetch3tambayan",persist)

                    var tambayanPost = await tambayanDaoObject.tambayanPostDao(persist)
                    if (tambayanDaoObject.error) {
                        response.error = true
                        response.statusCode = STRINGS.errorStatusCode
                        response.message = STRINGS.oopsErrorMessage
                        resolve(response)
                    } else {
                        response.error = false
                        response.statusCode = STRINGS.successStatusCode
                        response.message = STRINGS.SuccessString
                        response.data = tambayanPost.data

                        resolve(response)
                    }
                }
            } catch (e) {
                console.log(e)
                response.error = true
                response.statusCode = STRINGS.errorStatusCode
                response.message = STRINGS.oopsErrorMessage
                resolve(response)
            }
        })
    }

    this.tambayanListService = async (request) => {
        const response = {}
        return new Promise(async function (resolve) {
            try {
                var object = {}
                request.body.pageNumber = request.body.pageNumber.length == 0 ? 0 : request.body.pageNumber
                pageNumber = request.body.pageNumber
                var getTotaltambayanListCountDao = await tambayanDaoObject.getTotaltambayanListCountDao(request.body)

                if (getTotaltambayanListCountDao.error) {
                    response.error = true
                    response.statusCode = STRINGS.errorStatusCode
                    response.message = STRINGS.commanErrorString
                    resolve(response)
                } else {
                    var lenght = getTotaltambayanListCountDao.data
                    var paginationDetails = await this.getPaginationDetailsWithSize(lenght, pageNumber, 10)

                    var gettambayanListDao = await tambayanDaoObject.gettambayanListDao(request.body)

                    //
                    var iteraration = gettambayanListDao.data.length
                    var datas = gettambayanListDao.data
                    var arr = []
                    var storeall = {}
                    console.log("logging", datas, iteraration)
                    var uid = request.body.uid
                    for (var i = 0; i < iteraration; i++) {
                        // console.log("loop beginning",datas[i])

                        var convert = (datas[i]._id).toString()
                        var obj = {}
                        obj.post_id = convert
                        obj.uid = uid
                        //console.log("input for likedbydao",obj)
                        var searchinlike = await likesObject.forlikedbyList(obj)
                        var a = searchinlike.data

                        var updatecount = Object.keys(a).length
                        console.log("searchinlike", searchinlike)
                        var viewPostDao = await tambayanDaoObject.viewPostDao(obj)

                        console.log("consolw", viewPostDao.data[0])

                        let p2 = Object.assign({}, viewPostDao.data[0]._doc);
                        if (updatecount >= 1) {
                            p2.likedBy = "1"
                            arr.push(p2)

                            console.log("true", p2)
                        } else {
                            //var status={}
                            p2.likedBy = "0"


                            arr.push(p2)
                            console.log("false", p2)
                        }
                    }
                    if (tambayanDaoObject.error) {
                        response.error = true
                        response.statusCode = STRINGS.errorStatusCode
                        response.message = STRINGS.oopsErrorMessage
                        resolve(response)
                    } else {
                        response.error = false
                        response.statusCode = STRINGS.successStatusCode
                        response.message = STRINGS.SuccessString
                        response.totalPages = paginationDetails.totalPages
                        response.data = arr
                        resolve(response)
                    }
                }
            } catch (e) {
                console.log(e)
                response.error = true
                response.statusCode = STRINGS.errorStatusCode
                response.message = STRINGS.oopsErrorMessage
                resolve(response)
            }
        })
    }



    this.viewPostService = async (request) => {
        const response = {}
        return new Promise(async function (resolve) {
            try {
                var object = {}
                //const uid="4c19d0cd-aa55-4751-a43a-efc9ef6e63c7"
                var tambayanPost = await tambayanDaoObject.viewPostDao(request.body)
                if (tambayanDaoObject.error) {
                    response.error = true
                    response.statusCode = STRINGS.errorStatusCode
                    response.message = STRINGS.oopsErrorMessage
                    resolve(response)
                } else {

                    var convert = (tambayanPost.data[0]._id).toString()


                    var obj = {}
                    obj.post_id = convert
                    obj.uid = request.body.uid
                    var searchinlike = await likesObject.forlikedbyList(obj)
                    if (searchinlike.error) {
                        response.error = true
                        response.statusCode = STRINGS.errorStatusCode
                        response.message = STRINGS.commanErrorString
                        resolve(response)
                    } else {


                        var likedByKeyResponse = Object.assign({}, tambayanPost.data[0]._doc);


                        var a = searchinlike.data


                        var updatecount = Object.keys(a).length


                        if (updatecount >= 1) {
                            likedByKeyResponse.likedBy = "1"
                        } else {
                            likedByKeyResponse.likedBy = "0"
                        }
                    }
                    response.error = false
                    response.statusCode = STRINGS.successStatusCode
                    response.message = STRINGS.SuccessString
                    response.data = likedByKeyResponse

                    resolve(response)
                }
            } catch (e) {
                console.log(e)
                response.error = true
                response.statusCode = STRINGS.errorStatusCode
                response.message = STRINGS.oopsErrorMessage
                resolve(response)
            }
        })
    }

    this.editOneTambayanPostService = async (request) => {
        const response = {}
        return new Promise(async function (resolve) {
            try {
                var object = {}
                //const uid="4c19d0cd-aa55-4751-a43a-efc9ef6e63c7"
                var editOnePostDao = await tambayanDaoObject.editOnePostDao(request.body)
                if (editOnePostDao.error) {
                    response.error = true
                    response.statusCode = STRINGS.errorStatusCode
                    response.message = STRINGS.oopsErrorMessage
                    resolve(response)
                } else {

                    response.error = false
                    response.statusCode = STRINGS.successStatusCode
                    response.message = STRINGS.SuccessString
                    response.data = editOnePostDao
                    resolve(response)
                }
            } catch (e) {
                console.log(e)
                response.error = true
                response.statusCode = STRINGS.errorStatusCode
                response.message = STRINGS.oopsErrorMessage
                resolve(response)
            }
        })
    }




    this.deleteOneTambayanService = async (request) => {
        const response = {}
        return new Promise(async function (resolve) {
            try {
                var object = {}
                //const uid="4c19d0cd-aa55-4751-a43a-efc9ef6e63c7"
                var deleteOneTambayanDao = await tambayanDaoObject.deleteOneTambayanDao(request.body)
                if (deleteOneTambayanDao.error) {
                    response.error = true
                    response.statusCode = STRINGS.errorStatusCode
                    response.message = STRINGS.oopsErrorMessage
                    resolve(response)
                } else {

                    response.error = false
                    response.statusCode = STRINGS.successStatusCode
                    response.message = STRINGS.SuccessString
                    response.data = deleteOneTambayanDao
                    resolve(response)
                }
            } catch (e) {
                console.log(e)
                response.error = true
                response.statusCode = STRINGS.errorStatusCode
                response.message = STRINGS.oopsErrorMessage
                resolve(response)
            }
        })
    }

}